{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit LInputfrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,DB,
  StdCtrls, Buttons, ComCtrls, Grids, CheckLst, ExtCtrls;

type
  TSearchForm = class(TForm)
    CloseBtn: TButton;
    ZoomToBtn: TButton;
    LayerComboBox: TComboBox;
    FieldComboBox: TComboBox;
    HighlightBtn: TButton;
    PageControl1: TPageControl;
    SpatialTS: TTabSheet;
    TextTS: TTabSheet;
    FieldTS: TTabSheet;
    TextEdit: TEdit;
    FieldCB: TComboBox;
    TextFindBtn: TButton;
    FieldListBox: TListBox;
    ValueLabel: TLabel;
    FieldFindBtn: TButton;
    Label2: TLabel;
    HelpBtn: TButton;
    SpatialFindBtn: TButton;
    Label3: TLabel;
    SpatialGeoCB: TComboBox;
    SpatialUnitCB: TComboBox;
    SpatialLayFieldsCLB: TCheckListBox;
    ResultsSG: TStringGrid;
    FoundPanel: TPanel;
    ProgressBar1: TProgressBar;
    SpatialEdit: TEdit;
    IDBtn: TButton;
    TextLabel: TLabel;
    FieldListBoxIn: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
procedure Founded(Founded:Integer);
    procedure CloseBtnClick(Sender: TObject);

procedure Init;
    procedure LayerComboBoxChange(Sender: TObject);
procedure FieldsComboUpdate;
    procedure FieldComboBoxChange(Sender: TObject);

procedure SetUpResultsSG;

    procedure TextFindBtnClick(Sender: TObject);
    procedure FieldFindBtnClick(Sender: TObject);
    procedure FieldCBChange(Sender: TObject);
    procedure SpatialFindBtnClick(Sender: TObject);

    procedure ZoomToBtnClick(Sender: TObject);
    procedure HighlightBtnClick(Sender: TObject);
    procedure IDBtnClick(Sender: TObject);
procedure SetAllShapes;
  private
{    fLayerName : string;}
  public
    { Public declarations }
  end;

var
  SearchForm: TSearchForm;
  SearchValuesSet:Boolean;
  axeXMin,axeYMin,axeXMax,axeYMax:Double;

implementation

uses AllShapeLoaderFrm, LoGlobals, LoeditFrm,
     Lidentifyfrm, LOResMess;
{$R *.DFM}

procedure TSearchForm.FormCreate(Sender: TObject);
begin
  top := InputfrmY;
  left := InputfrmX;
end;

procedure TSearchForm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
  InputfrmY := SearchForm.top;
  InputfrmX := SearchForm.left;
end;

procedure TSearchForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(11000); {11000}
  {
Choose field from main map.
Select your criteria.

Valid criteria are SQL expressions that constitute
'where' clauses using field names and Sample Values.
Examples:
MUID = MA123
state_name = 'Maine'
  }
end;


procedure TSearchForm.Founded(Founded:Integer);
begin
  ProgressBar1.Position:=0;
  ProgressBar1.Visible:=False;
  FoundPanel.Caption:='Found '+Inttostr(Founded);
end;

procedure TSearchForm.CloseBtnClick(Sender: TObject);
begin  {close it: modal keeps it on top}
  modalResult := mrOK;
end;
(***********************************************************)
procedure TSearchForm.Init;
var I:Integer;
begin
SearchValuesSet:=False;
ProgressBar1.Position:=0;
ProgressBar1.Visible:=False;
Founded(0);
{SpatialLayFieldsCLB.Items  Layers}
{LayerComboBox
FieldComboBox}
  LayerComboBox.Items.Clear;
  if LayersLoaded = 0 then
  begin
    FieldComboBox.Items.Clear;
    exit;
  end;

  for i := 1 to LayersLoaded  do
  begin
    LayerComboBox.Items.Add(LayA[i].Filename);
  end;
  LayerComboBox.ItemIndex :=0;
  FieldsComboUpdate;

  for i := 1 to LayersLoaded  do
  begin
    SpatialLayFieldsCLB.Items.Add(LayA[i].Filename);
  end;
end;

procedure TSearchForm.LayerComboBoxChange(Sender: TObject);
begin
  if LayersLoaded > 0 then
  begin
  CurrentLayer:= LayerComboBox.ItemIndex+1;
  {  ShapeFileTypeRG(LayA[CurrentLayer].ShpType); }
  FieldsComboUpdate;{(LayerComboBox.Items[LayerComboBox.ItemIndex]);}
  SearchValuesSet:=False;
  end;
end;

procedure TSearchForm.FieldsComboUpdate;
var
  i: integer;
begin
  FieldComboBox.Items.Clear;
  for i := 0 to LayA[CurrentLayer].AttributesN-1  do
  begin
    FieldComboBox.Items.Add(LayA[CurrentLayer].AttType[i].Displayname);
  end;
  FieldComboBox.ItemIndex := 0;
end;
procedure TSearchForm.FieldComboBoxChange(Sender: TObject);
begin
  if LayersLoaded > 0 then
  begin
  CurrentField:= FieldComboBox.ItemIndex;{0 indexed}
  end;
  {Fill the FieldListBox values}
  SearchValuesSet:=False;
end;

(***********************************************************)

procedure TSearchForm.SetUpResultsSG;
var
 {ishape,}Ii,i: Integer;
{ ValueString,DataString: string;}
begin
  with ResultsSG do
  begin
      Cells[0,0] := 'Attribute';
      Cells[0,1] := 'Value';
    For I:= 1 to ShapesFound do
     for Ii := 0 to ColCount - 1 do
        begin
          Cells[Ii,0] := LayA[CurrentLayer].AttType[CurrentField].Displayname;
          Cells[Ii,1] := LayA[CurrentLayer].LyrShp[I].AAttributes[CurrentField];
        end;
  End;
End;
(***********************************************************)

(***********************************************************)
procedure TSearchForm.TextFindBtnClick(Sender: TObject);
var
 ishape,i: Integer;
 ValueString,DataString: string;
 aXMin,aYMin,aXMax,aYMax:Double;
begin
  {FieldComboBox.ItemIndex   CurrentLayer
  LayerComboBox.ItemIndex    CurrentField}
  axeXMin:=1.6E308;
  axeYMin:=1.6E308;
  axeXMax:=-4.9E324;
  axeYMax:=-4.9E324;
  ishape:= LayA[CurrentLayer].ShapeN;
  ValueString := TextEdit.Text;
  ShapesFound:=0;
  SetLength(ShapesFoundArray , ShapesFound);
  ProgressBar1.Position:=0;
  ProgressBar1.Visible:=True;
  TextLabel.Caption:=
  'in selected '
  + LayA[CurrentLayer].Filename
  + LayA[CurrentLayer].AttType[CurrentField].Displayname
  +' Attributes';
  For I:= 1 to LayA[CurrentLayer].ShapeN do
  begin
      ProgressBar1.Position:= Round((I / ishape) * 100);
      Application.ProcessMessages;
      DataString :=LayA[CurrentLayer].LyrShp[I].AAttributes[CurrentField];
      {Pos(Substr: string; S: string)}
      If Pos(ValueString,DataString)>0then
      begin
          Inc(ShapesFound);
          SetLength(ShapesFoundArray , ShapesFound+1);
          ShapesFoundArray[ShapesFound,1] := CurrentLayer;
          ShapesFoundArray[ShapesFound,2] := I;
    {Boundary of THIS object}
    aXMin:=LayA[CurrentLayer].LyrShp[I].XMin;
    aYMin:=LayA[CurrentLayer].LyrShp[I].YMin;
    aXMax:=LayA[CurrentLayer].LyrShp[I].XMax;
    aYMax:=LayA[CurrentLayer].LyrShp[I].YMax;
          {Get Extents axe are large Min and small max}
      If aXMin < axeXMin then axeXMin := aXMin;
      If aYMin < axeYMin then axeYMin := aYMin;
      If aXMax > axeXMax then axeXMax := aXMax;
      If aYMax > axeYMax then axeYMax := aYMax;
      end;
  end;
  ProgressBar1.Position:=0;
  ProgressBar1.Visible:=False;
  Founded(ShapesFound);
  If (ShapesFound >0) then SetUpResultsSG;
end;
(***********************************************************)

(***********************************************************)
procedure TSearchForm.FieldCBChange(Sender: TObject);
var
 ishape,i: Integer;
 DataString: string;
begin
{Search through and find all values for the Layer Field
FieldListBoxIn}
  if ((not SearchValuesSet)) then
  begin
  ProgressBar1.Position:=0;
  ProgressBar1.Visible:=True;
    {prevent repaints until done }
    FieldListBoxIn.Items.BeginUpdate;
    FieldListBox.Items.BeginUpdate;
    { empty the list of any old values }
    FieldListBoxIn.Items.Clear;
    FieldListBox.Items.Clear;
    {Set list of fields from database}
    ishape:= LayA[CurrentLayer].ShapeN;
    For I:= 0 to LayA[CurrentLayer].ShapeN-1 do
    begin
      FieldListBoxIn.Items.Add(LayA[CurrentLayer].LyrShp[I+1].AAttributes[CurrentField]);
      ProgressBar1.Position:= Round((I / ishape) * 100);
      Application.ProcessMessages;
    end;
    FieldListBoxIn.Sorted := True;
      { make sure the fields are sorted }
    DataString := FieldListBoxIn.Items.Strings[0];
    FieldListBox.Items.Add(FieldListBoxIn.Items.Strings[0]);
     ishape:=FieldListBoxIn.Items.Count;
    for i := 1 to (FieldListBoxIn.Items.Count - 1) do
    begin
      ProgressBar1.Position:= Round((I / ishape) * 100);
       Application.ProcessMessages;
      {Fill list2 with items}
      if (DataString <> FieldListBoxIn.Items.Strings[i]) then
      begin
        DataString := FieldListBoxIn.Items.Strings[i];
        FieldListBox.Items.Add(FieldListBoxIn.Items.Strings[i]);
      end; {IF}
    end; {for}
    FieldListBoxIn.Items.Clear; {Done so empty it}
    {reenable painting }
    FieldListBoxIn.Items.EndUpdate;
    FieldListBox.Items.EndUpdate;
    SearchValuesSet := True;
  ProgressBar1.Position:=0;
  ProgressBar1.Visible:=False;
end;
end;


procedure TSearchForm.FieldFindBtnClick(Sender: TObject);
var
 Switch,ishape,i: Integer;
 ValueString,DataString: string;
 ValueDatum,Datum:Double;
 aXMin,aYMin,aXMax,aYMax:Double; 
begin
If (  (LayA[CurrentLayer].AttType[CurrentField].DataType=ftSmallint)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftInteger)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftWord)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftLargeint)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftFloat)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftCurrency)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftDateTime))
then
begin
  {FieldComboBox.ItemIndex   CurrentLayer
  LayerComboBox.ItemIndex    CurrentField}
  axeXMin:=1.6E308;
  axeYMin:=1.6E308;
  axeXMax:=-4.9E324;
  axeYMax:=-4.9E324;

  ValueString := FieldListBox.Items.Strings[FieldListBox.ItemIndex];
ValueLabel.Caption:='Selected Value: '+ValueString;
{showmessage('1');}
If (  (LayA[CurrentLayer].AttType[CurrentField].DataType=ftSmallint)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftInteger)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftWord)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftLargeint))
then  ValueDatum:= StrToInt(ValueString)
else
If ((LayA[CurrentLayer].AttType[CurrentField].DataType=ftFloat)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftCurrency)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftDateTime))
then  ValueDatum:= StrToFloat(ValueString)
else ValueDatum:=0;

{showmessage('Value '+Floattostr(ValueDatum));}
  ShapesFound:=0;
  Switch:= FieldCB.Itemindex;
  SetLength(ShapesFoundArray , ShapesFound);
  ProgressBar1.Position:=0;
  ProgressBar1.Visible:=True;
  ishape:= LayA[CurrentLayer].ShapeN;
  For I:= 1 to LayA[CurrentLayer].ShapeN do
  begin
    ProgressBar1.Position:= Round((I / ishape) * 100);
    Application.ProcessMessages;
    DataString :=LayA[CurrentLayer].LyrShp[I].AAttributes[CurrentField];
If (  (LayA[CurrentLayer].AttType[CurrentField].DataType=ftSmallint)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftInteger)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftWord)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftLargeint))
then  Datum:= StrToInt(DataString)
else
If ((LayA[CurrentLayer].AttType[CurrentField].DataType=ftFloat)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftCurrency)
or(LayA[CurrentLayer].AttType[CurrentField].DataType=ftDateTime))
then  Datum:= StrToFloat(DataString)
else Datum:=0;
    Case Switch of
    0:
    Begin
      If (Datum<ValueDatum)then
      begin
          Inc(ShapesFound);
          SetLength(ShapesFoundArray , ShapesFound+1);
          ShapesFoundArray[ShapesFound,1] := CurrentLayer;
          ShapesFoundArray[ShapesFound,2] := I;
    {Boundary of THIS object}
    aXMin:=LayA[CurrentLayer].LyrShp[I].XMin;
    aYMin:=LayA[CurrentLayer].LyrShp[I].YMin;
    aXMax:=LayA[CurrentLayer].LyrShp[I].XMax;
    aYMax:=LayA[CurrentLayer].LyrShp[I].YMax;
          {Get Extents axe are large Min and small max}
      If aXMin < axeXMin then axeXMin := aXMin;
      If aYMin < axeYMin then axeYMin := aYMin;
      If aXMax > axeXMax then axeXMax := aXMax;
      If aYMax > axeYMax then axeYMax := aYMax;
      end;
    end;
    1:
    Begin
      If (Datum=ValueDatum)then
      begin
          Inc(ShapesFound);
          SetLength(ShapesFoundArray , ShapesFound+1);
          ShapesFoundArray[ShapesFound,1] := CurrentLayer;
          ShapesFoundArray[ShapesFound,2] := I;
    {Boundary of THIS object}
    aXMin:=LayA[CurrentLayer].LyrShp[I].XMin;
    aYMin:=LayA[CurrentLayer].LyrShp[I].YMin;
    aXMax:=LayA[CurrentLayer].LyrShp[I].XMax;
    aYMax:=LayA[CurrentLayer].LyrShp[I].YMax;
          {Get Extents axe are large Min and small max}
      If aXMin < axeXMin then axeXMin := aXMin;
      If aYMin < axeYMin then axeYMin := aYMin;
      If aXMax > axeXMax then axeXMax := aXMax;
      If aYMax > axeYMax then axeYMax := aYMax;
      end;
    end;
    2:
    Begin
      If (Datum>ValueDatum)then
      begin
          Inc(ShapesFound);
          SetLength(ShapesFoundArray , ShapesFound+1);
          ShapesFoundArray[ShapesFound,1] := CurrentLayer;
          ShapesFoundArray[ShapesFound,2] := I;
    {Boundary of THIS object}
    aXMin:=LayA[CurrentLayer].LyrShp[I].XMin;
    aYMin:=LayA[CurrentLayer].LyrShp[I].YMin;
    aXMax:=LayA[CurrentLayer].LyrShp[I].XMax;
    aYMax:=LayA[CurrentLayer].LyrShp[I].YMax;
          {Get Extents axe are large Min and small max}
      If aXMin < axeXMin then axeXMin := aXMin;
      If aYMin < axeYMin then axeYMin := aYMin;
      If aXMax > axeXMax then axeXMax := aXMax;
      If aYMax > axeYMax then axeYMax := aYMax;
      end;
    end;
    3:
    Begin
      If (Datum>=ValueDatum)then
      begin
          Inc(ShapesFound);
          SetLength(ShapesFoundArray , ShapesFound+1);
          ShapesFoundArray[ShapesFound,1] := CurrentLayer;
          ShapesFoundArray[ShapesFound,2] := I;
    {Boundary of THIS object}
    aXMin:=LayA[CurrentLayer].LyrShp[I].XMin;
    aYMin:=LayA[CurrentLayer].LyrShp[I].YMin;
    aXMax:=LayA[CurrentLayer].LyrShp[I].XMax;
    aYMax:=LayA[CurrentLayer].LyrShp[I].YMax;
          {Get Extents axe are large Min and small max}
      If aXMin < axeXMin then axeXMin := aXMin;
      If aYMin < axeYMin then axeYMin := aYMin;
      If aXMax > axeXMax then axeXMax := aXMax;
      If aYMax > axeYMax then axeYMax := aYMax;
      end;
    end;
    4:
    Begin
      If (Datum<>ValueDatum)then
      begin
          Inc(ShapesFound);
          SetLength(ShapesFoundArray , ShapesFound+1);
          ShapesFoundArray[ShapesFound,1] := CurrentLayer;
          ShapesFoundArray[ShapesFound,2] := I;
    {Boundary of THIS object}
    aXMin:=LayA[CurrentLayer].LyrShp[I].XMin;
    aYMin:=LayA[CurrentLayer].LyrShp[I].YMin;
    aXMax:=LayA[CurrentLayer].LyrShp[I].XMax;
    aYMax:=LayA[CurrentLayer].LyrShp[I].YMax;
          {Get Extents axe are large Min and small max}
      If aXMin < axeXMin then axeXMin := aXMin;
      If aYMin < axeYMin then axeYMin := aYMin;
      If aXMax > axeXMax then axeXMax := aXMax;
      If aYMax > axeYMax then axeYMax := aYMax;
      end;
    end;
    5:
    Begin
      If (Datum<=ValueDatum)then
      begin
          Inc(ShapesFound);
          SetLength(ShapesFoundArray , ShapesFound+1);
          ShapesFoundArray[ShapesFound,1] := CurrentLayer;
          ShapesFoundArray[ShapesFound,2] := I;
    {Boundary of THIS object}
    aXMin:=LayA[CurrentLayer].LyrShp[I].XMin;
    aYMin:=LayA[CurrentLayer].LyrShp[I].YMin;
    aXMax:=LayA[CurrentLayer].LyrShp[I].XMax;
    aYMax:=LayA[CurrentLayer].LyrShp[I].YMax;
          {Get Extents axe are large Min and small max}
      If aXMin < axeXMin then axeXMin := aXMin;
      If aYMin < axeYMin then axeYMin := aYMin;
      If aXMax > axeXMax then axeXMax := aXMax;
      If aYMax > axeYMax then axeYMax := aYMax;
      end;
    end;
    6:
    Begin
      If (Datum= {like}ValueDatum)then
      begin
          Inc(ShapesFound);
          SetLength(ShapesFoundArray , ShapesFound+1);
          ShapesFoundArray[ShapesFound,1] := CurrentLayer;
          ShapesFoundArray[ShapesFound,2] := I;
    {Boundary of THIS object}
    aXMin:=LayA[CurrentLayer].LyrShp[I].XMin;
    aYMin:=LayA[CurrentLayer].LyrShp[I].YMin;
    aXMax:=LayA[CurrentLayer].LyrShp[I].XMax;
    aYMax:=LayA[CurrentLayer].LyrShp[I].YMax;
          {Get Extents axe are large Min and small max}
      If aXMin < axeXMin then axeXMin := aXMin;
      If aYMin < axeYMin then axeYMin := aYMin;
      If aXMax > axeXMax then axeXMax := aXMax;
      If aYMax > axeYMax then axeYMax := aYMax;
      end;
    end;
   end;{case}
  end;
  ProgressBar1.Position:=0;
  ProgressBar1.Visible:=False;
  Founded(ShapesFound);
showmessage(inttostr(ShapesFound));
  If (ShapesFound >0) then SetUpResultsSG;
end else DoRezInfo(4);
end;
(***********************************************************)


(***********************************************************)
procedure TSearchForm.SpatialFindBtnClick(Sender: TObject);
var
 Z,Distance,LayerDo, Switch,ashape,i: Integer;
 zXMin,zYMin,zXMax,zYMax,
 aXMin,aYMin,aXMax,aYMax:Double;
begin
  axeXMin:=1.6E308;
  axeYMin:=1.6E308;
  axeXMax:=-4.9E324;
  axeYMax:=-4.9E324;
  {FieldComboBox.ItemIndex   CurrentLayer
  LayerComboBox.ItemIndex    CurrentField}
  Switch:= SpatialGeoCB.Itemindex;
  Distance:=StrtoInt(SpatialEdit.Text);
{Convert Distance
  SpatialUnitCB Units Kilometers Meters Miles Feet}
  ShapesFound:=0;
  SetLength(ShapesFoundArray , ShapesFound);
  ProgressBar1.Position:=0;
  ProgressBar1.Visible:=True;
  ashape:=LayA[CurrentLayer].ShapeN;
  For I:= 1 to ashape  do
  begin {Search All Shapes in CurrentLayers-CurrentField}
    ProgressBar1.Position:= Round((I / ashape) * 100);
    Application.ProcessMessages;
    {Boundary of THIS object}
    aXMin:=LayA[CurrentLayer].LyrShp[I].XMin;
    aYMin:=LayA[CurrentLayer].LyrShp[I].YMin;
    aXMax:=LayA[CurrentLayer].LyrShp[I].XMax;
    aYMax:=LayA[CurrentLayer].LyrShp[I].YMax;
  For LayerDo:= 1 to LayersLoaded do
  If SpatialLayFieldsCLB.Selected[LayerDo] then
  BEGIN
  For Z:= 1 to LayA[LayerDo].ShapeN do
  begin
    {Boundary of Searched object}
    zXMin:=LayA[CurrentLayer].LyrShp[I].XMin;
    zYMin:=LayA[CurrentLayer].LyrShp[I].YMin;
    zXMax:=LayA[CurrentLayer].LyrShp[I].XMax;
    zYMax:=LayA[CurrentLayer].LyrShp[I].YMax;
   {SpatialGeoCB
    Within, Larger then, Smaller than,
    Surrounded by, Next to}
    Case Switch of
    0:
    Begin
      If   ((aXMin+Distance >= zXMin)and
            (aYMin+Distance >= zYMin))or
            ((aXMax-Distance <= zXMax)and
            (aYMax-Distance <= zYMax)) then
      begin
          Inc(ShapesFound);
          SetLength(ShapesFoundArray , ShapesFound+1);
          ShapesFoundArray[ShapesFound,1] := LayerDo;
          ShapesFoundArray[ShapesFound,2] := I;
          {Get Extents axe are large Min and small max}
      If aXMin < axeXMin then axeXMin := aXMin;
      If aYMin < axeYMin then axeYMin := aYMin;
      If aXMax > axeXMax then axeXMax := aXMax;
      If aYMax > axeYMax then axeYMax := aYMax;
      end;
    end;
    1: Begin
       End;
    end;{Case}
  end;{ For Z}
  end;{ For Layerdo}
  end;{ For I}
  ProgressBar1.Position:=0;
  ProgressBar1.Visible:=False;
  Founded(ShapesFound);
  If (ShapesFound >0) then SetUpResultsSG;
end;

procedure TSearchForm.ZoomToBtnClick(Sender: TObject);
begin
    {Search Extents and Display as Highlight Shape}
  If (ShapesFound >0) then
  begin
    {SetAllExtents;}
    MinOffX:= axeXMin;
    MinOffY:= axeYMin;
    MaxOffX:= axeXMax;
    MaxOffY:=  axeYMax;
    SetAllShapes;
    MapA[CurrentLayer].SymLayerSymboled:=5;
    VoEditForm.DVDORedraw;
  end;
end;

procedure TSearchForm.HighlightBtnClick(Sender: TObject);
begin
    {Display as Highlight Shape}
  If (ShapesFound >0) then
  begin
    SetAllShapes;
    MapA[CurrentLayer].SymLayerSymboled:=5;
    VoEditForm.DVDORedraw;
  end;
end;

procedure TSearchForm.IDBtnClick(Sender: TObject);
begin
  If (ShapesFound >0) then
  begin
    isShapeSelected:=True;
    IDForm.IDInit;
    IDForm.Show;
  end;
end;


procedure TSearchForm.SetAllShapes;
var i:Integer;
Begin
  For I:= 1 to ShapesFound  do
  begin
  If ShapesFoundArray[I,1]= CurrentLayer then
  begin
    MapA[CurrentLayer].LyrSym[ShapesFoundArray[I,2]].SymLineColor:=
       HighlightColor;
    MapA[CurrentLayer].LyrSym[ShapesFoundArray[I,2]].SymBrushColor:=
       HighlightColor;
  end;     
  end;
End;




end.
