{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit LLegend;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TLegendForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Label1: TLabel;
    TabSheet5: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    HintsPanel: TPanel;
    HelpBitBtn: TBitBtn;
    Label4: TLabel;
    ComboBox1: TComboBox;
    Button1: TButton;
    Button2: TButton;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Button3: TButton;
    Button4: TButton;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    TabSheet12: TTabSheet;
    Edit2: TEdit;
    Label19: TLabel;
    LegendTextRG: TRadioGroup;
    FontDialog1: TFontDialog;
    FontTextBtn: TSpeedButton;
    TabSheet6: TTabSheet;
    Label20: TLabel;
    Label22: TLabel;
    ScrollBox1: TScrollBox;
    LegendLegionBitmapsImage: TImage;
    GroupBox1: TGroupBox;
    FeatureBitmapCB: TCheckBox;
    ScaleCB: TCheckBox;
    LegendCB: TCheckBox;
    NorthArrowBCB: TCheckBox;
    GridCB: TCheckBox;
    MapLocationCB: TCheckBox;
    FeatureTextCB: TCheckBox;
    SourceProjectionCB: TCheckBox;
    AuthorBotmCB: TCheckBox;
    TitleSeriesBotmCB: TCheckBox;
    AuthorTopCB: TCheckBox;
    TitleSeriesTopCB: TCheckBox;
    Panel1: TPanel;
    LegendLegionBitmapsRG: TRadioGroup;
    LegendBitmapSizeLabel: TLabel;
    LegendLegionBitmapsLabel: TLabel;
    LoadBitmapsBtn: TSpeedButton;
    LoadTextBtn: TSpeedButton;
    SaveTextBtn: TSpeedButton;
    TabSheet2: TTabSheet;
    GridsRG: TRadioGroup;
    Label21: TLabel;
    Label23: TLabel;
    Label18: TLabel;
    Label24: TLabel;
    CountryCB: TComboBox;
    StateCB: TComboBox;
    Label10: TLabel;
    Label9: TLabel;
    Label8: TLabel;
    PNameLabel: TLabel;
    PPathLabel: TLabel;
    LegendMemo: TMemo;
    NorthArrowTCB: TCheckBox;
    ContourIntervalCB: TCheckBox;
    ValidateBtn: TButton;
    MapLocationRG: TRadioGroup;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    WhereEdit: TEdit;
    Label25: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);    
    procedure HelpBitBtnClick(Sender: TObject);

    procedure ValidateBtnClick(Sender: TObject);
procedure CheckMapLegendRec;

    procedure FontTextBtnClick(Sender: TObject);
    procedure LoadTextBtnClick(Sender: TObject);
    procedure SaveTextBtnClick(Sender: TObject);
    procedure LoadBitmapsBtnClick(Sender: TObject);

    procedure MapLocationRGClick(Sender: TObject);
    procedure GridsRGClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LegendForm: TLegendForm;

implementation

uses AllShapeLoaderFrm, LoGlobals, LMap;
{$R *.DFM}

procedure TLegendForm.FormCreate(Sender: TObject);
begin
  top := LegendFormY;
  left := LegendFormX;
{  LoadTextBtn.Enabled:=False;
  SaveTextBtn.Enabled:=False;
  LoadBitmapsBtn.Enabled:=False;
  SaveBitmapsBtn.Enabled:=False;}
end;

procedure TLegendForm.FormShow(Sender: TObject);
begin
  If    ((ProjectName = 'Nada')
    or (not FileExists(ProjectPath+ ProjectName))) then
    MapForm.SaveMapBtnClick(Sender);
  PNameLabel.Caption:= ProjectName;
  PPathLabel.Caption:= ProjectPath;
end;

procedure TLegendForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  LegendFormY := LegendForm.top;
  LegendFormX := LegendForm.left;
end;

procedure TLegendForm.HelpBitBtnClick(Sender: TObject);
begin
  Application.HelpContext(14000);
end;
(***********************************************************)

(***********************************************************)
procedure TLegendForm.ValidateBtnClick(Sender: TObject);
begin
  {Check Record for path names...}
  CheckMapLegendRec;
  MapForm.SaveMap(ProjectPath+ ProjectName);
end;
(***********************************************************)
procedure TLegendForm.CheckMapLegendRec;
Begin
If MapLegendRec.TitleTop[0]='.' then
TitleSeriesTopCB.Checked:=False else TitleSeriesTopCB.Checked:=True;
If MapLegendRec.AuthorTop[0]='.' then
AuthorTopCB.Checked:=False else AuthorTopCB.Checked:=True;
If MapLegendRec.TitleBottom[0]='.' then
TitleSeriesBotmCB.Checked:=False else TitleSeriesBotmCB.Checked:=True;
If MapLegendRec.AuthorBottom[0]='.' then
AuthorBotmCB.Checked:=False else AuthorBotmCB.Checked:=True;
If MapLegendRec.Source[0]='.' then
SourceProjectionCB.Checked:=False else SourceProjectionCB.Checked:=True;
If MapLegendRec.FeatureText[0]='.' then
FeatureTextCB.Checked:=False else FeatureTextCB.Checked:=True;
If MapLegendRec.NorthArrowText[0]='.' then
NorthArrowTCB.Checked:=False else NorthArrowTCB.Checked:=True;
If MapLegendRec.ContourInterval[0]='.' then
ContourIntervalCB.Checked:=False else ContourIntervalCB.Checked:=True;

MapLocationCB.Checked:=False;
If MapLegendRec.MapLocationName<>'' then
If FileExists(MapLegendRec.MapLocationName) then
  MapLocationCB.Checked:=True;

GridCB.Checked:=False;
If MapLegendRec.GridName<>'' then
If FileExists(MapLegendRec.GridName) then
 GridCB.Checked:=True;

NorthArrowBCB.Checked:=False;
If MapLegendRec.NorthArrowBitName<>'' then
If FileExists(MapLegendRec.NorthArrowBitName) then
NorthArrowBCB.Checked:=True;

LegendCB.Checked:=False;
If MapLegendRec.LegendName<>'' then
If FileExists(MapLegendRec.LegendName) then
LegendCB.Checked:=True;

ScaleCB.Checked:=False;
If MapLegendRec.ScalebarsName<>'' then
If FileExists(MapLegendRec.ScalebarsName) then
ScaleCB.Checked:=True;

FeatureBitmapCB.Checked:=False;
If MapLegendRec.FeatureBitmapName<>'' then
If FileExists(MapLegendRec.FeatureBitmapName) then
FeatureBitmapCB.Checked:=True;
End;
(***********************************************************)
procedure TLegendForm.FontTextBtnClick(Sender: TObject);
begin
  FontDialog1.Font:= LegendMemo.Font;
  If FontDialog1.Execute then
    LegendMemo.Font:= FontDialog1.Font;
end;

procedure TLegendForm.LoadTextBtnClick(Sender: TObject);
var I:Integer;
begin
  LegendMemo.Clear;
  Case LegendTextRG.Itemindex of
  0: {Title, series (top)}
  Begin
    LegendMemo.Font:=MapLegendRec.TitleTopFont;
    For I:=0 to MapLegendRec.TitleTopCount-1 do
    LegendMemo.Lines.Add(MapLegendRec.TitleTop[I]);
  End;
  1: {Author (top)}
  Begin
    LegendMemo.Font:=MapLegendRec.AuthorTopFont;
    For I:=0 to MapLegendRec.AuthorTopCount-1 do
    LegendMemo.Lines.Add(MapLegendRec.AuthorTop[I]);
  End;
  2: {Title, series (bottom)}
  Begin
    LegendMemo.Font:=MapLegendRec.TitleBottomFont;
    For I:=0 to MapLegendRec.TitleBottomCount-1 do
    LegendMemo.Lines.Add(MapLegendRec.TitleBottom[I]);
  End;
  3: {Author (bottom)}
  Begin
    LegendMemo.Font:=MapLegendRec.AuthorBottomFont;
    For I:=0 to MapLegendRec.AuthorBottomCount-1 do
    LegendMemo.Lines.Add(MapLegendRec.AuthorBottom[I]);
  End;
  4: {Source, projection, etc.}
  Begin
    LegendMemo.Font:=MapLegendRec.SourceFont;
    For I:=0 to MapLegendRec.SourceCount-1 do
    LegendMemo.Lines.Add(MapLegendRec.Source[I]);
  End;
  5: {Feature Text}
  Begin
    LegendMemo.Font:=MapLegendRec.FeatureTextFont;
    For I:=0 to MapLegendRec.FeatureTextCount-1 do
    LegendMemo.Lines.Add(MapLegendRec.FeatureText[I]);
  End;
  6: {North Arrow}
  Begin
    LegendMemo.Font:=MapLegendRec.NorthArrowTextFont;
    For I:=0 to MapLegendRec.NorthArrowTextCount-1 do
    LegendMemo.Lines.Add(MapLegendRec.NorthArrowText[I]);
  End;
  7: {Contour Interval}
  Begin
    LegendMemo.Font:=MapLegendRec.ContourIntervalFont;
    For I:=0 to MapLegendRec.ContourIntervalCount-1 do
    LegendMemo.Lines.Add(MapLegendRec.ContourInterval[I]);
  End;
  end;
end;

procedure TLegendForm.SaveTextBtnClick(Sender: TObject);
{Title, series (top);Author (top);Title, series (bottom);
Author (bottom);Source, projection, etc.;Feature Text;
North Arrow;Contour Interval}
var I:Integer;
begin
  Case LegendTextRG.Itemindex of
  0: {Title, series (top)}
  Begin
    MapLegendRec.TitleTopFont:=LegendMemo.Font;
    MapLegendRec.TitleTopCount:=LegendMemo.Lines.Count;
    SetLength(MapLegendRec.TitleTop,MapLegendRec.TitleTopCount);
    For I:=0 to MapLegendRec.TitleTopCount-1 do
    MapLegendRec.TitleTop[I]:=LegendMemo.Lines[I];
  End;
  1: {Author (top)   AuthorTop}
  Begin
    MapLegendRec.AuthorTopFont:=LegendMemo.Font;
    MapLegendRec.AuthorTopCount:=LegendMemo.Lines.Count;
    SetLength(MapLegendRec.AuthorTop,MapLegendRec.AuthorTopCount);
    For I:=0 to MapLegendRec.AuthorTopCount-1 do
    MapLegendRec.AuthorTop[I]:=LegendMemo.Lines[I];
  End;
  2: {Title, series (bottom)     TitleBottom}
  Begin
    MapLegendRec.TitleBottomFont:=LegendMemo.Font;
    MapLegendRec.TitleBottomCount:=LegendMemo.Lines.Count;
    SetLength(MapLegendRec.TitleBottom,MapLegendRec.TitleBottomCount);
    For I:=0 to MapLegendRec.TitleBottomCount-1 do
    MapLegendRec.TitleBottom[I]:=LegendMemo.Lines[I];
  End;
  3: {Author (bottom)        AuthorBottom}
  Begin
    MapLegendRec.AuthorBottomFont:=LegendMemo.Font;
    MapLegendRec.AuthorBottomCount:=LegendMemo.Lines.Count;
    SetLength(MapLegendRec.AuthorBottom,MapLegendRec.AuthorBottomCount);
    For I:=0 to MapLegendRec.AuthorBottomCount-1 do
    MapLegendRec.AuthorBottom[I]:=LegendMemo.Lines[I];
  End;
  4: {Source, projection, etc.      Source}
  Begin
    MapLegendRec.SourceFont:=LegendMemo.Font;
    MapLegendRec.SourceCount:=LegendMemo.Lines.Count;
    SetLength(MapLegendRec.Source,MapLegendRec.SourceCount);
    For I:=0 to MapLegendRec.SourceCount-1 do
    MapLegendRec.Source[I]:=LegendMemo.Lines[I];
  End;
  5: {Feature Text        FeatureText}
  Begin
    MapLegendRec.FeatureTextFont:=LegendMemo.Font;
    MapLegendRec.FeatureTextCount:=LegendMemo.Lines.Count;
    SetLength(MapLegendRec.FeatureText,MapLegendRec.FeatureTextCount);
    For I:=0 to MapLegendRec.FeatureTextCount-1 do
    MapLegendRec.FeatureText[I]:=LegendMemo.Lines[I];
  End;
  6: {North Arrow       NorthArrowText}
  Begin
    MapLegendRec.NorthArrowTextFont:=LegendMemo.Font;
    MapLegendRec.NorthArrowTextCount:=LegendMemo.Lines.Count;
    SetLength(MapLegendRec.NorthArrowText,MapLegendRec.NorthArrowTextCount);
    For I:=0 to MapLegendRec.NorthArrowTextCount-1 do
    MapLegendRec.NorthArrowText[I]:=LegendMemo.Lines[I];
  End;
  7: {Contour Interval    ContourInterval}
  Begin
    MapLegendRec.ContourIntervalFont:=LegendMemo.Font;
    MapLegendRec.ContourIntervalCount:=LegendMemo.Lines.Count;
    SetLength(MapLegendRec.ContourInterval,MapLegendRec.ContourIntervalCount);
    For I:=0 to MapLegendRec.ContourIntervalCount-1 do
    MapLegendRec.ContourInterval[I]:=LegendMemo.Lines[I];
  End;
  end;
end;
(***********************************************************)


(***********************************************************)
procedure TLegendForm.LoadBitmapsBtnClick(Sender: TObject);
begin
{Grid (s) NOT,North Arrow,Legend,Map Location,Scale bars,Feature Bitmap}
  Case LegendLegionBitmapsRG.Itemindex of
  0:
  Begin
    OpenDialog1.Filename:=ExtractFileName(MapLegendRec.NorthArrowBitName);
    OpenDialog1.Initialdir:=ExtractFilePath(MapLegendRec.NorthArrowBitName);
    If OpenDialog1.Execute then
    begin
      If (ExtractFileExt(OpenDialog1.Filename)='.bmp') then
      begin
        MapLegendRec.NorthArrowBitName:=OpenDialog1.Filename;
        LegendLegionBitmapsImage.Picture.LoadFromFile(OpenDialog1.Filename);
        LegendLegionBitmapsLabel.Caption:=OpenDialog1.Filename;
        LegendBitmapSizeLabel.Caption:=
        InttoStr(LegendLegionBitmapsImage.Picture.Bitmap.Width)+' x '+
        InttoStr(LegendLegionBitmapsImage.Picture.Bitmap.Height);
        MapLegendRec.NorthArrowBitAt[6]:=
          LegendLegionBitmapsImage.Picture.Bitmap.Width;
        MapLegendRec.NorthArrowBitAt[7]:=
          LegendLegionBitmapsImage.Picture.Bitmap.Height;
      end;
    end;
  End;
  1:
  Begin
    OpenDialog1.Filename:=ExtractFileName(MapLegendRec.LegendName);
    OpenDialog1.Initialdir:=ExtractFilePath(MapLegendRec.LegendName);
    If OpenDialog1.Execute then
    begin
      If (ExtractFileExt(OpenDialog1.Filename)='.bmp') then
      begin
        MapLegendRec.LegendName:=OpenDialog1.Filename;
        LegendLegionBitmapsImage.Picture.LoadFromFile(OpenDialog1.Filename);
        LegendLegionBitmapsLabel.Caption:=OpenDialog1.Filename;
        LegendBitmapSizeLabel.Caption:=
        InttoStr(LegendLegionBitmapsImage.Picture.Bitmap.Width)+' x '+
        InttoStr(LegendLegionBitmapsImage.Picture.Bitmap.Height);
        MapLegendRec.LegendAt[6]:=
          LegendLegionBitmapsImage.Picture.Bitmap.Width;
        MapLegendRec.LegendAt[7]:=
          LegendLegionBitmapsImage.Picture.Bitmap.Height;
      end;
    end;
  End;
  2:
  Begin
    OpenDialog1.Filename:=ExtractFileName(MapLegendRec.MapLocationName);
    OpenDialog1.Initialdir:=ExtractFilePath(MapLegendRec.MapLocationName);
    If OpenDialog1.Execute then
    begin
      If (ExtractFileExt(OpenDialog1.Filename)='.bmp') then
      begin
        MapLegendRec.MapLocationName:=OpenDialog1.Filename;
        LegendLegionBitmapsImage.Picture.LoadFromFile(OpenDialog1.Filename);
        LegendLegionBitmapsLabel.Caption:=OpenDialog1.Filename;
        LegendBitmapSizeLabel.Caption:=
        InttoStr(LegendLegionBitmapsImage.Picture.Bitmap.Width)+' x '+
        InttoStr(LegendLegionBitmapsImage.Picture.Bitmap.Height);
        MapLegendRec.MapLocationAt[6]:=
          LegendLegionBitmapsImage.Picture.Bitmap.Width;
        MapLegendRec.MapLocationAt[7]:=
          LegendLegionBitmapsImage.Picture.Bitmap.Height;
      end;
    end;
  End;
  3:
  Begin
    OpenDialog1.Filename:=ExtractFileName(MapLegendRec.ScalebarsName);
    OpenDialog1.Initialdir:=ExtractFilePath(MapLegendRec.ScalebarsName);
    If OpenDialog1.Execute then
    begin
      If (ExtractFileExt(OpenDialog1.Filename)='.bmp') then
      begin
        MapLegendRec.ScalebarsName:=OpenDialog1.Filename;
        LegendLegionBitmapsImage.Picture.LoadFromFile(OpenDialog1.Filename);
        LegendLegionBitmapsLabel.Caption:=OpenDialog1.Filename;
        LegendBitmapSizeLabel.Caption:=
        InttoStr(LegendLegionBitmapsImage.Picture.Bitmap.Width)+' x '+
        InttoStr(LegendLegionBitmapsImage.Picture.Bitmap.Height);
        MapLegendRec.ScalebarsAt[6]:=
          LegendLegionBitmapsImage.Picture.Bitmap.Width;
        MapLegendRec.ScalebarsAt[7]:=
          LegendLegionBitmapsImage.Picture.Bitmap.Height;
      end;
    end;
  End;
  4:
  Begin
    OpenDialog1.Filename:=ExtractFileName(MapLegendRec.FeatureBitmapName);
    OpenDialog1.Initialdir:=ExtractFilePath(MapLegendRec.FeatureBitmapName);
    If OpenDialog1.Execute then
    begin
      If (ExtractFileExt(OpenDialog1.Filename)='.bmp') then
      begin
        MapLegendRec.FeatureBitmapName:=OpenDialog1.Filename;
        LegendLegionBitmapsImage.Picture.LoadFromFile(OpenDialog1.Filename);
        LegendLegionBitmapsLabel.Caption:=OpenDialog1.Filename;
        LegendBitmapSizeLabel.Caption:=
        InttoStr(LegendLegionBitmapsImage.Picture.Bitmap.Width)+' x '+
        InttoStr(LegendLegionBitmapsImage.Picture.Bitmap.Height);
        MapLegendRec.FeatureBitmapAt[6]:=
          LegendLegionBitmapsImage.Picture.Bitmap.Width;
        MapLegendRec.FeatureBitmapAt[7]:=
          LegendLegionBitmapsImage.Picture.Bitmap.Height;
      end;
    end;
  End;
  end;
end;
(***********************************************************)
(***********************************************************)


(***********************************************************)
(***********************************************************)




procedure TLegendForm.MapLocationRGClick(Sender: TObject);
begin
Case MapLocationRG.Itemindex of
0:
MapLegendRec.MapLocationText:=
StateCB.items[StateCB.Itemindex];
1:
MapLegendRec.MapLocationText:=
CountryCB.items[CountryCB.Itemindex];
2:
MapLegendRec.MapLocationText:=
  WhereEdit.Text;
  end;
end;

procedure TLegendForm.GridsRGClick(Sender: TObject);
begin
  MapLegendRec.GridsRG:=GridsRG.Itemindex;
  Case GridsRG.ItemIndex of
  0: MapLegendRec.GridName:='None';
  1: MapLegendRec.GridName:='Lat Long';
  2: MapLegendRec.GridName:='UTM Grid';
  end;
end;

end.
