{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit LOptionsForm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  FileCtrl{SelectDirectory},
  ExtCtrls, StdCtrls, Buttons, Grids, ComCtrls;

type
  TOptionsForm = class(TForm)
    OpenDialog1: TOpenDialog;
    ColorDialog1: TColorDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    RecordReader: TTabSheet;
    ColorPicker: TTabSheet;
    DrawGrid1: TDrawGrid;
    ColorFileEdit: TEdit;
    ColorFiler: TSpeedButton;
    ColorSaver: TSpeedButton;
    ColorsHelp: TSpeedButton;
    ColorClears: TSpeedButton;
    Color256Setter: TSpeedButton;
    ColorFill: TSpeedButton;
    ColorSubvert: TSpeedButton;
    ColorInverter: TSpeedButton;
    DotEdit: TEdit;
    SDTSEdit: TEdit;
    TigerEdit: TEdit;
    DXFEdit: TEdit;
    VectorDbEdit: TEdit;
    DLGEdit: TEdit;
    BaseImagesEdit: TEdit;
    ShapeEdit: TEdit;
    ProjectsEdit: TEdit;
    ProjectsBtn: TSpeedButton;
    ShapeBtn: TSpeedButton;
    BaseImagesBtn: TSpeedButton;
    DLGBtn: TSpeedButton;
    VectorDbBtn: TSpeedButton;
    DXFBtn: TSpeedButton;
    TigerBtn: TSpeedButton;
    SDTSBtn: TSpeedButton;
    DotBtn: TSpeedButton;
    Label3: TLabel;
    Label2: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label25: TLabel;
    Label17: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label49: TLabel;
    Bevel1: TBevel;
    Label1: TLabel;
    InfoCB: TCheckBox;
    ConfirmationCB: TCheckBox;
    ErrorsCB: TCheckBox;
    WarningCB: TCheckBox;
    CompletionCB: TCheckBox;
    BeepOrWavCB: TCheckBox;
    Label4: TLabel;
    MessageXEdit: TEdit;
    MessageYEdit: TEdit;
    MessageBtn: TSpeedButton;
    POHelpBtn: TSpeedButton;
    POM_ResetMenuBtn: TSpeedButton;
    CloseBitBtn: TBitBtn;
    SelectionRadiusEdit: TEdit;
    Label7: TLabel;
    Panel1: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    EditColorLabel: TLabel;
    Label8: TLabel;
    HighlightColorPanel: TPanel;
    BackgroundColorPanel: TPanel;
    EditColorPanel: TPanel;
    EditingColorPanel: TPanel;
    SaveDialog1: TSaveDialog;
    Color256RG: TRadioGroup;
    SeedEdit: TEdit;
    TabSheet2: TTabSheet;
    Label20: TLabel;
    ThumbBtn: TSpeedButton;
    ThumbEdit: TEdit;
    Label15: TLabel;
    WidthEdit: TEdit;
    SizeUpDown: TUpDown;
    Shape1: TShape;
    FillColorBtn: TSpeedButton;
    UseThumbnailsCB: TCheckBox;
    DeleteThumbnailsBtn: TSpeedButton;
    Label18: TLabel;
    KillAllThumbsBtn: TSpeedButton;
    TabSheet3: TTabSheet;
    ExtMemo: TMemo;
    ExtensionSetRG: TRadioGroup;
    ExtOpen: TSpeedButton;
    ClearExtBtn: TSpeedButton;
    ExtSave: TSpeedButton;
    ExtDefaults: TSpeedButton;
    procedure POHelpBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure POM_ResetMenuBtnClick(Sender: TObject);
    procedure DXFBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CloseBitBtnClick(Sender: TObject);
    procedure Showem;
    procedure ProjectsBtnClick(Sender: TObject);
    procedure TigerBtnClick(Sender: TObject);
    procedure DotBtnClick(Sender: TObject);
    procedure SDTSBtnClick(Sender: TObject);
    procedure DLGBtnClick(Sender: TObject);
    procedure ShapeBtnClick(Sender: TObject);
    procedure VectorDbBtnClick(Sender: TObject);
    procedure BaseImagesBtnClick(Sender: TObject);
    procedure MessageBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BeepOrWavCBClick(Sender: TObject);
    procedure BackgroundColorPanelClick(Sender: TObject);
    procedure HighlightColorPanelClick(Sender: TObject);
    procedure EditColorPanelClick(Sender: TObject);
    procedure EditingColorPanelClick(Sender: TObject);
    procedure ColorFilerClick(Sender: TObject);
    procedure ColorClearsClick(Sender: TObject);
    procedure ColorInverterClick(Sender: TObject);
    procedure ColorSaverClick(Sender: TObject);
    procedure ColorsHelpClick(Sender: TObject);
    procedure ColorSubvertClick(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DrawGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Color256RGClick(Sender: TObject);
Procedure MakePalette(Seed: Integer);
procedure Setup;
procedure ColorSetup;
    procedure Color256SetterClick(Sender: TObject);
    procedure ColorFillClick(Sender: TObject);
    procedure ThumbBtnClick(Sender: TObject);
    procedure DeleteThumbnailsBtnClick(Sender: TObject);
    procedure FillColorBtnClick(Sender: TObject);
    procedure KillAllThumbsBtnClick(Sender: TObject);
    procedure UseThumbnailsCBClick(Sender: TObject);
    procedure SizeUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure ExtOpenClick(Sender: TObject);
    procedure ClearExtBtnClick(Sender: TObject);
    procedure ExtSaveClick(Sender: TObject);
    procedure ExtDefaultsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OptionsForm: TOptionsForm;
{Color256S:Integer;}
implementation
{$R *.DFM}
uses LoGlobals, LoeditFrm,LOResMess, AllShapeLoaderFrm;


procedure TOptionsForm.FormCreate(Sender: TObject);
begin
  top := OptionsfrmY;
  left := OptionsfrmX;
  OpenDialog1.InitialDir := ProjectPath;
  SaveDialog1.InitialDir := ProjectPath;
end;

procedure TOptionsForm.FormShow(Sender: TObject);
begin
  ColorFileEdit.Text :=Inttostr(SeedNumber);
  ColorFileEdit.Text := Color256Name;
  Color256RG.ItemIndex:= Color256S-1;
{  Color256RG.ItemIndex:= Color256S-1; }  
  Color256RGClick(Sender);
  Showem;
end;

procedure TOptionsForm.Showem;
var ShowString: string;
begin
{Set all the boxes and edits}
  EditingColorPanel.Color:=EditingColor;
  BackgroundColorPanel.Color:=BackgroundColor;
  HighlightColorPanel.Color:=HighlightColor;
  EditColorPanel.Color:=EditColor;
{  CurrentColorPanel.Color := CurrentColor;}
  ErrorsCB.Checked:=ErrorBeepOn;
  WarningCB.Checked:=WarningBeepOn;
  InfoCB.Checked:=InfoBeepOn;
  ConfirmationCB.Checked:=ConfirmBeepOn;
  CompletionCB.Checked:=CompletedBeepOn;
  str(MessageX, ShowString);
  MessageXEdit.Text := ShowString;
  str(MessageY, ShowString);
  MessageYEdit.Text := ShowString;
  ProjectsEdit.Text := ProjectPath;
  TigerEdit.Text := TigerPath;
  DotEdit.Text := DotPath;
  SDTSEdit.Text := SDTSPath;
  DLGEdit.Text := DLGPath;
  DXFEdit.Text := DXFPath;
  ShapeEdit.Text := ShapePath;
  VectorDbEdit.Text := VRMDatabase;
  BaseImagesEdit.Text := ImagePath;
end;
procedure TOptionsForm.BeepOrWavCBClick(Sender: TObject);
begin
  ErrorBeepOn := ErrorsCB.Checked;
  WarningBeepOn := WarningCB.Checked;
  InfoBeepOn := InfoCB.Checked;
  ConfirmBeepOn := ConfirmationCB.Checked;
  CompletedBeepOn := CompletionCB.Checked;
  VoicesON:=BeepOrWavCB.Checked;
end;
procedure TOptionsForm.POHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(3000);
end;

procedure TOptionsForm.CloseBitBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TOptionsForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var code: Integer;
begin
  OptionsfrmY := OptionsForm.top;
  OptionsfrmX := OptionsForm.left;
  ErrorBeepOn := ErrorsCB.Checked;
  WarningBeepOn := WarningCB.Checked;
  InfoBeepOn := InfoCB.Checked;
  ConfirmBeepOn := ConfirmationCB.Checked;
  CompletedBeepOn := CompletionCB.Checked;
{Get the Message locations}
  val(MessageXEdit.Text, MessageX, Code);
  val(MessageYEdit.Text, MessageY, Code);
  val(SelectionRadiusEdit.Text, SelectionRadius, Code);
  DoSaver;
end;

procedure TOptionsForm.POM_ResetMenuBtnClick(Sender: TObject);
begin
  SelectionRadius:=8;
  CurrentColor := clBlack;
  EditingColor:=clFuchsia;
  BackgroundColor:=clWhite;
  HighlightColor:=clYellow;
  EditColor:=clRed;
  ErrorBeepOn := False;
  WarningBeepOn := False;
  InfoBeepOn := False;
  ConfirmBeepOn := False;
  CompletedBeepOn := False;
  MessageX := 123; MessageY := 123;
{Reset Directories defaults  }
  VRMProgramPath := ExtractFilePath(ParamStr(0));
  ProjectPath := VRMProgramPath;
  TigerPath := VRMProgramPath;
  DotPath := VRMProgramPath;
  SDTSPath := VRMProgramPath;
  DLGPath := VRMProgramPath;
  DXFPath := VRMProgramPath;
  ShapePath := VRMProgramPath;
  VRMDatabase := VRMProgramPath;
  ImagePath := VRMProgramPath;
  Showem;
end;

procedure TOptionsForm.ProjectsBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Project files (*.vrp)|*.vrp';
  OpenDialog1.InitialDir := ProjectPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
  begin
    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.vrp')
      then
    ProjectPath := ExtractFilePath(OpenDialog1.filename);
    ProjectsEdit.Text := ProjectPath;
  end {else DoMessages(1)};
end;

procedure TOptionsForm.TigerBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Tiger files (*.*)|*.*';
  OpenDialog1.InitialDir := TigerPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
  begin
{    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.x') then
    begin   }
    TigerPath := ExtractFilePath(OpenDialog1.filename);
    TigerEdit.Text := TigerPath;
  end; {else DoMessages(3);}
end;

procedure TOptionsForm.DotBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Dot files (*.*)|*.*';
  OpenDialog1.InitialDir := DotPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
  begin
{    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.bmp')
      then
    begin }
      DotPath := ExtractFilePath(OpenDialog1.filename);
      DotEdit.Text := DotPath;
  end;{ else DoMessages(9);}
end;

procedure TOptionsForm.SDTSBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'SDTS files (*.*)|*.*';
  OpenDialog1.InitialDir := SDTSPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
  begin
{    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.bmp')
      then
    begin  }
      SDTSPath := ExtractFilePath(OpenDialog1.filename);
      SDTSEdit.Text := SDTSPath;
  end;{ else DoMessages(4);}
end;

procedure TOptionsForm.DLGBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'DLG files (*.DLG)|*.DLG';
  OpenDialog1.InitialDir := DLGPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
    if ((lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.dlg')
      or (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.??f'))
      then
    begin
      DLGPath := ExtractFilePath(OpenDialog1.filename);
      DLGEdit.Text := DLGPath;
    end{ else DoMessages(10)};
end;

procedure TOptionsForm.DXFBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'dxf files (*.dxf)|*.dxf';
  OpenDialog1.InitialDir := DXFPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.dxf')
      then
    begin
      DXFPath := ExtractFilePath(OpenDialog1.filename);
      DXFEdit.Text := DXFPath;
    end {else DoMessages(11)};
end;

procedure TOptionsForm.ShapeBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Shape files (*.shp)|*.shp';
  OpenDialog1.Filename:='';
  OpenDialog1.InitialDir := ShapePath;
  if OpenDialog1.execute then
    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.shp')
      then
    begin
      ShapePath := ExtractFilePath(OpenDialog1.filename);
      ShapeEdit.Text := ShapePath;
    end {else DoMessages(8)};
end;

procedure TOptionsForm.VectorDbBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Database files (*.db)|*.db;*.dbf';
  OpenDialog1.InitialDir := VRMDatabase;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
    if ((lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.db')
      or (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.dbf'))
        then
    begin
      VRMDatabase := ExtractFilePath(OpenDialog1.filename);
      VectorDbEdit.Text := VRMDatabase;
    end {else DoMessages(12)};
end;

procedure TOptionsForm.BaseImagesBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Image files (*.bmp)|*.bmp';
  OpenDialog1.InitialDir := ImagePath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.bmp')
      then
    begin
      ImagePath := ExtractFilePath(OpenDialog1.filename);
        BaseImagesEdit.Text := ImagePath;
    end {else DoMessages(13)};
end;

procedure TOptionsForm.MessageBtnClick(Sender: TObject);
begin
  DoRezInfo(9999);
end;



procedure TOptionsForm.BackgroundColorPanelClick(Sender: TObject);
begin
   ColorDialog1.Color:= BackgroundColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    BackgroundColorPanel.Color := ColorDialog1.Color;
    BackgroundColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.HighlightColorPanelClick(Sender: TObject);
begin
    ColorDialog1.Color:=HighlightColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    HighlightColorPanel.Color := ColorDialog1.Color;
    HighlightColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.EditColorPanelClick(Sender: TObject);
begin
    ColorDialog1.Color:=EditColor;
  if ColorDialog1.Execute then
  begin
    EditColorPanel.Color := ColorDialog1.Color;
    EditColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.EditingColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:=EditingColor;
  if ColorDialog1.Execute then
  begin
    EditingColorPanel.Color := ColorDialog1.Color;
    EditingColor := ColorDialog1.Color;
  end;
end;




procedure TOptionsForm.ColorFilerClick(Sender: TObject);
var
  {F_File: file of TColor;
  i: Integer;   }
  FileS: string;
begin
  FileS := ColorFileEdit.Text;
  OpenDialog1.FileName := FileS;
  if OpenDialog1.Execute then
  { Display Open dialog box }
  begin
    if (FileExists(OpenDialog1.Filename)) then
    begin
    Color256Name:=OpenDialog1.Filename;
    ColorFileEdit.Text := Color256Name;
    Color256S:=10;
    Color256RG.ItemIndex:=9{+1=10};
    Color256RGClick(Sender);
(*      AssignFile(F_File, OpenDialog1.Filename);
      Reset(F_File);
      if IoResult <> 0 then
        begin
{        DoMessages(30091);}
        Exit;
        end;
      for i := 0 to 255 do Read(F_File, ColorArray[i]);
      CloseFile(F_File);*)
    end else {DoMessages(30092)};
{    PageControl1.ActivePage := RecordReader;
    PageControl1.ActivePage := ColorPicker;
  SetFocus;}
  end;
  end;

procedure TOptionsForm.ColorSaverClick(Sender: TObject);
var F_File: file of TColor;
  i: Integer;
  FileS: string;
begin
  FileS := ColorFileEdit.Text;
{  If (FileExists(FileS)) THEN Begin}
  AssignFile(F_File, FileS);
  ReWrite(F_File);
  if IoResult <> 0 then
  begin
{    DoMessages(30091);}
    Exit;
  end;
  for i := 0 to 255 do Write(F_File, ColorArray[i]);
  CloseFile(F_File);
end;


procedure TOptionsForm.ColorClearsClick(Sender: TObject);
var i: Integer;
begin
  for i := 0 to 255 do ColorArray[i] := RGB(255, 255, 255);
  PageControl1.ActivePage := RecordReader;
  PageControl1.ActivePage := ColorPicker;
  SetFocus;
end;


procedure TOptionsForm.ColorInverterClick(Sender: TObject);
var i: Integer; Colors: array[0..2, 0..255] of Byte;
begin
{ColorArray[0]:=RGB(Colors[0,0],Colors[1,0],Colors[2,0]);}
  if (GetRValue(ColorArray[0]) = 255) then
  begin for i := 0 to 255 do Colors[0, i] := i end
  else begin for i := 0 to 255 do Colors[0, i] := 0 end;
  if (GetGValue(ColorArray[0]) = 255) then
  begin for i := 0 to 255 do Colors[1, i] := i end
  else begin for i := 0 to 255 do Colors[1, i] := 0 end;
  if (GetBValue(ColorArray[0]) = 255) then
  begin for i := 0 to 255 do Colors[2, i] := i end
  else begin for i := 0 to 255 do Colors[2, i] := 0 end;
  for i := 0 to 255 do
    ColorArray[i] := RGB(Colors[0, i], Colors[1, i], Colors[2, i]);
  PageControl1.ActivePage := RecordReader;
  PageControl1.ActivePage := ColorPicker;
  SetFocus;
end;




procedure TOptionsForm.ColorsHelpClick(Sender: TObject);
begin
  Application.HelpContext(1900);
end;

procedure TOptionsForm.ColorSubvertClick(Sender: TObject);
var i: Integer;
begin
  for i := 0 to 15 do ColorArray[i] := RGB(0, 0, 255 - (i * 12));
  for i := 0 to 15 do
    ColorArray[i + 16] := RGB(0, 255 - (i * 12), 255 - (i * 12));
  for i := 0 to 15 do
    ColorArray[i + 32] := RGB(0, 255 - (i * 12), 0);
  for i := 0 to 15 do
    ColorArray[i + 48] := RGB(255 - (i * 12), 255 - (i * 12), 0);
  for i := 0 to 15 do
    ColorArray[i + 64] := RGB(255 - (i * 12), 0, 255 - (i * 12));
  for i := 0 to 15 do
    ColorArray[i + 80] := RGB(255 - (i * 12), 0, 0);
  for i := 0 to 15 do
    ColorArray[i + 96] := RGB(255 - (i * 12), 255 - (i * 12), 255 - (i
    * 12));

  for i := 0 to 15 do
    ColorArray[i + 112] := RGB(0, 0, 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 128] := RGB(0, 255 - (i * 14), 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 144] := RGB(0, 255 - (i * 14), 0);
  for i := 0 to 15 do
    ColorArray[i + 160] := RGB(255 - (i * 14), 255 - (i * 14), 0);
  for i := 0 to 15 do
    ColorArray[i + 176] := RGB(255 - (i * 14), 0, 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 192] := RGB(255 - (i * 14), 0, 0);
  for i := 0 to 15 do
    ColorArray[i + 208] := RGB(0, 255 - (i * 14), 0);
  for i := 0 to 15 do
    ColorArray[i + 224] := RGB(0, 255 - (i * 14), 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 240] := RGB(255 - (i * 14), 0, 0);
  PageControl1.ActivePage := RecordReader;
  PageControl1.ActivePage := ColorPicker;
  SetFocus;
end;


procedure TOptionsForm.DrawGrid1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  index: integer;
begin
  index := ARow * DrawGrid1.ColCount + ACol;
  with Sender as TDrawGrid do
  begin {(ACol*ARow)}
    DrawGrid1.Canvas.Brush.Color := ColorArray[index];
      { clBackGround;}
    DrawGrid1.Canvas.FillRect(Rect);
{    DrawGrid1.Draw(Canvas,Rect.Left,Rect.Top,index);}
    if gdFocused in State then
      Canvas.DrawFocusRect(Rect);
    Canvas.Refresh;
  end;
end;


procedure TOptionsForm.DrawGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var index: integer;
var RS, GS, BS: string;
begin
  index := ARow * DrawGrid1.ColCount + ACol;
  if ColorDialog1.Execute then
  begin
    ColorArray[index] := ColorDialog1.Color;
  {ColorArray[(ACol*ARow)]:=ColorDialog1.Color;}
              {(ACol*ARow) ... Mixes and duplicates values}
  Str(GetRValue(ColorArray[index]), RS);
  Str(GetGValue(ColorArray[index]), GS);
  Str(GetBValue(ColorArray[index]), BS);
  VoEditForm.HintPanel.Caption :=
    '  Red: ' + RS + ', Green: ' + GS + ', Blue: ' + BS;
  end;
end;

Procedure TOptionsForm.MakePalette(Seed: Integer);
var
  i : integer;
  r0, g0, b0: integer;
  r1, g1, b1: integer;
  s: real;
begin
  RandSeed := Seed;
  r0 := 64;
  g0 := 64;
  b0 := 64;
  //r1 := 255;
  //g1 := 200;
  //b1 := 64;
        r1 := random(256);
        g1 := random(256);
        b1 := random(256);
  s := 0;
  for i := 0 to 255 do
  begin
    s := s + 0.02 + 0.03 * (255-i)/255;
    if s >= 1.0 then
    begin
      r0 := r1;
      g0 := g1;
      b0 := b1;
      repeat
        r1 := random(256);
        g1 := random(256);
        b1 := random(256);
      until abs(r1-r0) + abs(g1-g0) + abs(b1-b0) > 200; // fixme
      s := 0;
    end;
  ColorArray[i] :=
  RGB(trunc((1-s) * r0 + s * r1),
      trunc((1-s) * g0 + s * g1),
      trunc((1-s) * b0 + s * b1));
{    dib.colors[i].r := trunc((1-s) * r0 + s * r1);
    dib.colors[i].g := trunc((1-s) * g0 + s * g1);
    dib.colors[i].b := trunc((1-s) * b0 + s * b1);}
  end;
  ColorArray[255] :=  RGB(0,0,0);
{  dib.colors[255].r := 0;//255;
  dib.colors[255].g := 0;//255;
  dib.colors[255].b := 0;//255;  }
end;

procedure TOptionsForm.Setup;
begin
  ColorFileEdit.Text :=Inttostr(SeedNumber);
  ColorFileEdit.Text := Color256Name;
{  Color256RG.ItemIndex:= Color256S-1; }
  ColorSetup;
end;
procedure TOptionsForm.Color256RGClick(Sender: TObject);
begin
 Color256S :=Color256RG.ItemIndex+1;
  ColorSetup;
  PageControl1.ActivePage := RecordReader;
  PageControl1.ActivePage := ColorPicker;
  SetFocus;
end;

procedure TOptionsForm.ColorSetup;
var
  i: Integer;
  F_File: file of TColor;
begin
{ Color256S :=Color256RG.ItemIndex+1;}
  case Color256S of
    1: for i := 0 to 255 do
       ColorArray[i] :=RGB(0,0, 255 -i);
    2: for i := 0 to 255 do
        ColorArray[i] := RGB(0, 255 - i, 255 - i);
    3: for i := 0 to 255 do
        ColorArray[i] := RGB(0, 255 - i, 0);
    4: for i := 0 to 255 do
        ColorArray[i] := RGB( 255 - i,  255 - i, 0);
    5: for i := 0 to 255 do
        ColorArray[i] := RGB(255 - i, 0, 255 - i);
    6: for i := 0 to 255 do
      ColorArray[i] :=RGB(255 - i, 0, 0);
    7: for i := 0 to 255 do
        ColorArray[i] := RGB(255 - i,255 - i,255 - i);
    8:begin
        Randomize;
        for i := 0 to 255 do
        ColorArray[i] := Random(16000000);
      end;
    9:begin {Use # to compute color set}
    SeedNumber:=Strtoint(SeedEdit.Text);
    MakePalette(SeedNumber);
    end;
    10: begin {Load filename set}
        if (FileExists(Color256Name)) then
        begin
          {Loaded256.Checked := True;}
          AssignFile(F_File, Color256Name);
          Reset(F_File);
          if IoResult <> 0 then
          begin
            {DoMessages(30091);}
          end else
          begin
            for i := 0 to 255 do Read(F_File, ColorArray[i]);
            CloseFile(F_File);
          end;
        end else
           { DoMessages(30092)};
           Color256S:=8;
      end;
  end; {of case}
end;


procedure TOptionsForm.Color256SetterClick(Sender: TObject);
var LayerDo:Integer;
begin
    For LayerDo:= 1 to LayersLoaded do
    begin
      MapA[LayerDo].SymLayerLineColor :=
       ShapeLoaderForm.SetMyColor(( LayerDo+1));
      MapA[LayerDo].SymLayerBrushColor :=
       ShapeLoaderForm.SetMyColor(( LayerDo));
    end;
    VoEditForm.DVDORedraw;
end;

procedure TOptionsForm.ColorFillClick(Sender: TObject);
begin
  Color256S :=9;
  Color256RG.ItemIndex:= Color256S-1;
  ColorSetup;
  PageControl1.ActivePage := RecordReader;
  PageControl1.ActivePage := ColorPicker;
  SetFocus;
end;

procedure TOptionsForm.ThumbBtnClick(Sender: TObject);
begin
  TransSearchDir:= ThumbPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
  begin
    ThumbPath := TransSearchDir;
    ThumbEdit.Text := ThumbPath;
  end;
end;

procedure TOptionsForm.DeleteThumbnailsBtnClick(Sender: TObject);
var
  I: integer;
  F: File;
begin
  OpenDialog1.Options := [ofAllowMultiSelect, ofFileMustExist];
  OpenDialog1.InitialDir := ThumbPath;
  OpenDialog1.Filter := 'bmp files (*.bmp)|*.bmp';
  OpenDialog1.FilterIndex := 1;
  OpenDialog1.Filename:='*.bmp';
  if OpenDialog1.Execute then
    with OpenDialog1.Files do
      for I := 0 to Count - 1 do
      begin
        AssignFile(F, Strings[I]);
        Erase(F);
      end;
  OpenDialog1.Options := [ofHideReadOnly,ofEnableSizing];
end;


procedure TOptionsForm.FillColorBtnClick(Sender: TObject);
begin
  ColorDialog1.Color:=ThumbColor;
  if ColorDialog1.Execute then
      ThumbColor:=ColorDialog1.Color;
  Shape1.Brush.Color:=ThumbColor;
end;

procedure TOptionsForm.KillAllThumbsBtnClick(Sender: TObject);
var
  FileAttrs: Integer;
  sr: TSearchRec;
  root:String;
  I:Integer;
  aStringList: TStringList;
begin
  If (ThumbPath <> ExtractFilePath(ParamStr(0))) then
  Begin
   aStringList := TStringList.Create;	{ construct the list object }
   try
   FileAttrs := faReadOnly + faHidden+faSysFile;
   root:=ThumbPath;
   if root [Length (root)] <> '\' then root := root + '\';
   if FindFirst (root+'*.*', FileAttrs, sr) = 0 then
   begin
     aStringList.Add(root+sr.Name);    {s.Name;}
     while FindNext(sr) = 0 do
     begin
       aStringList.Add(root+sr.Name);  {FindClose(sr);}
     end;
   end;
   Application.ProcessMessages;
   for I := 0 to aStringList.Count - 1 do
   begin
     If (ExtractFileName(aStringList[I])<>'index.dat' )then
     if FileExists(aStringList[I]) then
     If DeleteFile(aStringList[I]) then
     begin end else
     Showmessage('Boo boo '+aStringList[I]);
   end;
   aStringList.Clear;
   Application.ProcessMessages;
   finally
     aStringList.Free;	{ destroy the list object }
   end;
 End else
 Showmessage('Please Set Thumbnail directory in Program Options');
end;


procedure TOptionsForm.UseThumbnailsCBClick(Sender: TObject);
begin
  UseThumbnails:=(not UseThumbnails);
  UseThumbnailsCB.Checked:=UseThumbnails;
end;

procedure TOptionsForm.SizeUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
If ((Button = btNext) and  (SizeUpDown.Position <200)) then
   begin
   Shape1.Width:=SizeUpDown.Position+1;
   Shape1.Height:=SizeUpDown.Position+1;
   end   else  {287w 190h}
If ((Button = btPrev) and  (SizeUpDown.Position >11)) then
   begin
   Shape1.Width:=SizeUpDown.Position-1;
   Shape1.Height:=SizeUpDown.Position-1;
   end;
end;
(*If ((Button = btNext) and  (HeightUpDown.Position <190)) then
   Shape1.Height:=HeightUpDown.Position+1
   else  {287w 190h}
If ((Button = btPrev) and  (HeightUpDown.Position >2)) then
   Shape1.Height:=HeightUpDown.Position-1;*)
{The Button parameter specifies how the value of Position
 is about to change.
 When Button is btNext, the Up or Right arrow was clicked,
 and the value of Position is about to increase by Increment.
  When Button is btPrev, the Down or Left arrow was clicked,
  and the value of Position is about to decrease by Increment.  }

procedure TOptionsForm.ExtOpenClick(Sender: TObject);
var
ExtFileName:String;
begin

Case ExtensionSetRG.ItemIndex of
0:ExtFileName:='Grafext.et0';
1:ExtFileName:='Grafext.et1';
2:ExtFileName:='Grafext.et2';
3:ExtFileName:='Grafext.et3';
4:ExtFileName:='Grafext.et4';
5:ExtFileName:='Grafext.et5';
6:ExtFileName:='Grafext.et6';
end;{case}
If FileExists(ProgramPath+ExtFileName) then
  ExtMemo.Lines.LoadFromFile(ProgramPath+ExtFileName)
  else
  begin
  Tempname:=ProgramPath+ExtFileName;
{  DoMessages(39997); }
  end;
end;

procedure TOptionsForm.ClearExtBtnClick(Sender: TObject);
begin
  ExtMemo.Clear;
end;

procedure TOptionsForm.ExtSaveClick(Sender: TObject);
var
ExtFileName:String;
begin
Case ExtensionSetRG.ItemIndex of
0:ExtFileName:='Grafext.et0';
1:ExtFileName:='Grafext.et1';
2:ExtFileName:='Grafext.et2';
3:ExtFileName:='Grafext.et3';
4:ExtFileName:='Grafext.et4';
5:ExtFileName:='Grafext.et5';
6:ExtFileName:='Grafext.et6';
end;{case}
  ExtMemo.Lines.SaveToFile(ProgramPath+ExtFileName)
end;

procedure TOptionsForm.ExtDefaultsClick(Sender: TObject);
begin
Case ExtensionSetRG.ItemIndex of
0:begin
{ExtMemo}
  ExtMemo.Lines.Add('*.shp');
  ExtMemo.Lines.Add('*.shx');
  ExtMemo.Lines.Add('*.sbx');
  ExtMemo.Lines.Add('*.dbf');
  ExtMemo.Lines.Add('*.dxf');
  ExtMemo.Lines.Add('*.dlg');
  ExtMemo.Lines.Add('*.vrm');
end;
1:begin
    // internally register Delphi's "built in" formats,
    //these will not be unregistered on exit and
    // also not registered with TPicture (because they are already or will soon be)
  ExtMemo.Lines.Add('*.png');
  ExtMemo.Lines.Add('*.bmp');
  ExtMemo.Lines.Add('*.ico');
  ExtMemo.Lines.Add('*.wmf');
  ExtMemo.Lines.Add('*.emf');
  ExtMemo.Lines.Add('*.jfif');
  ExtMemo.Lines.Add('*.jpg');
  ExtMemo.Lines.Add('*.jpe');
  ExtMemo.Lines.Add('*.jpeg');

    // register our own formats
  ExtMemo.Lines.Add('*.rle');
  ExtMemo.Lines.Add('*.dib');

    {.$ifdef TargaGraphic}
  ExtMemo.Lines.Add('*.win');
  ExtMemo.Lines.Add('*.vst');
  ExtMemo.Lines.Add('*.vda');
  ExtMemo.Lines.Add('*.tga');
  ExtMemo.Lines.Add('*.icb');
    {.$endif}

    {.$ifdef TIFFGraphic}
  ExtMemo.Lines.Add('*.tiff');
  ExtMemo.Lines.Add('*.tif');
  ExtMemo.Lines.Add('*.fax');
      {.$ifdef EPSGraphic}
  ExtMemo.Lines.Add('*.eps');
      {.$endif}
    {.$endif}

    {.$ifdef PCXGraphic}
  ExtMemo.Lines.Add('*.pcx');
  ExtMemo.Lines.Add('*.pcc');
  ExtMemo.Lines.Add('*.scr');
    {.$endif}

    {.$ifdef RLAGraphic}
  ExtMemo.Lines.Add('*.rpf');
  ExtMemo.Lines.Add('*.rla');
    {.$endif}

    {.$ifdef SGIGraphic}
  ExtMemo.Lines.Add('*.sgi');
  ExtMemo.Lines.Add('*.rgba');
  ExtMemo.Lines.Add('*.rgb');
  ExtMemo.Lines.Add('*.bw');
    {.$endif}

    {.$ifdef PhotoshopGraphic}
  ExtMemo.Lines.Add('*.psd');
  ExtMemo.Lines.Add('*.pdd');
    {.$endif}

    {.$ifdef PortableMapGraphic}
  ExtMemo.Lines.Add('*.ppm');
  ExtMemo.Lines.Add('*.pgm');
  ExtMemo.Lines.Add('*.pbm');
    {.$endif}

    {.$ifdef AutodeskGraphic}
  ExtMemo.Lines.Add('*.cel');
  ExtMemo.Lines.Add('*.pic');
    {.$endif}

    {.$ifdef PCDGraphic}
  ExtMemo.Lines.Add('*.pcd');
    {.$endif}

    {$ifdef GIFGraphic}
  ExtMemo.Lines.Add('*.gif');
    {$endif}

    {.$ifdef CUTGraphic}
  ExtMemo.Lines.Add('*.cut');
    {.$endif}

    {.$ifdef PaintshopProGraphic}
  ExtMemo.Lines.Add('*.psp');
    {.$endif}

    {.$ifdef PortableNetworkGraphic}
  ExtMemo.Lines.Add('*.png');
    {.$endif}
end;     
2:begin
  ExtMemo.Lines.Add( '*.bt');
  ExtMemo.Lines.Add( '*.dem');
  ExtMemo.Lines.Add( '*.bin');
  ExtMemo.Lines.Add( '*.bit');
  ExtMemo.Lines.Add( '*.htf');
end;
3:begin
  ExtMemo.Lines.Add(      '*.tmp');
  ExtMemo.Lines.Add(      '~*.*');
  ExtMemo.Lines.Add(      '*.~*');
  ExtMemo.Lines.Add(      '*.?~?');
  ExtMemo.Lines.Add(      '*.aps');
  ExtMemo.Lines.Add(      '*.bak');
  ExtMemo.Lines.Add(      '*.bk?');
  ExtMemo.Lines.Add(      '*.bsc');
  ExtMemo.Lines.Add(      '*.dmp');
  ExtMemo.Lines.Add(      '*.dsm');
  ExtMemo.Lines.Add(      '*.ilk');
  ExtMemo.Lines.Add(      '*.pch');
  ExtMemo.Lines.Add(      '*.rws');
  ExtMemo.Lines.Add(      '*.sbr');
  ExtMemo.Lines.Add(      'backup*.wbk');
  ExtMemo.Lines.Add(      '*.fts');
  ExtMemo.Lines.Add(      '*.gid');
  ExtMemo.Lines.Add(      '*.$$$');
end;
4:begin  {Words}
  ExtMemo.Lines.Add(      '*.doc');
  ExtMemo.Lines.Add(      '*.txt');
  ExtMemo.Lines.Add(      '*.wpd');
  ExtMemo.Lines.Add(      '*.html');
  ExtMemo.Lines.Add(      '*.htm');
end;
5:begin  {Mine}
  ExtMemo.Lines.Add(      '*.db');
  ExtMemo.Lines.Add(      '*.dbf');
end;
6:begin {Other}
  ExtMemo.Lines.Add(      '*.dih');
  ExtMemo.Lines.Add(      '*.dvh');
  ExtMemo.Lines.Add(      '*.vlh');
  ExtMemo.Lines.Add(      '*.deh');
  ExtMemo.Lines.Add(      '*.dth');
  ExtMemo.Lines.Add(      '*.vrh');
  ExtMemo.Lines.Add(      '*.fth');
  ExtMemo.Lines.Add(      '*.idt');
  ExtMemo.Lines.Add(      '*.idf');
  ExtMemo.Lines.Add(      '*.plc');
  ExtMemo.Lines.Add(      '*.hmd');
  ExtMemo.Lines.Add(      '*.hfd');
end;
end;
end;

end.
