unit LPrintLayoutForm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Printers, Preview,  Paper,
  StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TPrintLayoutForm = class(TForm)
    PageControl1: TPageControl;
    LayoutTS: TTabSheet;
    GroupBox1: TGroupBox;
    TitleSeriesTopCB: TCheckBox;
    AuthorTopCB: TCheckBox;
    TitleSeriesBotmCB: TCheckBox;
    AuthorBotmCB: TCheckBox;
    SourceProjectionCB: TCheckBox;
    GridCB: TCheckBox;
    NorthArrowCB: TCheckBox;
    LegendCB: TCheckBox;
    MapLocationCB: TCheckBox;
    ScaleCB: TCheckBox;
    FeatureTextCB: TCheckBox;
    FeatureBitmapCB: TCheckBox;
    ContourCB: TCheckBox;
    NATextCB: TCheckBox;
    BaseMapPanel: TPanel;
    MapPanel: TPanel;
    TitleTPanel: TPanel;
    TitleBPanel: TPanel;
    AuthorTPanel: TPanel;
    AuthorBPanel: TPanel;
    MapLocoPanel: TPanel;
    ScalePanel: TPanel;
    SourcePanel: TPanel;
    NorthBitPanel: TPanel;
    LegendaryPanel: TPanel;
    FeatureBitmapPanel: TPanel;
    FeatureTextPanel: TPanel;
    ContourPanel: TPanel;
    NorthTextPanel: TPanel;
    PrintMapBtn: TSpeedButton;
    SetupPrinterBtn: TSpeedButton;
    PrePrintLayoutBtn: TSpeedButton;
    CheckLayoutBtn: TSpeedButton;
    SizeMattersTS: TTabSheet;
    ObjectSizeCompRG: TRadioGroup;
    ObjectSizeHEdit: TEdit;
    Label78: TLabel;
    ObjectSizeWEdit: TEdit;
    Label77: TLabel;
    ScaleSM: TLabel;
    Label36: TLabel;
    ImageWidthSM: TLabel;
    Label35: TLabel;
    ImageHeightSM: TLabel;
    Label33: TLabel;
    PaperWidthSM: TLabel;
    Label32: TLabel;
    PaperHeightSM: TLabel;
    Label31: TLabel;
    PrinterResolutionSM: TLabel;
    Panel5: TPanel;
    Label25: TLabel;
    Label26: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    SizeMattersSetBtn: TSpeedButton;
    SetPrinterXEdit: TEdit;
    SetPrinterYEdit: TEdit;
    SetScaleEdit: TEdit;
    SetbyScaleRB: TRadioButton;
    SetPrinterDPIEdit: TEdit;
    DISRegDIPHelp: TSpeedButton;
    SizeMattersOSCBtn: TSpeedButton;
    ScrollBox1: TScrollBox;
    LegendTestImage: TImage;
    MoverRG: TRadioGroup;
    MoverYEdit: TEdit;
    UpDownY: TUpDown;
    MoverXEdit: TEdit;
    UpDownX: TUpDown;
    Preview1: TPreview;
    MoverResetBtn: TSpeedButton;
    ScaledCBox: TCheckBox;
    Label30: TLabel;
    SetbyPrinterRB: TRadioButton;
    Label1: TLabel;
    SetbyImageRB: TRadioButton;
    MapScaleEdit: TEdit;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DISRegDIPHelpClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);


    procedure SetupPrinterBtnClick(Sender: TObject);
    procedure PrintMapBtnClick(Sender: TObject);
    procedure CheckLayoutBtnClick(Sender: TObject);
    procedure PrePrintLayoutBtnClick(Sender: TObject);
    procedure TitleSeriesTopCBClick(Sender: TObject);
    procedure AuthorTopCBClick(Sender: TObject);
    procedure TitleSeriesBotmCBClick(Sender: TObject);
    procedure AuthorBotmCBClick(Sender: TObject);
    procedure SourceProjectionCBClick(Sender: TObject);
    procedure FeatureTextCBClick(Sender: TObject);
    procedure MapLocationCBClick(Sender: TObject);
    procedure GridCBClick(Sender: TObject);
    procedure NorthArrowCBClick(Sender: TObject);
    procedure NATextCBClick(Sender: TObject);
    procedure LegendCBClick(Sender: TObject);
    procedure ScaleCBClick(Sender: TObject);
    procedure ContourCBClick(Sender: TObject);
    procedure FeatureBitmapCBClick(Sender: TObject);
    procedure SizeMattersSetBtnClick(Sender: TObject);

    procedure SizeMattersOSCBtnClick(Sender: TObject);

procedure CheckTitleTop;
procedure CheckAuthorTop;
procedure CheckTitleBottom;
procedure CheckAuthorBottom;
procedure CheckSource;
procedure CheckFeatureText;
procedure CheckNorthArrowText;
procedure CheckContourInterval;

procedure CheckMapLocation;
procedure CheckNorthArrow;
procedure CheckLegend;
procedure CheckScale;
procedure CheckFeatureBitmap;
procedure CheckMap;

Procedure Draw;

procedure SetDataToForm;
    procedure MoverResetBtnClick(Sender: TObject);
    procedure UpDownXChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure UpDownYChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure MoverRGClick(Sender: TObject);
  private
    { Private declarations }
    procedure ChangePosition(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  public
    { Public declarations }
  end;

var
  PrintLayoutForm: TPrintLayoutForm;
{  Preview1 : TPreview; }

implementation

{$R *.DFM}

uses AllShapeLoaderFrm, LoGlobals, LMap, LoeditFrm;

var
CheckLayoutOK: Boolean;
XRatio,YRatio:Double;
{  TextOK, ImageOk: Boolean;
  PrintImageWidth, PrintImageHeight,
    TextWidth, TextHeight: Longint;
  TitleStr, AuthorStr: string; }

procedure TPrintLayoutForm.FormCreate(Sender: TObject);
begin
  left := VRegitFormX;
  top := VRegitFormY;
 {TextOK := False;
  ImageOk := False;}
  CheckLayoutOK:=False;
  TitleTPanel.OnMouseDown:= ChangePosition;
  TitleBPanel.OnMouseDown:= ChangePosition;
  AuthorTPanel.OnMouseDown:= ChangePosition;
  AuthorBPanel.OnMouseDown:= ChangePosition;
  MapPanel.OnMouseDown:= ChangePosition;
  FeatureBitmapPanel.OnMouseDown:= ChangePosition;
  FeatureTextPanel.OnMouseDown:= ChangePosition;
  SourcePanel.OnMouseDown:= ChangePosition;
  NorthBitPanel.OnMouseDown:= ChangePosition;
  NorthTextPanel.OnMouseDown:= ChangePosition;
  MapLocoPanel.OnMouseDown:= ChangePosition;
  ScalePanel.OnMouseDown:= ChangePosition;
  ContourPanel.OnMouseDown:= ChangePosition;
  LegendaryPanel.OnMouseDown:= ChangePosition;
  {  Preview1.Buttons:=  '[btPrint,btPageSetup,btOpen,btSave,btLanguage]';}
  {  Preview1.Buttons.btHelp:=False;
  Preview1.Buttons.btAbout:=False; }
{  Preview1 := TPreview.Create( Self ); }
  Preview1.Paper.PrinterSetup.PaperFormat:=pfLETTER;
  Preview1.Paper.PrinterSetup.PaperHeight_MM:=279;
  Preview1.Paper.PrinterSetup.PaperWidth_MM:=216;
  Preview1.Paper.PrinterSetup.PixelsPerMM_byX:=11.1111111111111;
  Preview1.Paper.PrinterSetup.PixelsPerMM_byY:=11.1541218637993;
{????}
  Preview1.Paper.Units := unTenthMillimeters;

XRatio:=(Preview1.Paper.PrinterSetup.PaperWidth_MM
         * Preview1.Paper.PrinterSetup.PixelsPerMM_byX );
YRatio:=(Preview1.Paper.PrinterSetup.PaperHeight_MM
         * Preview1.Paper.PrinterSetup.PixelsPerMM_byY );
{2400
BaseMapPanel.Width := round(Printer.PageWidth / 13.77);}
end;

procedure TPrintLayoutForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  VRegitFormX := PrintLayoutForm.left;
  VRegitFormY := PrintLayoutForm.top;
  DoSaver;
end;

procedure TPrintLayoutForm.DISRegDIPHelpClick(Sender: TObject);
begin
  Application.HelpContext(16000);
end;

procedure TPrintLayoutForm.FormShow(Sender: TObject);
begin
  If    ((ProjectName = 'Nada')
    or (not FileExists(ProjectPath+ ProjectName))) then
    MapForm.SaveMapBtnClick(Sender);

{SetScaleEdit.Text:=MapScaleEdit.Text; }
SetPrinterXEdit.Text:=Inttostr(VoEditForm.ShapeViewImage.Width);
SetPrinterYEdit.Text:=Inttostr(VoEditForm.ShapeViewImage.Height);
SetPrinterDPIEdit.Text:=Inttostr(printer.PageWidth);

  SetDataToForm;
end;

procedure TPrintLayoutForm.FormDestroy(Sender: TObject);
begin
{ Preview1.Free;}
end;
(***********************************************************)
procedure TPrintLayoutForm.ChangePosition(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   ReleaseCapture;
   (Sender as TWinControl).Perform(WM_SYSCOMMAND, SC_MOVE + 2, 0);
end;
(***********************************************************)


(***********************************************************)
procedure TPrintLayoutForm.CheckLayoutBtnClick(Sender: TObject);
begin
  {Check all for file presence + data}
  TitleTPanel.Visible:=TitleSeriesTopCB.Checked;
  MapLegendRec.TitleTopOn:=TitleSeriesTopCB.Checked;
If MapLegendRec.TitleTop[0]='.' then
TitleSeriesTopCB.Color:=clRed else TitleSeriesTopCB.Color:=clBtnFace;

  AuthorTPanel.Visible:=AuthorTopCB.Checked;
  MapLegendRec.AuthorTopOn:=AuthorTopCB.Checked;
If MapLegendRec.AuthorTop[0]='.' then
AuthorTopCB.Color:=clRed else AuthorTopCB.Color:=clBtnFace;

  TitleBPanel.Visible:=TitleSeriesBotmCB.Checked;
  MapLegendRec.TitleBottomOn:=TitleSeriesBotmCB.Checked;
If MapLegendRec.TitleBottom[0]='.' then
TitleSeriesBotmCB.Color:=clRed else TitleSeriesBotmCB.Color:=clBtnFace;

  AuthorBPanel.Visible:=AuthorBotmCB.Checked;
  MapLegendRec.AuthorBottomOn:=AuthorBotmCB.Checked;
If MapLegendRec.AuthorBottom[0]='.' then
AuthorBotmCB.Color:=clRed else AuthorBotmCB.Color:=clBtnFace;

  SourcePanel.Visible:=SourceProjectionCB.Checked;
  MapLegendRec.SourceOn:=SourceProjectionCB.Checked;
If MapLegendRec.Source[0]='.' then
SourceProjectionCB.Color:=clRed else SourceProjectionCB.Color:=clBtnFace;

  FeatureTextPanel.Visible:=FeatureTextCB.Checked;
  MapLegendRec.FeatureTextOn:=FeatureTextCB.Checked;
If MapLegendRec.FeatureText[0]='.' then
FeatureTextCB.Color:=clRed else FeatureTextCB.Color:=clBtnFace;

  NorthTextPanel.Visible:=NATextCB.Checked;
  MapLegendRec.NorthArrowTextOn:=NATextCB.Checked;
If MapLegendRec.NorthArrowText[0]='.' then
NATextCB.Color:=clRed else NATextCB.Color:=clBtnFace;

  ContourPanel.Visible:=ContourCB.Checked;
  MapLegendRec.ContourIntervalOn:=ContourCB.Checked;
If MapLegendRec.ContourInterval[0]='.' then
ContourCB.Color:=clRed else ContourCB.Color:=clBtnFace;

  MapLocoPanel.Visible:=MapLocationCB.Checked;
  MapLegendRec.MapLocationOn:=MapLocationCB.Checked;
MapLocationCB.Color:=clRed;
If MapLegendRec.MapLocationName<>'.' then
If FileExists(MapLegendRec.MapLocationName) then
  MapLocationCB.Color:=clBtnFace;

  MapLegendRec.GridOn:=GridCB.Checked;
GridCB.Color:=clRed;
If MapLegendRec.GridName<>'.' then
If FileExists(MapLegendRec.GridName) then
 GridCB.Color:=clBtnFace;

  NorthBitPanel.Visible:=NorthArrowCB.Checked;
  MapLegendRec.NorthArrowBitOn:=NorthArrowCB.Checked;
NorthArrowCB.Color:=clRed;
If MapLegendRec.NorthArrowBitName<>'.' then
If FileExists(MapLegendRec.NorthArrowBitName) then
NorthArrowCB.Color:=clBtnFace;

  LegendaryPanel.Visible:=LegendCB.Checked;
  MapLegendRec.LegendOn:=LegendCB.Checked;
LegendCB.Color:=clRed;
If MapLegendRec.LegendName<>'.' then
If FileExists(MapLegendRec.LegendName) then
LegendCB.Color:=clBtnFace;

  ScalePanel.Visible:=ScaleCB.Checked;
  MapLegendRec.ScalebarsOn:=ScaleCB.Checked;
ScaleCB.Color:=clRed;
If MapLegendRec.ScalebarsName<>'.' then
If FileExists(MapLegendRec.ScalebarsName) then
ScaleCB.Color:=clBtnFace;

  FeatureBitmapPanel.Visible:=FeatureBitmapCB.Checked;
  MapLegendRec.FeatureBitmapOn:=FeatureBitmapCB.Checked;
FeatureBitmapCB.Color:=clRed;
If MapLegendRec.FeatureBitmapName<>'.' then
If FileExists(MapLegendRec.FeatureBitmapName) then
FeatureBitmapCB.Color:=clBtnFace;

  Application.ProcessMessages;
  CheckLayoutOK:=True;
end;
(***********************************************************)

procedure TPrintLayoutForm.SizeMattersSetBtnClick(Sender: TObject);
begin   {Change Scale or Image SIZE iaw the other}
    {Need Map Extents to compute width/scale.. or whatever}
  If SetbyImageRB.Checked then
  begin     {Image sets Scale}
    {Need Map Extents to compute width/scale.. or whatever}
    SetPrinterXEdit.Text:=Inttostr(VoEditForm.ShapeViewImage.Width);
    SetPrinterYEdit.Text:=Inttostr(VoEditForm.ShapeViewImage.Height);
    SetPrinterDPIEdit.Text:=Inttostr(printer.PageWidth);
                                {X Extent / Image Width}
    SetScaleEdit.Text:=Inttostr(Round( MaxExtentX/VoEditForm.ShapeViewImage.Width));
                       {MapScaleEdit.Text;}
  end else
  If SetbyScaleRB.Checked then
  begin
    SetScaleEdit.Text:=MapScaleEdit.Text;
{    Inttostr(Round( MaxExtentX/VoEditForm.ShapeViewImage.Width));}
    SetPrinterXEdit.Text:=Inttostr(VoEditForm.ShapeViewImage.Width);
    SetPrinterYEdit.Text:=Inttostr(VoEditForm.ShapeViewImage.Height);
    SetPrinterDPIEdit.Text:=Inttostr(printer.PageWidth);
  end else
  If SetbyPrinterRB.Checked then
  begin
    SetScaleEdit.Text:=MapScaleEdit.Text;
{    Inttostr(Round( MaxExtentX/VoEditForm.ShapeViewImage.Width));}
    SetPrinterXEdit.Text:=Inttostr(VoEditForm.ShapeViewImage.Width);
    SetPrinterYEdit.Text:=Inttostr(VoEditForm.ShapeViewImage.Height);
    SetPrinterDPIEdit.Text:=Inttostr(printer.PageWidth);
  end;

    SetScaleEdit.Text:=MapForm.MapScaleEdit.Text;
    SetPrinterXEdit.Text:=Inttostr(VoEditForm.ShapeViewImage.Width);
    SetPrinterYEdit.Text:=Inttostr(VoEditForm.ShapeViewImage.Height);
    SetPrinterDPIEdit.Text:=Inttostr(printer.PageHeight);
    {Get REAL page size in inches}
    {Inttostr(Round(printer.PageHeight/11));}
PrinterResolutionSM.Caption:='what';{Inttostr();}
PaperHeightSM.Caption:=Inttostr(printer.PageHeight);
PaperWidthSM.Caption:=Inttostr(printer.PageWidth);

  If SetbyScaleRB.Checked then
  begin
ImageHeightSM.Caption:=Inttostr(VoEditForm.ShapeViewImage.Height);
ImageWidthSM.Caption:=Inttostr(VoEditForm.ShapeViewImage.Width);
ScaleSM.Caption:=
Inttostr(Round(printer.PageHeight/VoEditForm.ShapeViewImage.Height));
  end else
  begin
ImageHeightSM.Caption:=Inttostr(VoEditForm.ShapeViewImage.Height);
ImageWidthSM.Caption:=Inttostr(VoEditForm.ShapeViewImage.Width);
ScaleSM.Caption:=
Inttostr(Round(printer.PageHeight/VoEditForm.ShapeViewImage.Height));
  end;

end;


procedure TPrintLayoutForm.SizeMattersOSCBtnClick(Sender: TObject);
begin
  Case ObjectSizeCompRG.Itemindex of
  0:CheckTitleTop;{Title, series (top)}
  1:CheckAuthorTop;{Author (top)}
  2:CheckTitleBottom;{Title, series (bottom)}
  3:CheckAuthorBottom;{Author (bottom)}
  4:CheckSource;{Source, projection, etc.}
  5:CheckFeatureText;{Feature Text}
  6:;{Grid (s)}
  7:CheckNorthArrow;{North Arrow Bit}
  8:CheckNorthArrowText;{North Arrow Text}
  9:CheckLegend;{Legend}
  10:CheckMapLocation;{Inset Map Location}
  11:CheckScale;{Scale bar}
  12:CheckFeatureBitmap;{Feature Bitmap}
  13:CheckContourInterval;{Contour interval}
  14:CheckMap;{Map Size}
  15:;{Paper Size}
  16:;{Boundary Top}
  17:;{Bottom}
  18:;{Left}
  19:;{Right}
  End;
end;
(***********************************************************)
procedure TPrintLayoutForm.PrePrintLayoutBtnClick(Sender: TObject);
begin
 If (not CheckLayoutOK) then CheckLayoutBtnClick(Sender);
CheckMap;
{Check Sizes... Check}
 If  TitleSeriesTopCB.Checked then {Title, series (top)}
     CheckTitleTop;
Application.ProcessMessages;
 If  AuthorTopCB.Checked then{Author (top)}
     CheckAuthorTop;
Application.ProcessMessages;
 If  TitleSeriesBotmCB.Checked then {Title, series (bottom)}
     CheckTitleBottom;
Application.ProcessMessages;
 If  AuthorBotmCB.Checked then {Author (bottom)}
      CheckAuthorBottom;
Application.ProcessMessages;
 If  SourceProjectionCB.Checked then {Source, projection, etc.}
      CheckSource;
Application.ProcessMessages;
 If  FeatureTextCB.Checked then {Feature Text}
      CheckFeatureText;
Application.ProcessMessages;
 If  NATextCB.Checked then {North Arrow}
      CheckNorthArrowText;
Application.ProcessMessages;
 If  ContourCB.Checked then {Contour Interval}
      CheckContourInterval;
Application.ProcessMessages;

 If  MapLocationCB.Checked then {MapLocationCB}
      CheckMapLocation;
Application.ProcessMessages;
 If  NorthArrowCB.Checked then {NorthArrowCB}
      CheckNorthArrow;
Application.ProcessMessages;
 If  LegendCB.Checked then {LegendCB}
      CheckLegend;
Application.ProcessMessages;
 If  ScaleCB.Checked then {ScaleCB}
      CheckScale;
Application.ProcessMessages;
 If  FeatureBitmapCB.Checked then {FeatureBitmapCB}
     CheckFeatureBitmap;
Application.ProcessMessages;
  {Save Location info to Record}
  MapForm.SaveMap(ProjectPath+ ProjectName);
end;
(***********************************************************)

(***********************************************************)
procedure TPrintLayoutForm.CheckTitleTop;
var
  TestTextSize:TSize;
  WKeep, Width,Widest,I:Integer;
Begin
{  LegendTestImage.Canvas.Font:=MapLegendRec.TitleTopFont;}
      Preview1.Paper.SetFont(
       MapLegendRec.TitleTopFont.Name,
       MapLegendRec.TitleTopFont.Size,
       MapLegendRec.TitleTopFont.Style,
       MapLegendRec.TitleTopFont.Color);
  Widest:=0;WKeep:=0;
  For I:=0 to MapLegendRec.TitleTopCount-1 do
  begin
    Width:= Length(MapLegendRec.TitleTop[I]);
    If Width>Widest then
    begin
      Widest:= Width;
      WKeep:=i;
    end;
  end;
  TestTextSize :=Preview1.Paper.
     {LegendTestImage.Canvas.}
     TextExtent(MapLegendRec.TitleTop[WKeep]);
  TitleTPanel.Width:=  Round(TestTextSize.cx/XRatio);
  TitleTPanel.Height:=
     Round((MapLegendRec.TitleTopCount*TestTextSize.cy)/YRatio);
ObjectSizeWEdit.Text:=Inttostr(TestTextSize.cx);
ObjectSizeHEdit.Text:=Inttostr(TestTextSize.cy);
  MapLegendRec.TitleTopAt[0]:=TitleTPanel.Left;
  MapLegendRec.TitleTopAt[1]:=TitleTPanel.Top;
  MapLegendRec.TitleTopAt[2]:=TitleTPanel.Width;
  MapLegendRec.TitleTopAt[3]:=TitleTPanel.Height;
  MapLegendRec.TitleTopAt[4]:=Round(TitleTPanel.Left*XRatio);
  MapLegendRec.TitleTopAt[5]:=Round(TitleTPanel.Top*YRatio);
  MapLegendRec.TitleTopAt[6]:=TestTextSize.cx;
  MapLegendRec.TitleTopAt[7]:=MapLegendRec.TitleTopCount*TestTextSize.cy;
End;

procedure TPrintLayoutForm.CheckAuthorTop;
var
  TestTextSize:TSize;
  WKeep, Width,Widest,I:Integer;
Begin
{  LegendTestImage.Canvas.Font:=MapLegendRec.AuthorTopFont;}
      Preview1.Paper.SetFont(
       MapLegendRec.AuthorTopFont.Name,
       MapLegendRec.AuthorTopFont.Size,
       MapLegendRec.AuthorTopFont.Style,
       MapLegendRec.AuthorTopFont.Color);
  Widest:=0;WKeep:=0;
  For I:=0 to MapLegendRec.AuthorTopCount-1 do
  begin
    Width:= Length(MapLegendRec.AuthorTop[I]);
    If Width>Widest then
    begin
      Widest:= Width;
      WKeep:=i;
    end;
  end;
  TestTextSize := Preview1.Paper.TextExtent(MapLegendRec.AuthorTop[WKeep]);
  AuthorTPanel.Width:=  Round(TestTextSize.cx/XRatio);
  AuthorTPanel.Height:=
      Round((MapLegendRec.AuthorTopCount*TestTextSize.cy)/YRatio);
ObjectSizeWEdit.Text:=Inttostr(TestTextSize.cx);
ObjectSizeHEdit.Text:=Inttostr(TestTextSize.cy);
  MapLegendRec.AuthorTopAt[0]:=AuthorTPanel.Left;
  MapLegendRec.AuthorTopAt[1]:=AuthorTPanel.Top;
  MapLegendRec.AuthorTopAt[2]:=AuthorTPanel.Width;
  MapLegendRec.AuthorTopAt[3]:=AuthorTPanel.Height;
  MapLegendRec.AuthorTopAt[4]:=Round(AuthorTPanel.Left*XRatio);
  MapLegendRec.AuthorTopAt[5]:=Round(AuthorTPanel.Top*YRatio);
  MapLegendRec.AuthorTopAt[6]:=TestTextSize.cx;
  MapLegendRec.AuthorTopAt[7]:=MapLegendRec.AuthorTopCount*TestTextSize.cy;
  End;
procedure TPrintLayoutForm.CheckTitleBottom;
var
  TestTextSize:TSize;
  WKeep, Width,Widest,I:Integer;
Begin
{  LegendTestImage.Canvas.Font:=MapLegendRec.TitleBottomFont;}
      Preview1.Paper.SetFont(
       MapLegendRec.TitleBottomFont.Name,
       MapLegendRec.TitleBottomFont.Size,
       MapLegendRec.TitleBottomFont.Style,
       MapLegendRec.TitleBottomFont.Color);
  Widest:=0;WKeep:=0;
  For I:=0 to MapLegendRec.TitleBottomCount-1 do
  begin
    Width:= Length(MapLegendRec.TitleBottom[I]);
    If Width>Widest then
    begin
      Widest:= Width;
      WKeep:=i;
    end;
  end;
  TestTextSize := Preview1.Paper.TextExtent(MapLegendRec.TitleBottom[WKeep]);
  TitleBPanel.Width:=  Round(TestTextSize.cx/XRatio);
  TitleBPanel.Height:=
      Round((MapLegendRec.TitleBottomCount*TestTextSize.cy)/YRatio);
ObjectSizeWEdit.Text:=Inttostr(TestTextSize.cx);
ObjectSizeHEdit.Text:=Inttostr(TestTextSize.cy);
  MapLegendRec.TitleBottomAt[0]:=TitleBPanel.Left;
  MapLegendRec.TitleBottomAt[1]:=TitleBPanel.Top;
  MapLegendRec.TitleBottomAt[2]:=TitleBPanel.Width;
  MapLegendRec.TitleBottomAt[3]:=TitleBPanel.Height;
  MapLegendRec.TitleBottomAt[4]:=Round(TitleBPanel.Left*XRatio);
  MapLegendRec.TitleBottomAt[5]:=Round(TitleBPanel.Top*YRatio);
  MapLegendRec.TitleBottomAt[6]:=TestTextSize.cx;
  MapLegendRec.TitleBottomAt[7]:=MapLegendRec.TitleBottomCount*TestTextSize.cy;
End;

procedure TPrintLayoutForm.CheckAuthorBottom;
var
  TestTextSize:TSize;
  WKeep, Width,Widest,I:Integer;
Begin
{  LegendTestImage.Canvas.Font:=MapLegendRec.AuthorBottomFont;}
      Preview1.Paper.SetFont(
       MapLegendRec.AuthorBottomFont.Name,
       MapLegendRec.AuthorBottomFont.Size,
       MapLegendRec.AuthorBottomFont.Style,
       MapLegendRec.AuthorBottomFont.Color);
  Widest:=0;WKeep:=0;
  For I:=0 to MapLegendRec.AuthorBottomCount-1 do
  begin
    Width:= Length(MapLegendRec.AuthorBottom[I]);
    If Width>Widest then
    begin
      Widest:= Width;
      WKeep:=i;
    end;
  end;
  TestTextSize := Preview1.Paper.TextExtent(MapLegendRec.AuthorBottom[WKeep]);
  AuthorBPanel.Width:=  Round(TestTextSize.cx/XRatio);
  AuthorBPanel.Height:=
    Round((MapLegendRec.AuthorBottomCount*TestTextSize.cy)/YRatio);
ObjectSizeWEdit.Text:=Inttostr(TestTextSize.cx);
ObjectSizeHEdit.Text:=Inttostr(TestTextSize.cy);
  MapLegendRec.AuthorBottomAt[0]:=AuthorBPanel.Left;
  MapLegendRec.AuthorBottomAt[1]:=AuthorBPanel.Top;
  MapLegendRec.AuthorBottomAt[2]:=AuthorBPanel.Width;
  MapLegendRec.AuthorBottomAt[3]:=AuthorBPanel.Height;
  MapLegendRec.AuthorBottomAt[4]:=Round(AuthorBPanel.Left*XRatio);
  MapLegendRec.AuthorBottomAt[5]:=Round(AuthorBPanel.Top*YRatio);
  MapLegendRec.AuthorBottomAt[6]:=TestTextSize.cx;
  MapLegendRec.AuthorBottomAt[7]:=MapLegendRec.AuthorBottomCount*TestTextSize.cy;
End;

procedure TPrintLayoutForm.CheckSource;
var
  TestTextSize:TSize;
  WKeep, Width,Widest,I:Integer;
Begin
{  LegendTestImage.Canvas.Font:=MapLegendRec.SourceFont;}
      Preview1.Paper.SetFont(
       MapLegendRec.SourceFont.Name,
       MapLegendRec.SourceFont.Size,
       MapLegendRec.SourceFont.Style,
       MapLegendRec.SourceFont.Color);
  Widest:=0;WKeep:=0;
  For I:=0 to MapLegendRec.SourceCount-1 do
  begin
    Width:= Length(MapLegendRec.Source[I]);
    If Width>Widest then
    begin
      Widest:= Width;
      WKeep:=i;
    end;
  end;
  TestTextSize := Preview1.Paper.TextExtent(MapLegendRec.Source[WKeep]);
  SourcePanel.Width:=  Round(TestTextSize.cx/XRatio);
  SourcePanel.Height:=
     Round((MapLegendRec.SourceCount*TestTextSize.cy)/YRatio);
ObjectSizeWEdit.Text:=Inttostr(TestTextSize.cx);
ObjectSizeHEdit.Text:=Inttostr(TestTextSize.cy);
  MapLegendRec.SourceAt[0]:=SourcePanel.Left;
  MapLegendRec.SourceAt[1]:=SourcePanel.Top;
  MapLegendRec.SourceAt[2]:=SourcePanel.Width;
  MapLegendRec.SourceAt[3]:=SourcePanel.Height;
  MapLegendRec.SourceAt[4]:=Round(SourcePanel.Left*XRatio);
  MapLegendRec.SourceAt[5]:=Round(SourcePanel.Top*YRatio);
  MapLegendRec.SourceAt[6]:=TestTextSize.cx;
  MapLegendRec.SourceAt[7]:=MapLegendRec.SourceCount*TestTextSize.cy;
End;

procedure TPrintLayoutForm.CheckFeatureText;
var
  TestTextSize:TSize;
  WKeep, Width,Widest,I:Integer;
Begin
{  LegendTestImage.Canvas.Font:=MapLegendRec.FeatureTextFont; }
      Preview1.Paper.SetFont(
       MapLegendRec.FeatureTextFont.Name,
       MapLegendRec.FeatureTextFont.Size,
       MapLegendRec.FeatureTextFont.Style,
       MapLegendRec.FeatureTextFont.Color);
  Widest:=0;WKeep:=0;
  For I:=0 to MapLegendRec.FeatureTextCount-1 do
  begin
    Width:= Length(MapLegendRec.FeatureText[I]);
    If Width>Widest then
    begin
      Widest:= Width;
      WKeep:=i;
    end;
  end;
  TestTextSize := Preview1.Paper.TextExtent(MapLegendRec.FeatureText[WKeep]);
  FeatureTextPanel.Width:=  Round(TestTextSize.cx/XRatio);
  FeatureTextPanel.Height:=
    Round((MapLegendRec.FeatureTextCount*TestTextSize.cy)/YRatio);
ObjectSizeWEdit.Text:=Inttostr(TestTextSize.cx);
ObjectSizeHEdit.Text:=Inttostr(TestTextSize.cy);
  MapLegendRec.FeatureTextAt[0]:=FeatureTextPanel.Left;
  MapLegendRec.FeatureTextAt[1]:=FeatureTextPanel.Top;
  MapLegendRec.FeatureTextAt[2]:=FeatureTextPanel.Width;
  MapLegendRec.FeatureTextAt[3]:=FeatureTextPanel.Height;
  MapLegendRec.FeatureTextAt[4]:=Round(FeatureTextPanel.Left*XRatio);
  MapLegendRec.FeatureTextAt[5]:=Round(FeatureTextPanel.Top*YRatio);
  MapLegendRec.FeatureTextAt[6]:=TestTextSize.cx;
  MapLegendRec.FeatureTextAt[7]:=MapLegendRec.FeatureTextCount*TestTextSize.cy;
End;

procedure TPrintLayoutForm.CheckNorthArrowText;
var
  TestTextSize:TSize;
  WKeep, Width,Widest,I:Integer;
Begin
{  LegendTestImage.Canvas.Font:=MapLegendRec.NorthArrowTextFont; }
      Preview1.Paper.SetFont(
       MapLegendRec.NorthArrowTextFont.Name,
       MapLegendRec.NorthArrowTextFont.Size,
       MapLegendRec.NorthArrowTextFont.Style,
       MapLegendRec.NorthArrowTextFont.Color);
  Widest:=0;WKeep:=0;
  For I:=0 to MapLegendRec.NorthArrowTextCount-1 do
  begin
    Width:= Length(MapLegendRec.NorthArrowText[I]);
    If Width>Widest then
    begin
      Widest:= Width;
      WKeep:=i;
    end;
  end;
  TestTextSize := Preview1.Paper.TextExtent(MapLegendRec.NorthArrowText[WKeep]);
  NorthTextPanel.Width:=  Round(TestTextSize.cx/XRatio);
  NorthTextPanel.Height:=
    Round((MapLegendRec.NorthArrowTextCount*TestTextSize.cy)/YRatio);
ObjectSizeWEdit.Text:=Inttostr(TestTextSize.cx);
ObjectSizeHEdit.Text:=Inttostr(TestTextSize.cy);
  MapLegendRec.NorthArrowTextAt[0]:=NorthTextPanel.Left;
  MapLegendRec.NorthArrowTextAt[1]:=NorthTextPanel.Top;
  MapLegendRec.NorthArrowTextAt[2]:=NorthTextPanel.Width;
  MapLegendRec.NorthArrowTextAt[3]:=NorthTextPanel.Height;
  MapLegendRec.NorthArrowTextAt[4]:=Round(NorthTextPanel.Left*XRatio);
  MapLegendRec.NorthArrowTextAt[5]:=Round(NorthTextPanel.Top*YRatio);
  MapLegendRec.NorthArrowTextAt[6]:=TestTextSize.cx;
  MapLegendRec.NorthArrowTextAt[7]:=MapLegendRec.NorthArrowTextCount*TestTextSize.cy;
End;

procedure TPrintLayoutForm.CheckContourInterval;
var
  TestTextSize:TSize;
  WKeep, Width,Widest,I:Integer;
Begin
{  LegendTestImage.Canvas.Font:=MapLegendRec.ContourIntervalFont;}
      Preview1.Paper.SetFont(
       MapLegendRec.ContourIntervalFont.Name,
       MapLegendRec.ContourIntervalFont.Size,
       MapLegendRec.ContourIntervalFont.Style,
       MapLegendRec.ContourIntervalFont.Color);
  Widest:=0;WKeep:=0;
  For I:=0 to MapLegendRec.ContourIntervalCount-1 do
  begin
    Width:= Length(MapLegendRec.ContourInterval[I]);
    If Width>Widest then
    begin
      Widest:= Width;
      WKeep:=i;
    end;
  end;
  TestTextSize := Preview1.Paper.TextExtent(MapLegendRec.ContourInterval[WKeep]);
  ContourPanel.Width:=  Round(TestTextSize.cx/XRatio);
  ContourPanel.Height:=
     Round((MapLegendRec.ContourIntervalCount*TestTextSize.cy)/YRatio);
ObjectSizeWEdit.Text:=Inttostr(TestTextSize.cx);
ObjectSizeHEdit.Text:=Inttostr(TestTextSize.cy);
  MapLegendRec.ContourIntervalAt[0]:=ContourPanel.Left;
  MapLegendRec.ContourIntervalAt[1]:=ContourPanel.Top;
  MapLegendRec.ContourIntervalAt[2]:=ContourPanel.Width;
  MapLegendRec.ContourIntervalAt[3]:=ContourPanel.Height;
  MapLegendRec.ContourIntervalAt[4]:=Round(ContourPanel.Left*XRatio);
  MapLegendRec.ContourIntervalAt[5]:=Round(ContourPanel.Top*YRatio);
  MapLegendRec.ContourIntervalAt[6]:=TestTextSize.cx;
  MapLegendRec.ContourIntervalAt[7]:=MapLegendRec.ContourIntervalCount*TestTextSize.cy;
End;

procedure TPrintLayoutForm.CheckMapLocation;
Begin
  MapLocoPanel.Width:=  Round(MapLegendRec.ContourIntervalAt[6]/XRatio);
  MapLocoPanel.Height:=  Round(MapLegendRec.ContourIntervalAt[7]/YRatio);
  MapLegendRec.ContourIntervalAt[0]:=MapLocoPanel.Left;
  MapLegendRec.ContourIntervalAt[1]:=MapLocoPanel.Top;
  MapLegendRec.ContourIntervalAt[2]:=MapLocoPanel.Width;
  MapLegendRec.ContourIntervalAt[3]:=MapLocoPanel.Height;
  MapLegendRec.ContourIntervalAt[4]:=Round(MapLocoPanel.Left*XRatio);
  MapLegendRec.ContourIntervalAt[5]:=Round(MapLocoPanel.Top*YRatio);
ObjectSizeWEdit.Text:=Inttostr(MapLegendRec.ContourIntervalAt[6]);
ObjectSizeHEdit.Text:=Inttostr(MapLegendRec.ContourIntervalAt[7]);
{6&7 from Bitmap}
End;

procedure TPrintLayoutForm.CheckNorthArrow;
Begin
  NorthBitPanel.Width:=  Round(MapLegendRec.NorthArrowBitAt[6]/XRatio);
  NorthBitPanel.Height:=  Round(MapLegendRec.NorthArrowBitAt[7]/YRatio);
  MapLegendRec.NorthArrowBitAt[0]:=NorthBitPanel.Left;
  MapLegendRec.NorthArrowBitAt[1]:=NorthBitPanel.Top;
  MapLegendRec.NorthArrowBitAt[2]:=NorthBitPanel.Width;
  MapLegendRec.NorthArrowBitAt[3]:=NorthBitPanel.Height;
  MapLegendRec.NorthArrowBitAt[4]:=Round(NorthBitPanel.Left*XRatio);
  MapLegendRec.NorthArrowBitAt[5]:=Round(NorthBitPanel.Top*YRatio);
ObjectSizeWEdit.Text:=Inttostr(MapLegendRec.NorthArrowBitAt[6]);
ObjectSizeHEdit.Text:=Inttostr(MapLegendRec.NorthArrowBitAt[7]);
{6&7 from Bitmap}
End;

procedure TPrintLayoutForm.CheckLegend;
Begin
  LegendaryPanel.Width:=  Round(MapLegendRec.LegendAt[6]/XRatio);
  LegendaryPanel.Height:=  Round(MapLegendRec.LegendAt[7]/YRatio);
  MapLegendRec.LegendAt[0]:=LegendaryPanel.Left;
  MapLegendRec.LegendAt[1]:=LegendaryPanel.Top;
  MapLegendRec.LegendAt[2]:=LegendaryPanel.Width;
  MapLegendRec.LegendAt[3]:=LegendaryPanel.Height;
  MapLegendRec.LegendAt[4]:=Round(LegendaryPanel.Left*XRatio);
  MapLegendRec.LegendAt[5]:=Round(LegendaryPanel.Top*YRatio);
ObjectSizeWEdit.Text:=Inttostr(MapLegendRec.LegendAt[6]);
ObjectSizeHEdit.Text:=Inttostr(MapLegendRec.LegendAt[7]);
{6&7 from Bitmap}
End;

procedure TPrintLayoutForm.CheckScale;
Begin
  ScalePanel.Width:=  Round(MapLegendRec.ScalebarsAt[6]/XRatio);
  ScalePanel.Height:=  Round(MapLegendRec.ScalebarsAt[7]/YRatio);
  MapLegendRec.ScalebarsAt[0]:=ScalePanel.Left;
  MapLegendRec.ScalebarsAt[1]:=ScalePanel.Top;
  MapLegendRec.ScalebarsAt[2]:=ScalePanel.Width;
  MapLegendRec.ScalebarsAt[3]:=ScalePanel.Height;
  MapLegendRec.ScalebarsAt[4]:=Round(ScalePanel.Left*XRatio);
  MapLegendRec.ScalebarsAt[5]:=Round(ScalePanel.Top*YRatio);
ObjectSizeWEdit.Text:=Inttostr(MapLegendRec.ScalebarsAt[6]);
ObjectSizeHEdit.Text:=Inttostr(MapLegendRec.ScalebarsAt[7]);
{6&7 from Bitmap}
End;

procedure TPrintLayoutForm.CheckFeatureBitmap;
Begin
  FeatureBitmapPanel.Width:=  Round(MapLegendRec.FeatureBitmapAt[6]/XRatio);
  FeatureBitmapPanel.Height:=  Round(MapLegendRec.FeatureBitmapAt[7]/YRatio);
  MapLegendRec.FeatureBitmapAt[0]:=FeatureBitmapPanel.Left;
  MapLegendRec.FeatureBitmapAt[1]:=FeatureBitmapPanel.Top;
  MapLegendRec.FeatureBitmapAt[2]:=FeatureBitmapPanel.Width;
  MapLegendRec.FeatureBitmapAt[3]:=FeatureBitmapPanel.Height;
  MapLegendRec.FeatureBitmapAt[4]:=Round(FeatureBitmapPanel.Left*XRatio);
  MapLegendRec.FeatureBitmapAt[5]:=Round(FeatureBitmapPanel.Top*YRatio);
ObjectSizeWEdit.Text:=Inttostr(MapLegendRec.FeatureBitmapAt[6]);
ObjectSizeHEdit.Text:=Inttostr(MapLegendRec.FeatureBitmapAt[7]);
{6&7 from Bitmap}
End;

procedure TPrintLayoutForm.CheckMap;
Begin
MapLegendRec.MapAt[6]:=VoEditForm.ShapeViewImage.Width;
MapLegendRec.MapAt[7]:=VoEditForm.ShapeViewImage.Height;
  MapPanel.Width:=  Round(MapLegendRec.MapAt[6]/XRatio);
  MapPanel.Height:=  Round(MapLegendRec.MapAt[7]/YRatio);
  MapLegendRec.MapAt[0]:=MapPanel.Left;
  MapLegendRec.MapAt[1]:=MapPanel.Top;
  MapLegendRec.MapAt[2]:=MapPanel.Width;
  MapLegendRec.MapAt[3]:=MapPanel.Height;
  MapLegendRec.MapAt[4]:=Round(MapPanel.Left*XRatio);
  MapLegendRec.MapAt[5]:=Round(MapPanel.Top*YRatio);
ObjectSizeWEdit.Text:=Inttostr(MapLegendRec.MapAt[6]);
ObjectSizeHEdit.Text:=Inttostr(MapLegendRec.MapAt[7]);
{6&7 from Bitmap}
End;
(***********************************************************)
{MapLegendRec.MapAt[0]:=10;MapLegendRec.MapAt[1]:=24;
MapLegendRec.MapAt[6]:=VoEditForm.ShapeViewImage.Width;
MapLegendRec.MapAt[7]:=VoEditForm.ShapeViewImage.Height;
ImageHeightSM.Caption:=Inttostr(VoEditForm.ShapeViewImage.Height);
ImageWidthSM.Caption:=Inttostr(VoEditForm.ShapeViewImage.Width);}
(***********************************************************)
procedure TPrintLayoutForm.TitleSeriesTopCBClick(Sender: TObject);
begin
{  TitleSeriesTopCB.Checked:= (not TitleSeriesTopCB.Checked);  }
  TitleTPanel.Visible:=TitleSeriesTopCB.Checked;
  MapLegendRec.TitleTopOn:=TitleSeriesTopCB.Checked;
end;

procedure TPrintLayoutForm.AuthorTopCBClick(Sender: TObject);
begin
{  AuthorTopCB.Checked:= (not AuthorTopCB.Checked);}
  AuthorTPanel.Visible:=AuthorTopCB.Checked;
  MapLegendRec.AuthorTopOn:=AuthorTopCB.Checked;
end;

procedure TPrintLayoutForm.TitleSeriesBotmCBClick(Sender: TObject);
begin
{ TitleSeriesBotmCB.Checked:= (not TitleSeriesBotmCB.Checked);}
  TitleBPanel.Visible:=TitleSeriesBotmCB.Checked;
  MapLegendRec.TitleBottomOn:=TitleSeriesBotmCB.Checked;
end;

procedure TPrintLayoutForm.AuthorBotmCBClick(Sender: TObject);
begin
{  AuthorBotmCB.Checked:= (not AuthorBotmCB.Checked);}
  AuthorBPanel.Visible:=AuthorBotmCB.Checked;
  MapLegendRec.AuthorBottomOn:=AuthorBotmCB.Checked;
end;

procedure TPrintLayoutForm.SourceProjectionCBClick(Sender: TObject);
begin
{  SourceProjectionCB.Checked:= (not SourceProjectionCB.Checked);}
  SourcePanel.Visible:=SourceProjectionCB.Checked;
  MapLegendRec.SourceOn:=SourceProjectionCB.Checked;
end;

procedure TPrintLayoutForm.FeatureTextCBClick(Sender: TObject);
begin
{  FeatureTextCB.Checked:= (not FeatureTextCB.Checked);}
  FeatureTextPanel.Visible:=FeatureTextCB.Checked;
  MapLegendRec.FeatureTextOn:=FeatureTextCB.Checked;
end;

procedure TPrintLayoutForm.MapLocationCBClick(Sender: TObject);
begin
{ MapLocationCB.Checked:= (not MapLocationCB.Checked);}
  MapLocoPanel.Visible:=MapLocationCB.Checked;
  MapLegendRec.MapLocationOn:=MapLocationCB.Checked;
end;

procedure TPrintLayoutForm.GridCBClick(Sender: TObject);
begin
{  GridCB.Checked:= (not GridCB.Checked);}
  MapLegendRec.GridOn:=GridCB.Checked;
end;

procedure TPrintLayoutForm.NorthArrowCBClick(Sender: TObject);
begin
{  NorthArrowCB.Checked:= (not NorthArrowCB.Checked);}
  NorthBitPanel.Visible:=NorthArrowCB.Checked;
  MapLegendRec.NorthArrowBitOn:=NorthArrowCB.Checked;
end;

procedure TPrintLayoutForm.NATextCBClick(Sender: TObject);
begin
{  NATextCB.Checked:= (not NATextCB.Checked);}
  NorthTextPanel.Visible:=NATextCB.Checked;
  MapLegendRec.NorthArrowTextOn:=NATextCB.Checked;
end;

procedure TPrintLayoutForm.LegendCBClick(Sender: TObject);
begin
{  LegendCB.Checked:= (not LegendCB.Checked);}
  LegendaryPanel.Visible:=LegendCB.Checked;
  MapLegendRec.LegendOn:=LegendCB.Checked;
end;

procedure TPrintLayoutForm.ScaleCBClick(Sender: TObject);
begin
{  ScaleCB.Checked:= (not ScaleCB.Checked);}
  ScalePanel.Visible:=ScaleCB.Checked;
  MapLegendRec.ScalebarsOn:=ScaleCB.Checked;
end;

procedure TPrintLayoutForm.ContourCBClick(Sender: TObject);
begin
{  ContourCB.Checked:= (not ContourCB.Checked);}
  ContourPanel.Visible:=ContourCB.Checked;
  MapLegendRec.ContourIntervalOn:=ContourCB.Checked;
end;

procedure TPrintLayoutForm.FeatureBitmapCBClick(Sender: TObject);
begin
{  FeatureBitmapCB.Checked:= (not FeatureBitmapCB.Checked);}
  FeatureBitmapPanel.Visible:=FeatureBitmapCB.Checked;
  MapLegendRec.FeatureBitmapOn:=FeatureBitmapCB.Checked;
end;
(***********************************************************)
(***********************************************************)

procedure TPrintLayoutForm.SetDataToForm;
begin
  MapPanel.Left:=MapLegendRec.MapAt[0];
  MapPanel.Top:= MapLegendRec.MapAt[1];
  MapPanel.Width:= MapLegendRec.MapAt[2];
  MapPanel.Height:= MapLegendRec.MapAt[3];

  TitleTPanel.Left:=  MapLegendRec.TitleTopAt[0];
  TitleTPanel.Top:=  MapLegendRec.TitleTopAt[1];
  TitleTPanel.Width:=  MapLegendRec.TitleTopAt[2];
  TitleTPanel.Height:=  MapLegendRec.TitleTopAt[3];

  AuthorTPanel.Left:=  MapLegendRec.AuthorTopAt[0];
  AuthorTPanel.Top:=  MapLegendRec.AuthorTopAt[1];
  AuthorTPanel.Width:=  MapLegendRec.AuthorTopAt[2];
  AuthorTPanel.Height:=  MapLegendRec.AuthorTopAt[3];

  TitleBPanel.Left:=  MapLegendRec.TitleBottomAt[0];
  TitleBPanel.Top:=  MapLegendRec.TitleBottomAt[1];
  TitleBPanel.Width:=  MapLegendRec.TitleBottomAt[2];
  TitleBPanel.Height:=  MapLegendRec.TitleBottomAt[3];

  AuthorBPanel.Left:=  MapLegendRec.AuthorBottomAt[0];
  AuthorBPanel.Top:=  MapLegendRec.AuthorBottomAt[1];
  AuthorBPanel.Width:=  MapLegendRec.AuthorBottomAt[2];
  AuthorBPanel.Height:=  MapLegendRec.AuthorBottomAt[3];

  SourcePanel.Left:=  MapLegendRec.SourceAt[0];
  SourcePanel.Top:=  MapLegendRec.SourceAt[1];
  SourcePanel.Width:=  MapLegendRec.SourceAt[2];
  SourcePanel.Height:=  MapLegendRec.SourceAt[3];

  FeatureTextPanel.Left:=  MapLegendRec.FeatureTextAt[0];
  FeatureTextPanel.Top:=  MapLegendRec.FeatureTextAt[1];
  FeatureTextPanel.Width:=  MapLegendRec.FeatureTextAt[2];
  FeatureTextPanel.Height:=   MapLegendRec.FeatureTextAt[3];

  NorthTextPanel.Left:=  MapLegendRec.NorthArrowTextAt[0];
  NorthTextPanel.Top:=  MapLegendRec.NorthArrowTextAt[1];
  NorthTextPanel.Width:=  MapLegendRec.NorthArrowTextAt[2];
  NorthTextPanel.Height:=  MapLegendRec.NorthArrowTextAt[3];

  ContourPanel.Left:=  MapLegendRec.ContourIntervalAt[0];
  ContourPanel.Top:=  MapLegendRec.ContourIntervalAt[1];
  ContourPanel.Width:=  MapLegendRec.ContourIntervalAt[2];
  ContourPanel.Height:=  MapLegendRec.ContourIntervalAt[3];

  MapLocoPanel.Left:=  MapLegendRec.ContourIntervalAt[0];
  MapLocoPanel.Top:=  MapLegendRec.ContourIntervalAt[1];
  MapLocoPanel.Width:=  MapLegendRec.ContourIntervalAt[2];
  MapLocoPanel.Height:=  MapLegendRec.ContourIntervalAt[3];

  NorthBitPanel.Left:=  MapLegendRec.NorthArrowBitAt[0];
  NorthBitPanel.Top:=  MapLegendRec.NorthArrowBitAt[1];
  NorthBitPanel.Width:=  MapLegendRec.NorthArrowBitAt[2];
  NorthBitPanel.Height:=  MapLegendRec.NorthArrowBitAt[3];

  LegendaryPanel.Left:=  MapLegendRec.LegendAt[0];
  LegendaryPanel.Top:=  MapLegendRec.LegendAt[1];
  LegendaryPanel.Width:=  MapLegendRec.LegendAt[2];
  LegendaryPanel.Height:=  MapLegendRec.LegendAt[3];

  ScalePanel.Left:=  MapLegendRec.ScalebarsAt[0];
  ScalePanel.Top:=  MapLegendRec.ScalebarsAt[1];
  ScalePanel.Width:=  MapLegendRec.ScalebarsAt[2];
  ScalePanel.Height:=  MapLegendRec.ScalebarsAt[3];

  FeatureBitmapPanel.Left:=  MapLegendRec.FeatureBitmapAt[0];
  FeatureBitmapPanel.Top:=  MapLegendRec.FeatureBitmapAt[1];
  FeatureBitmapPanel.Width:= MapLegendRec.FeatureBitmapAt[2];
  FeatureBitmapPanel.Height:= MapLegendRec.FeatureBitmapAt[3];
end;

(***********************************************************)
(***********************************************************)
procedure TPrintLayoutForm.SetupPrinterBtnClick(Sender: TObject);
begin
{  PrinterSetupDialog1.Execute;}

XRatio:=(Preview1.Paper.PrinterSetup.PaperWidth_MM
         * Preview1.Paper.PrinterSetup.PixelsPerMM_byX );
YRatio:=(Preview1.Paper.PrinterSetup.PaperHeight_MM
         * Preview1.Paper.PrinterSetup.PixelsPerMM_byY );

{         Preview1.Paper.PrinterSetup.Orientation}

    BaseMapPanel.Height :=  Preview1.Paper.PrinterSetup.PaperHeight_MM;
    {216;}    {round(Printer.PageHeight / 13.77);}
    BaseMapPanel.Width := Preview1.Paper.PrinterSetup.PaperWidth_MM;
    {279;}{ round(Printer.PageWidth / 13.77) ;}

  if (Preview1.Paper.PrinterSetup.Orientation = poPortrait) then
  begin
{    Printer.Orientation := poPortrait;}
    BaseMapPanel.Top := 160;
    BaseMapPanel.Left := 8;
MapLegendRec.PaperSizeAt[0]:=BaseMapPanel.Left;
MapLegendRec.PaperSizeAt[1]:=BaseMapPanel.Top;
MapLegendRec.PaperSizeAt[2]:=BaseMapPanel.Width;
MapLegendRec.PaperSizeAt[3]:=BaseMapPanel.Height;
{MapLegendRec.PaperSizeAt[4]:=0;MapLegendRec.PaperSizeAt[5]:=0;MapLegendRec.PaperSizeAt[6]:=0;MapLegendRec.PaperSizeAt[7]:=0;}

MapLegendRec.TitleTopAt[0]:=88;MapLegendRec.TitleTopAt[1]:=4;MapLegendRec.TitleTopAt[2]:=49;MapLegendRec.TitleTopAt[3]:=13;
{MapLegendRec.TitleTopAt[4]:=0;MapLegendRec.TitleTopAt[5]:=0;MapLegendRec.TitleTopAt[6]:=0;MapLegendRec.TitleTopAt[7]:=0;}
MapLegendRec.AuthorTopAt[0]:=10;MapLegendRec.AuthorTopAt[1]:=4;MapLegendRec.AuthorTopAt[2]:=57;MapLegendRec.AuthorTopAt[3]:=13;
{MapLegendRec.AuthorTopAt[4]:=0;MapLegendRec.AuthorTopAt[5]:=0;MapLegendRec.AuthorTopAt[6]:=0;MapLegendRec.AuthorTopAt[7]:=0;}
MapLegendRec.TitleBottomAt[0]:=94;MapLegendRec.TitleBottomAt[1]:=177;MapLegendRec.TitleBottomAt[2]:=41;MapLegendRec.TitleBottomAt[3]:=13;
{MapLegendRec.TitleBottomAt[4]:=0;MapLegendRec.TitleBottomAt[5]:=0;MapLegendRec.TitleBottomAt[6]:=0;MapLegendRec.TitleBottomAt[7]:=0;}
MapLegendRec.AuthorBottomAt[0]:=10;MapLegendRec.AuthorBottomAt[1]:=177;MapLegendRec.AuthorBottomAt[2]:=65;MapLegendRec.AuthorBottomAt[3]:=13;
{MapLegendRec.AuthorBottomAt[4]:=0;MapLegendRec.AuthorBottomAt[5]:=0;MapLegendRec.AuthorBottomAt[6]:=0;MapLegendRec.AuthorBottomAt[7]:=0;}
MapLegendRec.SourceAt[0]:=10;MapLegendRec.SourceAt[1]:=192;MapLegendRec.SourceAt[2]:=46;MapLegendRec.SourceAt[3]:=31;
{MapLegendRec.SourceAt[4]:=0;MapLegendRec.SourceAt[5]:=0;MapLegendRec.SourceAt[6]:=0;MapLegendRec.SourceAt[7]:=0;}
MapLegendRec.FeatureTextAt[0]:=56;MapLegendRec.FeatureTextAt[1]:=150;MapLegendRec.FeatureTextAt[2]:=44;MapLegendRec.FeatureTextAt[3]:=14;
{MapLegendRec.FeatureTextAt[4]:=0;MapLegendRec.FeatureTextAt[5]:=0;MapLegendRec.FeatureTextAt[6]:=0;MapLegendRec.FeatureTextAt[7]:=0;}
MapLegendRec.NorthArrowTextAt[0]:=140;MapLegendRec.NorthArrowTextAt[1]:=134;MapLegendRec.NorthArrowTextAt[2]:=17;MapLegendRec.NorthArrowTextAt[3]:=17;
{MapLegendRec.NorthArrowTextAt[4]:=0;MapLegendRec.NorthArrowTextAt[5]:=0;MapLegendRec.NorthArrowTextAt[6]:=0;MapLegendRec.NorthArrowTextAt[7]:=0;}
MapLegendRec.ContourIntervalAt[0]:=58;MapLegendRec.ContourIntervalAt[1]:=210;MapLegendRec.ContourIntervalAt[2]:=41;MapLegendRec.ContourIntervalAt[3]:=13;
{MapLegendRec.ContourIntervalAt[4]:=0;MapLegendRec.ContourIntervalAt[5]:=0;MapLegendRec.ContourIntervalAt[6]:=0;MapLegendRec.ContourIntervalAt[7]:=0;}

MapLegendRec.NorthArrowBitAt[0]:=140;MapLegendRec.NorthArrowBitAt[1]:=120;MapLegendRec.NorthArrowBitAt[2]:=17;MapLegendRec.NorthArrowBitAt[3]:=11;
{MapLegendRec.NorthArrowBitAt[4]:=0;MapLegendRec.NorthArrowBitAt[5]:=0;MapLegendRec.NorthArrowBitAt[6]:=0;MapLegendRec.NorthArrowBitAt[7]:=0;}
MapLegendRec.LegendAt[0]:=120;MapLegendRec.LegendAt[1]:=192;MapLegendRec.LegendAt[2]:=44;MapLegendRec.LegendAt[3]:=25;
{MapLegendRec.LegendAt[4]:=0;MapLegendRec.LegendAt[5]:=0;MapLegendRec.LegendAt[6]:=0;MapLegendRec.LegendAt[7]:=0;}

MapLegendRec.MapAt[6]:=VoEditForm.ShapeViewImage.Width;
MapLegendRec.MapAt[7]:=VoEditForm.ShapeViewImage.Height;
MapLegendRec.MapAt[0]:=10;MapLegendRec.MapAt[1]:=18;
MapLegendRec.MapAt[2]:=127;MapLegendRec.MapAt[3]:=158;

{MapLegendRec.MapAt[4]:=0;MapLegendRec.MapAt[5]:=0;MapLegendRec.MapAt[6]:=0;MapLegendRec.MapAt[7]:=0;}
MapLegendRec.MapLocationAt[0]:=140;MapLegendRec.MapLocationAt[1]:=154;MapLegendRec.MapLocationAt[2]:=17;MapLegendRec.MapLocationAt[3]:=17;
{MapLegendRec.MapLocationAt[4]:=0;MapLegendRec.MapLocationAt[5]:=0;MapLegendRec.MapLocationAt[6]:=0;MapLegendRec.MapLocationAt[7]:=0;}
MapLegendRec.ScalebarsAt[0]:=58;MapLegendRec.ScalebarsAt[1]:=192;MapLegendRec.ScalebarsAt[2]:=57;MapLegendRec.ScalebarsAt[3]:=17;
{MapLegendRec.ScalebarsAt[4]:=0;MapLegendRec.ScalebarsAt[5]:=0;MapLegendRec.ScalebarsAt[6]:=0;MapLegendRec.ScalebarsAt[7]:=0;}
MapLegendRec.FeatureBitmapAt[0]:=56;MapLegendRec.FeatureBitmapAt[1]:=130;MapLegendRec.FeatureBitmapAt[2]:=65;MapLegendRec.FeatureBitmapAt[3]:=18;
{MapLegendRec.FeatureBitmapAt[4]:=0;MapLegendRec.FeatureBitmapAt[4]:=0;MapLegendRec.FeatureBitmapAt[6]:=0;MapLegendRec.FeatureBitmapAt[7]:=0;}
   end else
  begin
{    Printer.Orientation := poLandscape; }
    BaseMapPanel.Top := 160;
    BaseMapPanel.Left := 8;

MapLegendRec.PaperSizeAt[0]:=BaseMapPanel.Left;
MapLegendRec.PaperSizeAt[1]:=BaseMapPanel.Top;
MapLegendRec.PaperSizeAt[2]:=BaseMapPanel.Width;
MapLegendRec.PaperSizeAt[3]:=BaseMapPanel.Height;
{MapLegendRec.PaperSizeAt[4]:=0;MapLegendRec.PaperSizeAt[5]:=0;MapLegendRec.PaperSizeAt[6]:=0;MapLegendRec.PaperSizeAt[7]:=0;}

MapLegendRec.TitleTopAt[0]:=160;MapLegendRec.TitleTopAt[1]:=8;MapLegendRec.TitleTopAt[2]:=49;MapLegendRec.TitleTopAt[3]:=13;
{MapLegendRec.TitleTopAt[4]:=0;MapLegendRec.TitleTopAt[5]:=0;MapLegendRec.TitleTopAt[6]:=0;MapLegendRec.TitleTopAt[7]:=0;}
MapLegendRec.AuthorTopAt[0]:=8;MapLegendRec.AuthorTopAt[1]:=8;MapLegendRec.AuthorTopAt[2]:=57;MapLegendRec.AuthorTopAt[3]:=13;
{MapLegendRec.AuthorTopAt[4]:=0;MapLegendRec.AuthorTopAt[5]:=0;MapLegendRec.AuthorTopAt[6]:=0;MapLegendRec.AuthorTopAt[7]:=0;}
MapLegendRec.TitleBottomAt[0]:=122;MapLegendRec.TitleBottomAt[1]:=155;MapLegendRec.TitleBottomAt[2]:=41;MapLegendRec.TitleBottomAt[3]:=13;
{MapLegendRec.TitleBottomAt[4]:=0;MapLegendRec.TitleBottomAt[5]:=0;MapLegendRec.TitleBottomAt[6]:=0;MapLegendRec.TitleBottomAt[7]:=0;}
MapLegendRec.AuthorBottomAt[0]:=8;MapLegendRec.AuthorBottomAt[1]:=155;MapLegendRec.AuthorBottomAt[2]:=65;MapLegendRec.AuthorBottomAt[3]:=13;
{MapLegendRec.AuthorBottomAt[4]:=0;MapLegendRec.AuthorBottomAt[5]:=0;MapLegendRec.AuthorBottomAt[6]:=0;MapLegendRec.AuthorBottomAt[7]:=0;}
MapLegendRec.SourceAt[0]:=170;MapLegendRec.SourceAt[1]:=66;MapLegendRec.SourceAt[2]:=46;MapLegendRec.SourceAt[3]:=31;
{MapLegendRec.SourceAt[4]:=0;MapLegendRec.SourceAt[5]:=0;MapLegendRec.SourceAt[6]:=0;MapLegendRec.SourceAt[7]:=0;}
MapLegendRec.FeatureTextAt[0]:=112;MapLegendRec.FeatureTextAt[1]:=135;MapLegendRec.FeatureTextAt[2]:=44;MapLegendRec.FeatureTextAt[3]:=14;
{MapLegendRec.FeatureTextAt[4]:=0;MapLegendRec.FeatureTextAt[5]:=0;MapLegendRec.FeatureTextAt[6]:=0;MapLegendRec.FeatureTextAt[7]:=0;}
MapLegendRec.NorthArrowTextAt[0]:=170;MapLegendRec.NorthArrowTextAt[1]:=150;MapLegendRec.NorthArrowTextAt[2]:=17;MapLegendRec.NorthArrowTextAt[3]:=17;
{MapLegendRec.NorthArrowTextAt[4]:=0;MapLegendRec.NorthArrowTextAt[5]:=0;MapLegendRec.NorthArrowTextAt[6]:=0;MapLegendRec.NorthArrowTextAt[7]:=0;}
MapLegendRec.ContourIntervalAt[0]:=170;MapLegendRec.ContourIntervalAt[1]:=120;MapLegendRec.ContourIntervalAt[2]:=41;MapLegendRec.ContourIntervalAt[3]:=13;
{MapLegendRec.ContourIntervalAt[4]:=0;MapLegendRec.ContourIntervalAt[5]:=0;MapLegendRec.ContourIntervalAt[6]:=0;MapLegendRec.ContourIntervalAt[7]:=0;}

MapLegendRec.NorthArrowBitAt[0]:=170;MapLegendRec.NorthArrowBitAt[1]:=137;MapLegendRec.NorthArrowBitAt[2]:=17;MapLegendRec.NorthArrowBitAt[3]:=11;
{MapLegendRec.NorthArrowBitAt[4]:=0;MapLegendRec.NorthArrowBitAt[5]:=0;MapLegendRec.NorthArrowBitAt[6]:=0;MapLegendRec.NorthArrowBitAt[7]:=0;}
MapLegendRec.LegendAt[0]:=170;MapLegendRec.LegendAt[1]:=36;MapLegendRec.LegendAt[2]:=44;MapLegendRec.LegendAt[3]:=25;
{MapLegendRec.LegendAt[4]:=0;MapLegendRec.LegendAt[5]:=0;MapLegendRec.LegendAt[6]:=0;MapLegendRec.LegendAt[7]:=0;}
MapLegendRec.MapAt[6]:=VoEditForm.ShapeViewImage.Width;
MapLegendRec.MapAt[7]:=VoEditForm.ShapeViewImage.Height;
MapLegendRec.MapAt[0]:=3;MapLegendRec.MapAt[1]:=23;
MapLegendRec.MapAt[2]:=200;MapLegendRec.MapAt[3]:=164;
{MapLegendRec.MapAt[4]:=0;MapLegendRec.MapAt[5]:=0;MapLegendRec.MapAt[6]:=0;MapLegendRec.MapAt[7]:=0;}
MapLegendRec.MapLocationAt[0]:=196;MapLegendRec.MapLocationAt[1]:=138;MapLegendRec.MapLocationAt[2]:=17;MapLegendRec.MapLocationAt[3]:=17;
{MapLegendRec.MapLocationAt[4]:=0;MapLegendRec.MapLocationAt[5]:=0;MapLegendRec.MapLocationAt[6]:=0;MapLegendRec.MapLocationAt[7]:=0;}
MapLegendRec.ScalebarsAt[0]:=170;MapLegendRec.ScalebarsAt[1]:=100;MapLegendRec.ScalebarsAt[2]:=57;MapLegendRec.ScalebarsAt[3]:=17;
{MapLegendRec.ScalebarsAt[4]:=0;MapLegendRec.ScalebarsAt[5]:=0;MapLegendRec.ScalebarsAt[6]:=0;MapLegendRec.ScalebarsAt[7]:=0;}
MapLegendRec.FeatureBitmapAt[0]:=88;MapLegendRec.FeatureBitmapAt[1]:=111;MapLegendRec.FeatureBitmapAt[2]:=65;MapLegendRec.FeatureBitmapAt[3]:=18;
{MapLegendRec.FeatureBitmapAt[4]:=0;MapLegendRec.FeatureBitmapAt[4]:=0;MapLegendRec.FeatureBitmapAt[6]:=0;MapLegendRec.FeatureBitmapAt[7]:=0;}
  end;
  SetDataToForm;
end;


procedure TPrintLayoutForm.PrintMapBtnClick(Sender: TObject);
begin
 {Save info to Record}
 If (not CheckLayoutOK) then PrePrintLayoutBtnClick(Sender);
  Draw;
  Preview1.Preview;  {    Preview1.Print;}
end;
(***********************************************************)

(***********************************************************)
Procedure TPrintLayoutForm.Draw;
var I:Integer;
Begin
  With Preview1.Paper Do
  Begin
    Clear;
    SetPage( 1 );
    SetBrush( exClear, clWhite, clWhite, Nil, 0 );

    If MapLegendRec.TitleTopOn then
    begin
      SetFont(
       MapLegendRec.TitleTopFont.Name,
       MapLegendRec.TitleTopFont.Size,
       MapLegendRec.TitleTopFont.Style,
       MapLegendRec.TitleTopFont.Color);
      For I := 0 To MapLegendRec.TitleTopCount-1 Do
      Begin
        TextOut( MapLegendRec.TitleTopAt[4],
               MapLegendRec.TitleTopAt[5]
               + Round(I*
               (MapLegendRec.TitleTopAt[7]/MapLegendRec.TitleTopCount)),
               MapLegendRec.TitleTop[I] );
      End;
    end;

    If MapLegendRec.AuthorTopOn then
    begin
      SetFont(
       MapLegendRec.AuthorTopFont.Name,
       MapLegendRec.AuthorTopFont.Size,
       MapLegendRec.AuthorTopFont.Style,
       MapLegendRec.AuthorTopFont.Color);
      For I := 0 To MapLegendRec.AuthorTopCount-1 Do
      Begin
        TextOut( MapLegendRec.AuthorTopAt[4],
               MapLegendRec.AuthorTopAt[5]
               + Round(I*
               (MapLegendRec.AuthorTopAt[7]/MapLegendRec.AuthorTopCount)),
               MapLegendRec.AuthorTop[I] );
      End;
    end;

    If MapLegendRec.TitleBottomOn then
    begin
      SetFont(
       MapLegendRec.TitleBottomFont.Name,
       MapLegendRec.TitleBottomFont.Size,
       MapLegendRec.TitleBottomFont.Style,
       MapLegendRec.TitleBottomFont.Color);
      For I := 0 To MapLegendRec.TitleBottomCount-1 Do
      Begin
        TextOut( MapLegendRec.TitleBottomAt[4],
               MapLegendRec.TitleBottomAt[5]
               + Round(I*
               (MapLegendRec.TitleBottomAt[7]/MapLegendRec.TitleBottomCount)),
               MapLegendRec.TitleBottom[I] );
      End;
    end;

    If MapLegendRec.AuthorBottomOn then
    begin
      SetFont(
       MapLegendRec.AuthorBottomFont.Name,
       MapLegendRec.AuthorBottomFont.Size,
       MapLegendRec.AuthorBottomFont.Style,
       MapLegendRec.AuthorBottomFont.Color);
      For I := 0 To MapLegendRec.AuthorBottomCount-1 Do
      Begin
        TextOut( MapLegendRec.AuthorBottomAt[4],
               MapLegendRec.AuthorBottomAt[5]
               + Round(I*
               (MapLegendRec.AuthorBottomAt[7]/MapLegendRec.AuthorBottomCount)),
               MapLegendRec.AuthorBottom[I] );
      End;
    end;

    If MapLegendRec.SourceOn then
    begin
      SetFont(
       MapLegendRec.SourceFont.Name,
       MapLegendRec.SourceFont.Size,
       MapLegendRec.SourceFont.Style,
       MapLegendRec.SourceFont.Color);
      For I := 0 To MapLegendRec.SourceCount-1 Do
      Begin
        TextOut( MapLegendRec.SourceAt[4],
               MapLegendRec.SourceAt[5]
               + Round(I*
               (MapLegendRec.SourceAt[7]/MapLegendRec.SourceCount)),
               MapLegendRec.Source[I] );
      End;
    end;
    If MapLegendRec.FeatureTextOn then
    begin
      SetFont(
       MapLegendRec.FeatureTextFont.Name,
       MapLegendRec.FeatureTextFont.Size,
       MapLegendRec.FeatureTextFont.Style,
       MapLegendRec.FeatureTextFont.Color);
      For I := 0 To MapLegendRec.FeatureTextCount-1 Do
      Begin
        TextOut( MapLegendRec.FeatureTextAt[4],
               MapLegendRec.FeatureTextAt[5]
               + Round(I*
               (MapLegendRec.FeatureTextAt[7]/MapLegendRec.FeatureTextCount)),
               MapLegendRec.FeatureText[I] );
      End;
    end;

    If MapLegendRec.NorthArrowTextOn then
    begin
      SetFont(
       MapLegendRec.NorthArrowTextFont.Name,
       MapLegendRec.NorthArrowTextFont.Size,
       MapLegendRec.NorthArrowTextFont.Style,
       MapLegendRec.NorthArrowTextFont.Color);
      For I := 0 To MapLegendRec.NorthArrowTextCount-1 Do
      Begin
        TextOut( MapLegendRec.NorthArrowTextAt[4],
               MapLegendRec.NorthArrowTextAt[5]
               + Round(I*
               (MapLegendRec.NorthArrowTextAt[7]/MapLegendRec.NorthArrowTextCount)),
               MapLegendRec.NorthArrowText[I] );
      End;
    end;

    If MapLegendRec.ContourIntervalOn then
    begin
      SetFont(
       MapLegendRec.ContourIntervalFont.Name,
       MapLegendRec.ContourIntervalFont.Size,
       MapLegendRec.ContourIntervalFont.Style,
       MapLegendRec.ContourIntervalFont.Color);
      For I := 0 To MapLegendRec.ContourIntervalCount-1 Do
      Begin
        TextOut( MapLegendRec.ContourIntervalAt[4],
               MapLegendRec.ContourIntervalAt[5]
               + Round(I*
               (MapLegendRec.ContourIntervalAt[7]/MapLegendRec.ContourIntervalCount)),
               MapLegendRec.ContourInterval[I] );
      End;
    end;

    If MapLegendRec.NorthArrowBitOn then
    begin
      LegendTestImage.Picture.LoadFromFile(MapLegendRec.NorthArrowBitName);
      StretchDraw( Rect(
        MapLegendRec.NorthArrowBitAt[4],
        MapLegendRec.NorthArrowBitAt[5],
        MapLegendRec.NorthArrowBitAt[4]+
                  MapLegendRec.NorthArrowBitAt[6],
        MapLegendRec.NorthArrowBitAt[5]+
              MapLegendRec.NorthArrowBitAt[7]),
              LegendTestImage.Picture.Bitmap);
    end;
    If MapLegendRec.LegendOn then
    begin
      LegendTestImage.Picture.LoadFromFile(MapLegendRec.LegendName);
      StretchDraw( Rect(
        MapLegendRec.LegendAt[4],
        MapLegendRec.LegendAt[5],
        MapLegendRec.LegendAt[4]+
                  MapLegendRec.LegendAt[6],
        MapLegendRec.LegendAt[5]+
              MapLegendRec.LegendAt[7]),
              LegendTestImage.Picture.Bitmap);
    end;
{    If MapLegendRec.LegendOn then }
    begin
{      LegendTestImage.Picture.LoadFromFile(MapLegendRec.LegendName);}
      StretchDraw( Rect(
        MapLegendRec.MapAt[4],
        MapLegendRec.MapAt[5],
        MapLegendRec.MapAt[4]+
                  MapLegendRec.MapAt[6],
        MapLegendRec.MapAt[5]+
              MapLegendRec.MapAt[7]),
              VoEditForm.ShapeViewImage.Picture.Bitmap);
    end;
    If MapLegendRec.MapLocationOn then
    begin
      LegendTestImage.Picture.LoadFromFile(MapLegendRec.MapLocationName);
      StretchDraw( Rect(
        MapLegendRec.MapLocationAt[4],
        MapLegendRec.MapLocationAt[5],
        MapLegendRec.MapLocationAt[4]+
                  MapLegendRec.MapLocationAt[6],
        MapLegendRec.MapLocationAt[5]+
              MapLegendRec.MapLocationAt[7]),
              LegendTestImage.Picture.Bitmap);
    end;
    If MapLegendRec.ScalebarsOn then
    begin
      LegendTestImage.Picture.LoadFromFile(MapLegendRec.ScalebarsName);
      StretchDraw( Rect(
        MapLegendRec.ScalebarsAt[4],
        MapLegendRec.ScalebarsAt[5],
        MapLegendRec.ScalebarsAt[4]+
                  MapLegendRec.ScalebarsAt[6],
        MapLegendRec.ScalebarsAt[5]+
              MapLegendRec.ScalebarsAt[7]),
              LegendTestImage.Picture.Bitmap);
    end;
    If MapLegendRec.FeatureBitmapOn then
    begin
      LegendTestImage.Picture.LoadFromFile(MapLegendRec.FeatureBitmapName);
      StretchDraw( Rect(
        MapLegendRec.FeatureBitmapAt[4],
        MapLegendRec.FeatureBitmapAt[5],
        MapLegendRec.FeatureBitmapAt[4]+
                  MapLegendRec.FeatureBitmapAt[6],
        MapLegendRec.FeatureBitmapAt[5]+
              MapLegendRec.FeatureBitmapAt[7]),
              LegendTestImage.Picture.Bitmap);
    end;
  End;
End;
(***********************************************************)
(***********************************************************)

(***********************************************************)
(***********************************************************)
procedure TPrintLayoutForm.MoverResetBtnClick(Sender: TObject);
begin
  Case MoverRG.Itemindex of
  0:  {TT}   Begin
    MapLegendRec.TitleTopAt[0]:=10;
    MapLegendRec.TitleTopAt[1]:=10;
    MapLegendRec.TitleTopAt[4]:=100;
    MapLegendRec.TitleTopAt[5]:=100;
     End;
  1:  {AT}   Begin
    MapLegendRec.AuthorTopAt[0]:=10;
    MapLegendRec.AuthorTopAt[1]:=10;
    MapLegendRec.AuthorTopAt[4]:=100;
    MapLegendRec.AuthorTopAt[5]:=100;
     End;
  2:  {TB}   Begin
    MapLegendRec.TitleBottomAt[0]:=10;
    MapLegendRec.TitleBottomAt[1]:=10;
    MapLegendRec.TitleBottomAt[4]:=100;
    MapLegendRec.TitleBottomAt[5]:=100;
     End;
  3:  {AB}   Begin
    MapLegendRec.AuthorBottomAt[0]:=10;
    MapLegendRec.AuthorBottomAt[1]:=10;
    MapLegendRec.AuthorBottomAt[4]:=100;
    MapLegendRec.AuthorBottomAt[5]:=100;
     End;
  4:  {FT}   Begin
    MapLegendRec.FeatureTextAt[0]:=10;
    MapLegendRec.FeatureTextAt[1]:=10;
    MapLegendRec.FeatureTextAt[4]:=100;
    MapLegendRec.FeatureTextAt[5]:=100;
     End;
  5:  {NT}   Begin
    MapLegendRec.NorthArrowTextAt[0]:=10;
    MapLegendRec.NorthArrowTextAt[1]:=10;
    MapLegendRec.NorthArrowTextAt[4]:=100;
    MapLegendRec.NorthArrowTextAt[5]:=100;
     End;
  6:  {SP}   Begin
    MapLegendRec.SourceAt[0]:=10;
    MapLegendRec.SourceAt[1]:=10;
    MapLegendRec.SourceAt[4]:=100;
    MapLegendRec.SourceAt[5]:=100;
     End;
  7:  {CT}  Begin
    MapLegendRec.ContourIntervalAt[0]:=10;
    MapLegendRec.ContourIntervalAt[1]:=10;
    MapLegendRec.ContourIntervalAt[4]:=100;
    MapLegendRec.ContourIntervalAt[5]:=100;
     End;
  8:  {ML}  Begin
    MapLegendRec.MapLocationAt[0]:=10;
    MapLegendRec.MapLocationAt[1]:=10;
    MapLegendRec.MapLocationAt[4]:=100;
    MapLegendRec.MapLocationAt[5]:=100;
     End;
  9:;  {GS}
  {Not an object...}
  10:  {LG}  Begin
    MapLegendRec.LegendAt[0]:=10;
    MapLegendRec.LegendAt[1]:=10;
    MapLegendRec.LegendAt[4]:=100;
    MapLegendRec.LegendAt[5]:=100;
     End;
  11:  {SB}  Begin
    MapLegendRec.ScalebarsAt[0]:=10;
    MapLegendRec.ScalebarsAt[1]:=10;
    MapLegendRec.ScalebarsAt[4]:=100;
    MapLegendRec.ScalebarsAt[5]:=100;
     End;
  12:  {FB}  Begin
    MapLegendRec.FeatureBitmapAt[0]:=10;
    MapLegendRec.FeatureBitmapAt[1]:=10;
    MapLegendRec.FeatureBitmapAt[4]:=100;
    MapLegendRec.FeatureBitmapAt[5]:=100;
     End;
  13:  {NB}  Begin
    MapLegendRec.NorthArrowBitAt[0]:=10;
    MapLegendRec.NorthArrowBitAt[1]:=10;
    MapLegendRec.NorthArrowBitAt[4]:=100;
    MapLegendRec.NorthArrowBitAt[5]:=100;
     End;
  14:  {MB}  Begin
    MapLegendRec.MapAt[0]:=10;
    MapLegendRec.MapAt[1]:=10;
    MapLegendRec.MapAt[4]:=100;
    MapLegendRec.MapAt[5]:=100;
     End;
  End;
  SetDataToForm;
end;

procedure TPrintLayoutForm.UpDownXChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  Case MoverRG.Itemindex of
  0:  {TT}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.TitleTopAt[4]:=NewValue;
     {MapLegendRec.TitleTopAt[5]:=NewValue;}
     MapLegendRec.TitleTopAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.TitleTopAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.TitleTopAt[0]:=NewValue;
     {MapLegendRec.TitleTopAt[1]:=NewValue;}
   end;
  1:  {AT}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.AuthorTopAt[4]:=NewValue;
     {MapLegendRec.AuthorTopAt[5]:=NewValue;}
     MapLegendRec.AuthorTopAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.AuthorTopAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.AuthorTopAt[0]:=NewValue;
     {MapLegendRec.AuthorTopAt[1]:=NewValue;}
   end;
  2:  {TB}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.TitleBottomAt[4]:=NewValue;
     {MapLegendRec.TitleBottomAt[5]:=NewValue;}
     MapLegendRec.TitleBottomAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.TitleBottomAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.TitleBottomAt[0]:=NewValue;
     {MapLegendRec.TitleBottomAt[1]:=NewValue;}
   end;
  3:  {AB}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.AuthorBottomAt[4]:=NewValue;
     {MapLegendRec.AuthorBottomAt[5]:=NewValue;}
     MapLegendRec.AuthorBottomAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.AuthorBottomAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.AuthorBottomAt[0]:=NewValue;
     {MapLegendRec.AuthorBottomAt[1]:=NewValue;}
   end;
  4:  {FT}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.FeatureTextAt[4]:=NewValue;
     {MapLegendRec.FeatureTextAt[5]:=NewValue;}
     MapLegendRec.FeatureTextAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.FeatureTextAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.FeatureTextAt[0]:=NewValue;
     {MapLegendRec.FeatureTextAt[1]:=NewValue;}
   end;
  5:  {NT}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.NorthArrowTextAt[4]:=NewValue;
     {MapLegendRec.NorthArrowTextAt[5]:=NewValue;}
     MapLegendRec.NorthArrowTextAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.NorthArrowTextAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.NorthArrowTextAt[0]:=NewValue;
     {MapLegendRec.NorthArrowTextAt[1]:=NewValue;}
   end;
  6:  {SP}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.SourceAt[4]:=NewValue;
     {MapLegendRec.SourceAt[5]:=NewValue;}
     MapLegendRec.SourceAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.SourceAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.SourceAt[0]:=NewValue;
     {MapLegendRec.SourceAt[1]:=NewValue;}
   end;
  7:  {CT}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.ContourIntervalAt[4]:=NewValue;
     {MapLegendRec.ContourIntervalAt[5]:=NewValue;}
     MapLegendRec.ContourIntervalAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.ContourIntervalAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.ContourIntervalAt[0]:=NewValue;
     {MapLegendRec.ContourIntervalAt[1]:=NewValue;}
   end;
  8:  {ML}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.MapLocationAt[4]:=NewValue;
     {MapLegendRec.MapLocationAt[5]:=NewValue;}
     MapLegendRec.MapLocationAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.MapLocationAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.MapLocationAt[0]:=NewValue;
     {MapLegendRec.MapLocationAt[1]:=NewValue;}
   end;
  9:;  {GS}
  {Not an object...}
  10:  {LG}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.LegendAt[4]:=NewValue;
     {MapLegendRec.LegendAt[5]:=NewValue;}
     MapLegendRec.LegendAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.LegendAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.LegendAt[0]:=NewValue;
     {MapLegendRec.LegendAt[1]:=NewValue;}
   end;
  11:  {SB}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.ScalebarsAt[4]:=NewValue;
     {MapLegendRec.ScalebarsAt[5]:=NewValue;}
     MapLegendRec.ScalebarsAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.ScalebarsAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.ScalebarsAt[0]:=NewValue;
     {MapLegendRec.ScalebarsAt[1]:=NewValue;}
   end;
  12:  {FB}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.FeatureBitmapAt[4]:=NewValue;
     {MapLegendRec.FeatureBitmapAt[5]:=NewValue;}
     MapLegendRec.FeatureBitmapAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.FeatureBitmapAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.FeatureBitmapAt[0]:=NewValue;
     {MapLegendRec.FeatureBitmapAt[1]:=NewValue;}
   end;
  13:  {NB}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.NorthArrowBitAt[4]:=NewValue;
     {MapLegendRec.NorthArrowBitAt[5]:=NewValue;}
     MapLegendRec.NorthArrowBitAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.NorthArrowBitAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.NorthArrowBitAt[0]:=NewValue;
     {MapLegendRec.NorthArrowBitAt[1]:=NewValue;}
   end;
  14:  {MB}
   If ScaledCBox.Checked then
   begin
     MapLegendRec.MapAt[4]:=NewValue;
     {MapLegendRec.MapAt[5]:=NewValue;}
     MapLegendRec.MapAt[0]:=Round(NewValue/XRatio);
     {MapLegendRec.MapAt[1]:=Round(NewValue/YRatio);}
   end else
   begin
     MapLegendRec.MapAt[0]:=NewValue;
     {MapLegendRec.MapAt[1]:=NewValue;}
   end;
  End;
  SetDataToForm;
end;

procedure TPrintLayoutForm.UpDownYChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  Case MoverRG.Itemindex of
  0:  {TT}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.TitleTopAt[4]:=NewValue;}
     MapLegendRec.TitleTopAt[5]:=NewValue;
     {MapLegendRec.TitleTopAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.TitleTopAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.TitleTopAt[0]:=NewValue;}
     MapLegendRec.TitleTopAt[1]:=NewValue;
   end;
  1:  {AT}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.AuthorTopAt[4]:=NewValue;}
     MapLegendRec.AuthorTopAt[5]:=NewValue;
     {MapLegendRec.AuthorTopAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.AuthorTopAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.AuthorTopAt[0]:=NewValue;}
     MapLegendRec.AuthorTopAt[1]:=NewValue;
   end;
  2:  {TB}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.TitleBottomAt[4]:=NewValue;}
     MapLegendRec.TitleBottomAt[5]:=NewValue;
     {MapLegendRec.TitleBottomAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.TitleBottomAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.TitleBottomAt[0]:=NewValue;}
     MapLegendRec.TitleBottomAt[1]:=NewValue;
   end;
  3:  {AB}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.AuthorBottomAt[4]:=NewValue;}
     MapLegendRec.AuthorBottomAt[5]:=NewValue;
     {MapLegendRec.AuthorBottomAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.AuthorBottomAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.AuthorBottomAt[0]:=NewValue;}
     MapLegendRec.AuthorBottomAt[1]:=NewValue;
   end;
  4:  {FT}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.FeatureTextAt[4]:=NewValue;}
     MapLegendRec.FeatureTextAt[5]:=NewValue;
     {MapLegendRec.FeatureTextAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.FeatureTextAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.FeatureTextAt[0]:=NewValue;}
     MapLegendRec.FeatureTextAt[1]:=NewValue;
   end;
  5:  {NT}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.NorthArrowTextAt[4]:=NewValue;}
     MapLegendRec.NorthArrowTextAt[5]:=NewValue;
     {MapLegendRec.NorthArrowTextAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.NorthArrowTextAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.NorthArrowTextAt[0]:=NewValue;}
     MapLegendRec.NorthArrowTextAt[1]:=NewValue;
   end;
  6:  {SP}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.SourceAt[4]:=NewValue;}
     MapLegendRec.SourceAt[5]:=NewValue;
     {MapLegendRec.SourceAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.SourceAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.SourceAt[0]:=NewValue;}
     MapLegendRec.SourceAt[1]:=NewValue;
   end;
  7:  {CT}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.ContourIntervalAt[4]:=NewValue;}
     MapLegendRec.ContourIntervalAt[5]:=NewValue;
     {MapLegendRec.ContourIntervalAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.ContourIntervalAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.ContourIntervalAt[0]:=NewValue;}
     MapLegendRec.ContourIntervalAt[1]:=NewValue;
   end;
  8:  {ML}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.MapLocationAt[4]:=NewValue;}
     MapLegendRec.MapLocationAt[5]:=NewValue;
     {MapLegendRec.MapLocationAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.MapLocationAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.MapLocationAt[0]:=NewValue;}
     MapLegendRec.MapLocationAt[1]:=NewValue;
   end;
  9:;  {GS}
  {Not an object...}
  10:  {LG}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.LegendAt[4]:=NewValue;}
     MapLegendRec.LegendAt[5]:=NewValue;
     {MapLegendRec.LegendAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.LegendAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.LegendAt[0]:=NewValue;}
     MapLegendRec.LegendAt[1]:=NewValue;
   end;
  11:  {SB}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.ScalebarsAt[4]:=NewValue;}
     MapLegendRec.ScalebarsAt[5]:=NewValue;
     {MapLegendRec.ScalebarsAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.ScalebarsAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.ScalebarsAt[0]:=NewValue;}
     MapLegendRec.ScalebarsAt[1]:=NewValue;
   end;
  12:  {FB}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.FeatureBitmapAt[4]:=NewValue;}
     MapLegendRec.FeatureBitmapAt[5]:=NewValue;
     {MapLegendRec.FeatureBitmapAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.FeatureBitmapAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.FeatureBitmapAt[0]:=NewValue;}
     MapLegendRec.FeatureBitmapAt[1]:=NewValue;
   end;
  13:  {NB}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.NorthArrowBitAt[4]:=NewValue;}
     MapLegendRec.NorthArrowBitAt[5]:=NewValue;
     {MapLegendRec.NorthArrowBitAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.NorthArrowBitAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.NorthArrowBitAt[0]:=NewValue;}
     MapLegendRec.NorthArrowBitAt[1]:=NewValue;
   end;
  14:  {MB}
   If ScaledCBox.Checked then
   begin
     {MapLegendRec.MapAt[4]:=NewValue;}
     MapLegendRec.MapAt[5]:=NewValue;
     {MapLegendRec.MapAt[0]:=Round(NewValue/XRatio);}
     MapLegendRec.MapAt[1]:=Round(NewValue/YRatio);
   end else
   begin
     {MapLegendRec.MapAt[0]:=NewValue;}
     MapLegendRec.MapAt[1]:=NewValue;
   end;
  End;
  SetDataToForm;
end;

procedure TPrintLayoutForm.MoverRGClick(Sender: TObject);
begin
  Case MoverRG.Itemindex of
  0:  {TT} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.TitleTopAt[4];
     UpDownY.Position:= MapLegendRec.TitleTopAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.TitleTopAt[0];
     UpDownY.Position:= MapLegendRec.TitleTopAt[1];
   end;
   End;
  1:  {AT} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.AuthorTopAt[4];
     UpDownY.Position:= MapLegendRec.AuthorTopAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.AuthorTopAt[0];
     UpDownY.Position:= MapLegendRec.AuthorTopAt[1];
   end;
   End;
  2:  {TB} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.TitleBottomAt[4];
     UpDownY.Position:= MapLegendRec.TitleBottomAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.TitleBottomAt[0];
     UpDownY.Position:= MapLegendRec.TitleBottomAt[1];
   end;
   End;
  3:  {AB} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.AuthorBottomAt[4];
     UpDownY.Position:= MapLegendRec.AuthorBottomAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.AuthorBottomAt[0];
     UpDownY.Position:= MapLegendRec.AuthorBottomAt[1];
   end;
    End;
  4:  {FT} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.FeatureTextAt[4];
     UpDownY.Position:= MapLegendRec.FeatureTextAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.FeatureTextAt[0];
     UpDownY.Position:= MapLegendRec.FeatureTextAt[1];
   end;
    End;
  5:  {NT} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.NorthArrowTextAt[4];
     UpDownY.Position:= MapLegendRec.NorthArrowTextAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.NorthArrowTextAt[0];
     UpDownY.Position:= MapLegendRec.NorthArrowTextAt[1];
   end;
    End;
  6:  {SP} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.SourceAt[4];
     UpDownY.Position:= MapLegendRec.SourceAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.SourceAt[0];
     UpDownY.Position:= MapLegendRec.SourceAt[1];
   end;
    End;
  7:  {CT}  Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.ContourIntervalAt[4];
     UpDownY.Position:= MapLegendRec.ContourIntervalAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.ContourIntervalAt[0];
     UpDownY.Position:= MapLegendRec.ContourIntervalAt[1];
   end;
    End;
  8:  {ML}  Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.MapLocationAt[4];
     UpDownY.Position:= MapLegendRec.MapLocationAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.MapLocationAt[0];
     UpDownY.Position:= MapLegendRec.MapLocationAt[1];
   end;
    End;
  9:;  {GS}
  {Not an object...}
  10:  {LG} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.LegendAt[4];
     UpDownY.Position:= MapLegendRec.LegendAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.LegendAt[0];
     UpDownY.Position:= MapLegendRec.LegendAt[1];
   end;
    End;
  11:  {SB} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.ScalebarsAt[4];
     UpDownY.Position:= MapLegendRec.ScalebarsAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.ScalebarsAt[0];
     UpDownY.Position:= MapLegendRec.ScalebarsAt[1];
   end;
    End;
  12:  {FB} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.FeatureBitmapAt[4];
     UpDownY.Position:= MapLegendRec.FeatureBitmapAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.FeatureBitmapAt[0];
     UpDownY.Position:= MapLegendRec.FeatureBitmapAt[1];
   end;
    End;
  13:  {NB} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.NorthArrowBitAt[4];
     UpDownY.Position:= MapLegendRec.NorthArrowBitAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.NorthArrowBitAt[0];
     UpDownY.Position:= MapLegendRec.NorthArrowBitAt[1];
   end;
    End;
  14:  {MB} Begin
   If ScaledCBox.Checked then
   begin
     UpDownX.Position:= MapLegendRec.MapAt[4];
     UpDownY.Position:= MapLegendRec.MapAt[5];
   end else
   begin
     UpDownX.Position:= MapLegendRec.MapAt[0];
     UpDownY.Position:= MapLegendRec.MapAt[1];
   end;
    End;
  End;
end;
(***********************************************************)
(***********************************************************)


(***********************************************************)
(***********************************************************)



end.
