unit VoGlobals;

interface

uses  Windows, SysUtils, Db, Graphics;

type
  FieldDefRec= record
    FieldNo: Integer;
    Displayname:String;
    DataType: TFieldType;
    Size: Integer;
    Precision: Integer;
    Required: Boolean;
    {TFieldDef Field Name,Type,Size for Each attribute}
   end;

  Pnts = record
    Xd,Yd{,Zd,Md}: Double;
   end;
  Pnts3 = record
    Xd,Yd,Zd,Md: Double;
   end;
  PAR = record
    PA:array of Pnts;  {Pnts in each Part}
   end;
  PAR3 = record
    PA3:array of Pnts3; {Pnts in each Part}
   end;
  ShpObj = record
    ShpType: Integer;{Shape type for THIS Object: ONLY MY Types}
    ShapeIDN, {Shape Object number in file}
    PntsN, {Total points in Object}
    PartsN:integer;{1 implies single part with no subpparts}
    PPA: array of Integer;{# of Pnts in each Part}
    PARA: array of PAR;{array of Pnts for each Part in Object}
    {Boundary of THIS object}
    XMin,YMin,XMax,YMax{,ZMin,MMin,ZMax,MMax}: Double;
    {array of the attributes AS Strings .. per Object}
    AAttributes:array of string;{0..AttributesN-1}
  end;
  ShpObj3 = record
    ShpType: Integer;{Shape type for THIS Object: ONLY MY Types}
    ShapeIDN, {Shape Object number in file}
    PntsN, {Total points in Object}
    PartsN:integer;{1 implies single part with no subpparts}
    PPA: array of Integer;{# of Pnts in each Part}
    PARA3: array of PAR3;{array of Pnts for each Part in Object}
    {Boundary of THIS object}
    XMin,YMin,XMax,YMax,ZMin,MMin,ZMax,MMax: Double;
    {array of the attributes AS Strings .. per Object}
    AAttributes:array of string;{0..AttributesN-1}
  end;
    {all per ShpObj: PARA[PartsN #].PA[PPA[PartsN #]].Xn }

  ShpLayer = record{Shape Type and Boundary}
    LayerN,{Layer number loaded as}
    ShapeN,{Number of Shape Objects in file layer}
    IslandsN,{Total Islands  ie. ShapeN+IslandsN=Total parts}
    TotalPnts:Integer;{Total Points in file layer}
    Modified:Boolean; {Editing done for THIS layer}
    ShpType: Integer;{Shape file type for THIS Layer:
                       All except MY Types}
    LayerDBName,LayerDBPath,{ ? should be same as Shape file name..}
    Filename,Path:String;
    OffsetX, OffsetY,{Offset +- resets-sizes to 0,0 for display}
      {Boundary of Layer}
    XMin,YMin,XMax,YMax,ZMin,MMin,ZMax,MMax: Double;
       {Attribute count for THIS File}
    AttributesN: Integer;
      {TFieldDef Field Name,Type,Size for Each attribute}
    AttType:array of FieldDefRec;
      {All the Objects in the file}
    LyrShp:array of ShpObj;
    LyrShp3:array of ShpObj3;
    {LayA[].LyrShp[].PARA[PartsN #].PA[PPA[PartsN #]].Xn Yn Zn Mn}
  end;

  SymObj = record
  {0 Not, 1 Simple, 2 Unique, 3 Classed, 4 Individual}
    SymSymboled, SymLabeled, SymClassSize:Integer;
    SymStyle,SymLineStyle,SymLineWidth:Integer;
    SymLabelBackColor, SymLineColor, SymBrushColor:TColor;
    isSymOutlined, isSymLabelSet,isSymLabelColored:Boolean;
    SymFont:Tfont;
    SymlabelFieldstring: string;
    labelHeight,labelAngle,HAlign,VAlign:Integer;
    LabelX,LabelY:Double;
    end;

  SymLayer=record
    SymLayerBeginSize,SymLayerEndSize, SymLayerClasses,
   {0 Not, 1 Simple, 2 Unique, 3 Classed, 4 Individual}
    SymLayerSymboled, SymLayerLabeled:Integer;
    SymLayerStyle, SymLayerLineStyle,
    SymLayerLineWidth{1.. else no style}:Integer;
    SymLayerLabelBackColor,
    SymLayerStartColor, SymLayerFinishColor,
    SymLayerLineColor,  SymLayerBrushColor:TColor;
    isSymLayerEditable,
    isSymLayerOutlined, isSymLayerLabelColored:Boolean;
    SymFont:Tfont;
    labelHeight,labelAngle,Field:Integer;
    SymLayerClassBreaks:Array of Double;
    LyrSym:array of SymObj;{Store data for EACH OBJECT  LayA[].ShapeN}
  end;

  {Store Info for Each Layer loaded as MapLayerRec}
  Type
  MapRec=Record
    MapNameEdit,       MapDateEdit,       MapRevisionEdit,
    MapScaleEdit,      MapQuadrangleEdit, ProductTypeEdit,
    PreProcessingEdit, ResamplingTechniqueEdit
    :string[255];{ :String;}

    MapEdge1Edit, MapEdge2Edit, MapEdge3Edit, MapEdge4Edit,
    MapEdgeW1Edit,MapEdgeW2Edit,
    MapEdgeN1Edit,MapEdgeN2Edit,
    MapEdgeE1Edit,MapEdgeE2Edit,
    MapEdgeS1Edit,MapEdgeS2Edit:Char;

    bIsProjectedCB, bNeverProjectedCB,
    bIgnoreDatumCB, bIgnoreErrorsCB,
    bUTMZoneNorthCB,
    bProjectionValidCBox:Boolean;

    CatNameCB,
    ProjectionCB,
    InUnitCB,
    InUtmZoneCB,
    InDatumCB,
    SpheroidCB,
    StatePlaneZoneEdit:Integer;

    ModeEdit,
    SMajorEdit, SMinorEdit,    SphereEdit,
    FEEdit,     FNEdit,        OriginLatEdit,
    STDPR1Edit, STDPR2Edit,    CentMerEdit,
    TrueScaleEdit,    CentLonEdit,    CenterLatEdit,
    STDPAREdit, LongPolEdit, FactorEdit, HeightEdit,
    ShapeMEdit, ShapeNEdit,  AngleEdit,
    Long1Edit,  Long2Edit,   Lat1Edit,   Lat2Edit,
    AziAngEdit, AzmthPtEdit, IncAngEdit,
    AscLongEdit,PSRevEdit,   LRatEdit,
    PFlagEdit,  SatnumEdit,  PathEdit:Double;
    DLGPA1,DLGPA2,DLGPA3,
    DLGPB1,DLGPB2,DLGPB3,
    DLGPC1,DLGPC2,DLGPC3,
    DLGPD1,DLGPD2,DLGPD3,
    DLGPE1,DLGPE2,DLGPE3,
    DLGPP1,DLGPP2,DLGPP3,DLGPP4:Double;

    MapZUnitsCB, MapMUnitsCB:Integer;

    MapXMaxEdit,MapXMinEdit,
    MapYMaxEdit,MapYMinEdit,
    MapZMaxEdit,MapZMinEdit,
    MapMMaxEdit,MapMMinEdit:Double;

    bCoordinatesValidCBox:Boolean;

    ULLongitudeEdit,ULLatitudeEdit,
    URLongitudeEdit, URLatitudeEdit,
    LLLongitudeEdit,LLLatitudeEdit,
    LRLongitudeEdit,LRLatitudeEdit:Double;

    MetadataFileEdit:string[255];{ :String;}
  end;
{  MapLayerFile = file of MapRec;}{for Layer Projections}

  Type
  LegendRec=Record
  ProjectionName:String;

  ProjectionCB,  GridsRG,
  TitleTopCount,AuthorTopCount,TitleBottomCount,AuthorBottomCount,
  SourceCount,FeatureTextCount,NorthArrowTextCount,
  ContourIntervalCount:Integer;

  TitleTopFont, AuthorTopFont,TitleBottomFont,
  AuthorBottomFont,SourceFont,FeatureTextFont,
  NorthArrowTextFont,ContourIntervalFont:Tfont;

  TitleTop,AuthorTop,TitleBottom,AuthorBottom,
  Source,FeatureText,NorthArrowText,ContourInterval:array of string;

  TitleTopOn,AuthorTopOn,TitleBottomOn,AuthorBottomOn,
  SourceOn,FeatureTextOn,NorthArrowTextOn,
  ContourIntervalOn:Boolean;

  TitleTopAt,AuthorTopAt,TitleBottomAt,AuthorBottomAt,
  SourceAt,FeatureTextAt,NorthArrowTextAt,
  ContourIntervalAt:Array[0..7] of Integer;
  {BITMAPS}
  MapLocationText,
  GridName,NorthArrowBitName,LegendName,
  MapLocationName,ScalebarsName,FeatureBitmapName:String;

  GridOn,NorthArrowBitOn,LegendOn,
  MapLocationOn,ScalebarsOn,FeatureBitmapOn:Boolean;

  PaperSizeAt, NorthArrowBitAt,LegendAt,MapAt,
  MapLocationAt,ScalebarsAt,FeatureBitmapAt:Array[0..7] of Integer;
  end;


var
  MapLegendRec: LegendRec;{Loaded with Map Project file}
  MapProject: MapRec;  { "   "  }
  MapLayerRec: MapRec;{Loaded and saved per command per layer}


  Version:Double;{Map load and save}
  {Length is 0..LayersLoaded-1 to use with Index es}
  LayersControlArray: Array  of Integer;
  ShapesFoundArray: Array of array[1..2]of Integer;
  ShpFilename: string;
  ShapesFound,
  SelectionRadius,
  CurrentLayer,{selected from LayerComboBox or LayerCount when loaded}
  CurrentObj, {selected when searching else 0}
  CurrentObjPart,
  CurrentObjPoint,
  CurrentField, {selected from FieldComboBox}SearchDbField,
  LayersLoaded,{0 is nil for editing}
  AnnoLayerCreatedAs,PolygonLayerCreatedAs,
  LineLayerCreatedAs,   PointLayerCreatedAs:Integer;
  IsMapLoaded, IsProjected, IsPointDrawn,
  AnnoLayerCreated,   PolygonLayerCreated,
  LineLayerCreated,   PointLayerCreated,
  isShapeSelected,
  bDemLoaded, bBackClipBitmapLoaded:Boolean;
    DemPath, DemName,
    BackBitmapPath, BackBitmapName,
  NewLayerName:String;
  EditingColor, ClassStartPanelColor,
  BackgroundColor,
  HighlightColor,
  EditColor,
  CurrentColor: TColor;
  {Extents used in Drawing.. ? always positive?}
  MaxOffsetX, MaxOffsetY,{Offset is +- to center data to 0,0}
  MaxExtentX, MaxExtentY,{Store difference : MinOffX, MaxOffX}
  MinOffX, MaxOffX, MinOffY, MaxOffY:Double; {resize view data}
  MapA:Array of SymLayer;{  MapA[].LyrSym[]  MapA[].Labeled}
  LayA:array of ShpLayer;{All Shape Layers for all Files loaded}
  {LayA[].LyrShp[].PARA[].PA[].Xn   Yn Zn Mn}
  AnnoA: array of SymObj;
  AnnoShp:array of ShpObj;

{  MapTextStrings,MapBitsPathFilename:array of String;
  MapTextFonts:array of TFont;  }
{LayerType:
   Dem,Texture.bmp:  loaded separately
   Shape: uses LayA:array of ShpLayer to store MANY Shape layers
   Fractal,Object,Plant,DXF,... : 3D maybe someday}
(*
{LayA[].ShpLayer.LyrShp[].ShpObj.PARA[].PAR.PA[]].Pnts.Xn Yn Zn Mn}
{LayA[].LyrShp[].PARA[].PA[].Pnts.Xn Yn Zn Mn}
	.LayerN, ShapeN
	.OffsetX, OffsetY
	.LayerDBName,LayerDBPath
	.Filename,Path
	.ShpType
	.XMin,YMin,ZMin,MMin,XMax,YMax,ZMax,MMax
	.AttributesN
	.AttType  {:array of TFieldDef;  Field Name,Type,Size  }
	.LyrShp[]
{LayA[].LyrShp[].PARA[].PA[].Pnts.Xn Yn Zn Mn}
			.PartsN
			.PPA[]
			.PARA[]
			.XMin,YMin,ZMin,MMin,XMax,YMax,ZMax,MMax
			.AttributeAS[]
*)
(*
    ShpType: Integer;
      {1,3,(4 is Lines and Areas for conversion)5,8,(#9)
       11,13,15,18, (Measured 3D)
       21,23,25,28, (Measured 2D)
      (31),
      32, Mesh TIN
      34, Fan
      36, Strip
      37, OI polys -> 1 + ?n  Outer + Inner ?n
      39, Rings -> Ring1 + Rings ?n   else is a 15}
*)
(*
    ShpFont:Tfont;
{Specifies the font to use when writing text on the image.
property Font: TFont;
  Set Font to specify the font to use for writing text on the image.
  The value of Font is a TFont object.
property Name: TFontName;
  type TFontName = type string;
  Use Name to specify the typeface of the font.
  If the font family described by Name includes
  multiple character sets, be sure to set the
  CharSet property as well.
property Charset: TFontCharset
  ANSI_CHARSET	0	ANSI characters.
  DEFAULT_CHARSET	1
   Font is chosen based solely on Name and Size.
   If the described font is not available on the system,
   Windows will substitute another font.
property Color: TColor;  ... ?reset to Line color : Boundary of Poly?
property Height: Integer;
   Use Height to specify the height of the font in pixels.
   size Font.Size = -Font.Height * 72 / Font.PixelsPerInch
property PixelsPerInch: Integer; (not to be modified...)
property Style: TFontStyles; [] is no style
  TFontStyle = (fsBold, fsItalic, fsUnderline, fsStrikeOut);
  TFontStyles = set of TFontStyle;
property Pitch: TFontPitch;
   must be correct for the typeface NAME or might be WEIRD
  type TFontPitch = (fpDefault, fpVariable, fpFixed);
*)
{DrawShape
  (TopLeft, BottomRight, Tri, Quad: TPoint; AMode: TPenMode);
      DrawShape(Origin, MovePt, Origin, MovePt, pmCopy	);
    DrawingTool := dtLine;
    bDrawing := False;
    MovePt := Point(X, Y);}
type
  TDrawingTool =  {x Point, 0 Poly, / Line}
    (
    dtSqRectangle{x 0},dtEllipse{x 1}, dtTriangle{x 2}, dtDotPt{x 3},
    dtDotCirclePt{x 4}, dtXBoxPt{x 5},
    dtPolygon{0}, dtPBrush{0},
    dtCSEllipse, dtVTriangle,  dtTSTriangle,
    dtVPRectangle, dtVERectangle, dtVSRectangle, dtRectangle,
    dtVDRectangle, dtVTRectangle, dtVFRectangle, dtVNRectangle,
    dtVMRectangle, dtVARectangle, dtVWRectangle, dtVCRectangle,
    dtVBRectangle, dtVRectangle,  dtRoundRect,
    dtLine{/}, dtPtRectangle{x});
{Zoom and Crop rectangles
Use for Points : Rectangles and Ellipse (Circles)
Line to track Point movement..?}


type
  PrefRecord = record
  {first line of file serves as Version ID}
  PHiddenString,PVRMProgramPath,PProjectPath,
  PColor256Name,
  PTigerPath,PDotPath,PSDTSPath,
  PDLGPath,PDXFPath,PShapePath,PVRMDatabase, PImagePath: string[255];
  PStartedNameNumber: string[25];
    PMapBordersColor, PMapGridsColor,
      PMapDatasColor, PMapBacksColor: TColor;
  PClassStartPanelColor,
  PEditingColor,
  PBackgroundColor,
  PHighlightColor,
  PEditColor,
  PCurrentColor: TColor;
  PToolBarMenuOn,PToolBarClipOn,PToolBarExitOn,
  PToolBarFileOn,PToolBarEditOn,PToolBarZoomOn,
  PToolBarLayerOn,PToolBarToolsOn,
  PErrorBeepOn, PWarningBeepOn ,PInfoBeepOn ,
  PConfirmBeepOn, PCompletedBeepOn :Boolean;
  PSelectionRadius, PColor256S,
{Registration numbers}
    PColorreg: Integer;
    PStarted: TDateTime;
    PSeedNumber,
 {X Y Location of forms}
       PLocatableX, PLocatableY,
      PLMOFormY, PLMOFormX,
 PVRegitFormX,PVRegitFormY,
    PCBFX, PCBFY,
  PMapFormY , PMapFormX,
  PLegendFormY , PLegendFormX ,
    PVoEditfrmY ,PVoEditfrmX,
    PVoEditDbfrmX, PVoEditDbfrmY,
    PNRISoilsFormX, PNRISoilsFormY,
    PMessageX, PMessageY,
    PNRISoilsfrmY, PNRISoilsfrmX,
    PNRidentifyfrmX,PNRidentifyfrmY,
    PSystemInfoFormX, PSystemInfoFormY,
    PviewerfrmX, PtransfrmX, PpropfrmX,
    PlabelfrmX, PInputfrmX,
    PSoilsfrmX,
    PidentifyfrmX, PattribfrmX, PrenderedfrmX, PAboutX,
    POptionsfrmX,
    PviewerfrmY, PtransfrmY, PpropfrmY,
    PlabelfrmY, PInputfrmY,
    PSoilsfrmY,
      PidentifyfrmY, PattribfrmY, PrenderedfrmY,
      PAboutY, POptionsfrmY
      : Integer;
  end;
  PrefFile = file of PrefRecord;

var
  PreRcd: PrefRecord;
  Colorreg: Integer;
  Started: TDateTime;
  HiddenString,
  StartedNameNumber: string;

  MessageX, MessageY,
    LMOFormY, LMOFormX,
    LocatableX, LocatableY,
  MapFormY , MapFormX,
  LegendFormY , LegendFormX ,
    CBFX, CBFY,
 VRegitFormX,VRegitFormY,
    VoEditDbfrmX, VoEditDbfrmY,
    VoEditfrmY ,VoEditfrmX,
    SystemInfoFormX, SystemInfoFormY,
    NRISoilsfrmY, NRISoilsfrmX,
    NRidentifyfrmY, NRidentifyfrmX,
    NRISoilsFormX, NRISoilsFormY,
    viewerfrmX, transfrmX, propfrmX,
    labelfrmX, InputfrmX, SoilsfrmX,
    identifyfrmX, attribfrmX, renderedfrmX,
    AboutX, OptionsfrmX,
    viewerfrmY, transfrmY, propfrmY,
    labelfrmY, InputfrmY, SoilsfrmY,
    identifyfrmY, attribfrmY, renderedfrmY,
    AboutY, OptionsfrmY
    : Integer;

const Sqrt2 = 1.4142135623731;
  PI = 3.1415926535898;
  HalfPI = 1.5707963267949;
  TwoPI = 6.2831853071796;
  Radian = 1.7453292519943E-2;
  RadianDiv100 = 1.7453292519943E-4;
      { PI/180/100, needed to convert }
      { data in WORLD.DAT to radians  }

const
  XCENTER: INTEGER = 180; {320;} { VGA Graphics constants.       }
  YCENTER: INTEGER = 135; { 240; } {99;  Screen center X and Y    }
  ASPECT: Extended = 1.0; {2.4; 640x200 aspect ratio      }
      { R   : Extended    =  90; }{ Default map radius ? meaningless }
                    { SET in the bottom IT WORKS THERE ! }
  NotVisible: Smallint = -32767; { Flag for point visibility     }

type LLREC = record
    CODE: array[0..1] of CHAR;
    LONGI, LATI: Smallint; {INTEGER;} end;

var
  LL: LLREC;
  LLF: file of LLREC;
  LLArray: array {[1..7561]} of LLREC;
{ Save variables for plotting }
  MapDataCount,
    LastX, LastY, XP, YP, COLOR_GLB,
    I, J, K, MapType, M, X1, Y1,
    X2, Y2, SX, SY, CENTER: INTEGER;
  L, L1, LONGR, LSTEP,
    B, LATR, BSTEP, X, Y,
    PHI1, Lambda0, {LambdaIn ,}
    XX, YY, SA, SB: Extended;
  LastPtVis {, GRID }: BOOLEAN;
  CH: CHAR;
  {MapBackColor,MapColor,GridColor:TColor;}
  MapBordersColor, MapGridsColor,
    MapDatasColor, MapBacksColor: TColor;

  NRINatsgoPointsStr, NRINatsgoPShapeStr,
    NRINatsgoTablesStr, NRINatsgoTShapeStr,
    StateStatsgoStr, StateStatsgoShapeStr,
    CountySurgoStr, CountySurgoShapeStr: string;
var
   VRMProgramPath,
   ProjectPath, ProjectName,
   Color256Name,  {MapName, MapPath, }
   TempName, {NTADPath, }
  TigerPath,DotPath,SDTSPath,
  DLGPath,DxfPath,ShapePath,VRMDatabase, ImagePath: string;
  ToolBarMenuOn,ToolBarClipOn,ToolBarExitOn,
  ToolBarFileOn,ToolBarEditOn,ToolBarZoomOn,
  ToolBarLayerOn,ToolBarToolsOn,
  bStatsGOGO, bNatsGOGO, bSSatsGOGO, bHYDRO, bFIPS, bMLRA,
    bPDatabaseActive, bNDatabaseActive,bSDatabaseActive,
    MuidFound, NRIFound,
    StillOpen,
  ErrorBeepOn, WarningBeepOn ,InfoBeepOn ,
  ConfirmBeepOn, CompletedBeepOn, VoicesON :Boolean;
{  AutoDisPlay, , DoneBeepOn, bAutoSave:
      Boolean; }

  NRIPTRN,
    UserID,
    Sample, SampleW,
    BottomRow, TopRow, RightColumn, LeftColumn: Integer;
  dXTemp, dYTemp, dXMIN, dYMIN, dXMAX, dYMAX: Double;
 SeedNumber : Integer;
  ColorArray: array[0..255] of TColor; {passing fancy}
{  Colors: array[0..2, 0..255] of Byte;} {256 RGB's}
MyPixelFormat:TPixelFormat;
Color256S,PixelScanSize:Integer;
  MMSysHandle: THandle;
  PlaySound: function(lpszSoundName: PAnsiChar; uFlags: UINT): BOOL;
  stdcall;

function C2S(X: Extended): string;
function I2S(X: Integer): string;
procedure DoLoader;
procedure SetPreferences;
procedure DoSaver;
procedure GetPreferences;

implementation
uses LOResMess;
{---------------------------------------------------------------------}
function C2S(X: Extended): string;
var TempStr: string;
begin
  str(X: 24: 18, TempStr);
  C2S := TempStr;
end;

function I2S(X: Integer): string;
var
  TempStr: string;
begin
  str(X, TempStr);
  I2S := TempStr;
end;


procedure DoLoader;
var P_File: PrefFile;
var PathS: string;
begin
  PathS := ExtractFilePath(ParamStr(0)) + 'voice.pof';
  if FileExists(PathS) then
  begin
    AssignFile(P_File, PathS);
    Reset(P_File);
    if IoResult <> 0 then
    begin DoRezError(22);
    end;
    Read(P_File, PreRcd);
    CloseFile(P_File);
    SetPreferences;
  end else DoRezError(24);
end;

procedure SetPreferences;
begin {after loading}
  with PreRcd do begin
  VRMProgramPath:=PVRMProgramPath;
  Color256Name:=PColor256Name;
  ProjectPath:=PProjectPath;
  TigerPath:=PTigerPath;
  DotPath:= PDotPath;
  SDTSPath:= PSDTSPath;
  DLGPath:=PDLGPath;
  DXFPath:=PDXFPath;
  ShapePath:=  PShapePath;
  VRMDatabase:= PVRMDatabase;
  ImagePath := PImagePath;
  EditingColor:=PEditingColor;
  BackgroundColor:=PBackgroundColor;
  HighlightColor:=PHighlightColor;
  ClassStartPanelColor:=PClassStartPanelColor;
  EditColor:=PEditColor;
  CurrentColor:=PCurrentColor;
  ErrorBeepOn:=PErrorBeepOn;
  WarningBeepOn:=PWarningBeepOn;
  InfoBeepOn :=PInfoBeepOn;
  ConfirmBeepOn:=PConfirmBeepOn;
  CompletedBeepOn:=PCompletedBeepOn;
  ToolBarMenuOn:=PToolBarMenuOn;
  ToolBarClipOn:=PToolBarClipOn;
  ToolBarExitOn:=PToolBarExitOn;
  ToolBarFileOn:=PToolBarFileOn;
  ToolBarEditOn:=PToolBarEditOn;
  ToolBarZoomOn:=PToolBarZoomOn;
  ToolBarLayerOn:=PToolBarLayerOn;
  ToolBarToolsOn:=PToolBarToolsOn;
    Started := PStarted;
    StartedNameNumber := PStartedNameNumber;
    Colorreg := PColorreg;
    SeedNumber:=PSeedNumber;
    SelectionRadius:=PSelectionRadius;
    Color256S:=PColor256S;
    MessageX := PMessageX;
    MessageY := PMessageY;
    LMOFormY := PLMOFormY; LMOFormX := PLMOFormX;
    LocatableX := PLocatableX; LocatableY := PLocatableY;
    MapBordersColor := PMapBordersColor;
    MapGridsColor := PMapGridsColor;
    MapDatasColor := PMapDatasColor;
    MapBacksColor := PMapBacksColor;
    VRegitFormX:= PVRegitFormX;
    VRegitFormY:=PVRegitFormY;
  MapFormY :=PMapFormY; MapFormX:=PMapFormX;
  LegendFormY :=PLegendFormY; LegendFormX :=PLegendFormX;
        CBFX:=PCBFX;
        CBFY:=PCBFY;
        VoEditfrmY :=PVoEditfrmY;
        VoEditfrmX :=PVoEditfrmX;
    VoEditDbfrmX:=PVoEditDbfrmX;
    VoEditDbfrmY:=PVoEditDbfrmY;
    SystemInfoFormX := PSystemInfoFormX;
    SystemInfoFormY := PSystemInfoFormY;
    NRISoilsfrmY := PNRISoilsfrmY;
    NRISoilsfrmX := PNRISoilsfrmX;
    NRISoilsFormX:=PNRISoilsFormX;
    NRISoilsFormY:=PNRISoilsFormY;
    NRidentifyfrmX:=PNRidentifyfrmX;
    NRidentifyfrmY:=PNRidentifyfrmY;
    viewerfrmX := PviewerfrmX; transfrmX := PtransfrmX;
    propfrmX := PpropfrmX; labelfrmX := PlabelfrmX;
    InputfrmX := PInputfrmX; SoilsfrmX := PSoilsfrmX;
    identifyfrmX := PidentifyfrmX; attribfrmX := PattribfrmX;
    renderedfrmX := PrenderedfrmX; AboutX := PAboutX;
    OptionsfrmX := POptionsfrmX;
    viewerfrmY := PviewerfrmY; transfrmY := PtransfrmY;
    propfrmY := PpropfrmY; labelfrmY := PlabelfrmY;
    InputfrmY := PInputfrmY; SoilsfrmY := PSoilsfrmY;
    identifyfrmY := PidentifyfrmY; attribfrmY := PattribfrmY;
    renderedfrmY := PrenderedfrmY; AboutY := PAboutY;
    OptionsfrmY := POptionsfrmY;
  end;
end;
{---------------------------------------------------------------------}

procedure DoSaver;
var P_File: PrefFile;
var PathS: string;
begin
  PathS := ExtractFilePath(ParamStr(0)) + 'voice.pof';
  GetPreferences;
  AssignFile(P_File, PathS );
  Rewrite(P_File);
  if IoResult <> 0 then DorezError(23);
  write(P_File, PreRcd);
  CloseFile(P_File);
end;
{---------------------------------------------------------------------}

procedure GetPreferences;
begin {before saving}
  with PreRcd do begin
{This is my secret string ? as text?}
    PHiddenString :=HiddenString;
    PColor256Name:=Color256Name;
  PVRMProgramPath:=VRMProgramPath;
  PProjectPath:=ProjectPath;
  PTigerPath:=TigerPath;
  PDotPath:= DotPath;
  PSDTSPath:= SDTSPath;
  PDLGPath:=DLGPath;
  PDXFPath:=DXFPath;
  PShapePath:= ShapePath;
  PVRMDatabase:= VRMDatabase;
  PImagePath := ImagePath;
  PEditingColor:=EditingColor;
  PBackgroundColor:=BackgroundColor;
  PHighlightColor:=HighlightColor;
  PClassStartPanelColor:=ClassStartPanelColor;
  PEditColor:=EditColor;
  PCurrentColor:=CurrentColor;
  PErrorBeepOn:=ErrorBeepOn;
  PWarningBeepOn:=WarningBeepOn;
  PInfoBeepOn :=InfoBeepOn;
  PConfirmBeepOn:=ConfirmBeepOn;
  PCompletedBeepOn:=CompletedBeepOn;
  PToolBarMenuOn:=ToolBarMenuOn;
  PToolBarClipOn:=ToolBarClipOn;
  PToolBarExitOn:=ToolBarExitOn;
  PToolBarFileOn:=ToolBarFileOn;
  PToolBarEditOn:=ToolBarEditOn;
  PToolBarZoomOn:=ToolBarZoomOn;
  PToolBarLayerOn:=ToolBarLayerOn;
  PToolBarToolsOn:=ToolBarToolsOn;
    PSelectionRadius:=SelectionRadius;
    PColor256S:=Color256S;
    PColorreg := Colorreg;
    PSeedNumber:=SeedNumber;    
    PStarted := Started;
    PStartedNameNumber := StartedNameNumber;
    PLMOFormY := LMOFormY; PLMOFormX := LMOFormX;
    PLocatableX := LocatableX; PLocatableY := LocatableY;
    PMapBordersColor := MapBordersColor;
    PMapGridsColor := MapGridsColor;
    PMapDatasColor := MapDatasColor;
    PMapBacksColor := MapBacksColor;    
    PMessageX := MessageX;  PMessageY := MessageY;
        PCBFX:=CBFX;
        PCBFY:=CBFY;
  PMapFormY :=MapFormY; PMapFormX:=MapFormX;
  PLegendFormY :=LegendFormY; PLegendFormX :=LegendFormX;
    PVRegitFormX:= VRegitFormX;
    PVRegitFormY:=VRegitFormY;
    PSystemInfoFormX := SystemInfoFormX;
    PSystemInfoFormY := SystemInfoFormY;
    PVoEditDbfrmX:=VoEditDbfrmX;
    PVoEditDbfrmY:=VoEditDbfrmY;
    PNRISoilsfrmY := NRISoilsfrmY; {NRI Point}
    PNRISoilsfrmX := NRISoilsfrmX;
    PNRISoilsFormX:=NRISoilsFormX;
    PNRISoilsFormY:=NRISoilsFormY;
    PNRidentifyfrmX:=NRidentifyfrmX;
    PNRidentifyfrmY:=NRidentifyfrmY;
        PVoEditfrmY :=VoEditfrmY;
        PVoEditfrmX :=VoEditfrmX;
    PSoilsfrmX := SoilsfrmX;   PSoilsfrmY := SoilsfrmY;
    PviewerfrmX := viewerfrmX; PviewerfrmY := viewerfrmY;
    PtransfrmX := transfrmX;   PtransfrmY := transfrmY;
    PpropfrmX := propfrmX;     PpropfrmY := propfrmY;
    PlabelfrmX := labelfrmX;   PlabelfrmY := labelfrmY;
    PInputfrmX := InputfrmX;   PInputfrmY := InputfrmY;
    PidentifyfrmX := identifyfrmX;  PidentifyfrmY := identifyfrmY;
    PattribfrmX := attribfrmX; PattribfrmY := attribfrmY;
    PrenderedfrmX := renderedfrmX; PrenderedfrmY := renderedfrmY;
    PAboutX := AboutX;         PAboutY := AboutY;
    POptionsfrmX :=  OptionsfrmX;  POptionsfrmY :=  OptionsfrmY;
  end;
end;
{---------------------------------------------------------------------}



end.


