{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit vritransoil; {CREATE USDA NRCS DATABASES}
{ bSSurgo=true }
{ interp_dbTable,
layer_dbTable,
taxclass_dbTable }
interface

uses  Forms, SysUtils, Controls, DBTables,Db;
{Windows,  Classes, Messages,  Graphics,
  Dialogs, Gauges, ComCtrls, StdCtrls, Buttons,
  ExtCtrls, Math, ;}

procedure Transoildodb;

implementation

uses LoGlobals, LOResMess, vritransfrm;

(******************************************************************)
{      dBase
C	1 - 254		Character (alpha)
F*	1 - 20	0 - 18, and <=Size - 2	Float (numeric)
N	1 - 20**	0 - 18, and <= Size - 2	Number (BCD)
Paradox
        A	1 - 255	Alpha
 N		Number
 $		Money
 S		Short
 I		Long Integer
 }

procedure Transoildodb;
var
  LineEnder10, LineEnder13, bSSurgo: Boolean;
  Ch: Char;
  Count, Ido, iLineEnder,
    ISur, IChar2, IChar, ErrorCodex, ShapeI: Integer;
  ShapeAttributeN3: Double;
  STSSAIDtemp, MUIDtemp, SEQNUMtemp, MUSYMtemp, COMPNAMEtemp,
    S5IDtemp,InString, temp2, temp, {tempstr,}
    StateDataSPath, StateDataSName, LineEnder,
    StateShapeSPath, StateShapeSPathS, StateShapeSName: string;
    comp_dbTable,  interp_dbTable,
    compyld_dbTable, rsprod_dbTable,
    forest_dbTable,  woodland_dbTable, plantcom_dbTable,
    windbrk_dbTable,  wlhabit_dbTable,   woodmgt_dbTable,
    layer_dbTable,
    plantnm_dbTable,yldunits_dbTable,taxclass_dbTable,
{STATSGO only}  state_dbTable,
mapunit_dbTable {both?},
{SSURGO only}
  helclass_dbTable, inclusn_dbTable,
  mucoacre_dbTable, muyld_dbTable,
  rangenm_dbTable, ssacoac_dbTable, ssarea_dbTable,
  hydcomp_dbTable{?}, muident_dbTable{?}: TTable;
  F1: TextFile;
begin {State: Statsgo}
  if ((not (Transformer.StatsgoEdit.Text = 'Data directory'))
    and (not (Transformer.StatsgoShapeEdit.Text = 'Shape Directory')))
      then
  begin
     {inc(MyPDbCount);}{ Initialize MyDbCount early on }
     {RunTimeDbCreate(const DatabaseName, SessionName: String): TDatabase;}
    MyPDatabase[MyPDbCount] :=
    Transformer.RunTimeDbCreateP('statsgo'+IntToStr(MyPDbCount),'');
    Screen.Cursor := crHourglass; {crDefault}
{--------------------------------------------------------}
    StateDataSPath := ExtractFilePath(StateStatsgoStr);
{--------------------------------------------------------}
{Check for Statsgo or Ssurgo data}
    if FileExists(StateDataSPath + 'helclass') then
    begin
      bSSurgo := True;
      StateShapeSPath := ExtractFilePath(StateStatsgoShapeStr);
      StateShapeSPath := StateShapeSPath + 'Ss_';
    end else
    begin
    bSSurgo := False;
    StateShapeSPath := copy(StateStatsgoShapeStr, 1,
      (length(StateStatsgoShapeStr) - 4));
    StateShapeSPath := StateShapeSPath + '_';
    end;
{--------------------------------------------------------}
{--------------------------------------------------------}
    if (bSSurgo = false) then
    begin
{--------------------------------------------------------}
{Make a database table      comp}
      if FileExists(StateDataSPath + 'comp') then
      begin
       {temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('comp');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption := 'Making comp Table (1 of 15)';
        comp_dbTable := TTable.Create(Transformer);
        with comp_dbTable do
        begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox; {ttDBase;}
          TableName := StateShapeSName + '.db';
          with FieldDefs do
          begin
            Clear;
            with AddFieldDef do
            begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do
            begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do
            begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
                {Size:=31;  2#s}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'MUSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'COMPNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 30;
            end;
            with AddFieldDef do begin
              Name := 'S5ID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 6;
            end;
            with AddFieldDef do begin
              Name := 'COMPPCT';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=7;   3 }
            end;
            with AddFieldDef do begin
              Name := 'SLOPEL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=7;   2 }
            end;
            with AddFieldDef do begin
              Name := 'SLOPEH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=7;   2 }
            end;
            with AddFieldDef do begin
              Name := 'SURFTEX';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'OTHERPH';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 40;
            end;
            with AddFieldDef do begin
              Name := 'COMPKIND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'COMPACRE';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=6;   6}
            end;
            with AddFieldDef do begin
              Name := 'CLASCODE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 20;
            end;
            with AddFieldDef do begin
              Name := 'ANFLOOD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'ANFLODUR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 12;
            end;
            with AddFieldDef do begin
              Name := 'ANFLOBEG';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'ANFLOEND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'GSFLOOD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'GSFLODUR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 12;
            end;
            with AddFieldDef do begin
              Name := 'GSFLOBEG';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'GSFLOEND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'WTDEPL';
              DataType := ftFloat;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  4.1}
            end;
            with AddFieldDef do begin
              Name := 'WTDEPH';
              DataType := ftFloat;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  4.1}
            end;
            with AddFieldDef do begin
              Name := 'WTKIND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'WTBEG';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'WTEND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'PNDDEPL';
              DataType := ftFloat;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  4.1}
            end;
            with AddFieldDef do begin
              Name := 'PNDDEPH';
              DataType := ftFloat;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  4.1}
            end;
            with AddFieldDef do begin
              Name := 'PNDDUR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 10;
            end;
            with AddFieldDef do begin
              Name := 'PNDBEG';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'PNDEND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'ROCKDEPL';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2.1}
            end;
            with AddFieldDef do begin
              Name := 'ROCKDEPH';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2.1}
            end;
            with AddFieldDef do begin
              Name := 'ROCKHARD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 4;
            end;
            with AddFieldDef do begin
              Name := 'PANDEPL';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'PANDEPH';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'PANHARD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'SUBINITL';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'SUBINITH';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'SUBTOTL';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'SUBTOTH';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'HYDGRP';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'FROSTACT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'DRAINAGE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'HYDRIC';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'CORCON';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'CORSTEEL';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'CLNIRR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'CLIRR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'SCLNIRR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SCLIRR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            if (bSSurgo = false) then begin
              with AddFieldDef do begin
                Name := 'PRIMFML';
                DataType := ftString;
                  {ftInteger ftString Required := True;}
                Size := 2;
              end;
            end;
          end; {Fielddefs}

    { Next, describe any indexes ... dBase table so NO INDEX}
    { Next, describe any indexes Paradox so first is KEY }
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID;SEQNUMS';
        Options := [ixPrimary];
      end;
{      with AddIndexDef do begin
        Name := 'ClascodeIndx';
        Fields := 'CLASCODE';
        Options := [];
      end;  }
    end;*)
          CreateTable;
        end;
        Count := 0;
        comp_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString);
        Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
{   inc(Count);str(Count,temp);
   Transformer.THints.Caption:='Making comp Table '+temp;}
          Application.ProcessMessages;
          Readln(F1, InString);
          comp_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          STSSAIDtemp := temp;

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp;
          IChar := IChar2; {for more than ... then dupe second}
{   Transformer.THints.Caption:='Making comp Table '+temp;
      Application.ProcessMessages;}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUSYMtemp := temp;
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          COMPNAMEtemp := temp;
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          if (length(temp) = 1) then SEQNUMtemp := '0' + temp else
            SEQNUMtemp := temp;
          IChar := IChar2; {for more than ... then dupe second}
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          comp_dbTable.FieldValues['MUID'] := MUIDtemp; {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          comp_dbTable.FieldValues['SEQNUM'] := ShapeI; {Second item}
          comp_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
            {First item}
          comp_dbTable.FieldValues['MUSYM'] := MUSYMtemp;
            {Second item}
          comp_dbTable.FieldValues['COMPNAME'] := COMPNAMEtemp;
            {Second item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['S5ID'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['COMPPCT'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SLOPEL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SLOPEH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['SURFTEX'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['OTHERPH'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['COMPKIND'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['COMPACRE'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['CLASCODE'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['ANFLOOD'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['ANFLODUR'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['ANFLOBEG'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['ANFLOEND'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['GSFLOOD'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['GSFLODUR'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['GSFLOBEG'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['GSFLOEND'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          comp_dbTable.FieldValues['WTDEPL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          comp_dbTable.FieldValues['WTDEPH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['WTKIND'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['WTBEG'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['WTEND'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          comp_dbTable.FieldValues['PNDDEPL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          comp_dbTable.FieldValues['PNDDEPH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['PNDDUR'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['PNDBEG'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['PNDEND'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['ROCKDEPL'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['ROCKDEPH'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['ROCKHARD'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['PANDEPL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['PANDEPH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['PANHARD'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SUBINITL'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SUBINITH'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SUBTOTL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SUBTOTH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['HYDGRP'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['FROSTACT'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['DRAINAGE'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['HYDRIC'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['CORCON'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['CORSTEEL'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['CLNIRR'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['CLIRR'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          comp_dbTable.FieldValues['SCLNIRR'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          if (bSSurgo = false) then begin
            temp2 := Copy(InString, IChar, length(InString));
            InString := temp2;
            IChar2 := Pos(#9, temp2);
            if (IChar2 = 1) then
            begin
              InString[IChar2] := ' ';
              temp2[IChar2] := ' ';
              IChar2 := Pos(#9, temp2);
            end;
            temp2 := Copy(InString, 1, IChar2);
            for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
              temp2[Ido] := ' ';
            temp := trim(temp2);
            if (length(temp) = 0) then temp := '.';
            comp_dbTable.FieldValues['SCLIRR'] := temp; {Second item}
             {IChar :=IChar2;}{for more than ... then dupe second}
            temp2 := Copy(InString, (IChar2), length(InString));
              {Last item}
            for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
              temp2[Ido] := ' ';
            temp := trim(temp2);
            comp_dbTable.FieldValues['PRIMFML'] := temp;
          end else begin
            temp2 := Copy(InString, (IChar2), length(InString));
              {Last item}
            for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
              temp2[Ido] := ' ';
            temp := trim(temp2);
            comp_dbTable.FieldValues['SCLIRR'] := temp;
          end;
          comp_dbTable.Post;
        end;
        comp_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        comp_dbTable.AddIndex('', 'MUID;SEQNUMS', [ixPrimary]);

      end; {COMP}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'compyld') then begin
{Make a database table       compyld}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('compyld');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making compyld Table  (2 of 15)';
        compyld_dbTable := TTable.Create(Transformer);
        with compyld_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'CROPNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 30;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=31;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'NIRRYLD';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=7;   8.1}
            end;
            with AddFieldDef do begin
              Name := 'IRRYLD';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=7;   8.1}
            end;
          end; {Fielddefs}
    { Next, describe any indexes }
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID;SEQNUMS';
        Options := [ixPrimary];
      end;
    end;*)
          CreateTable;
        end;

        compyld_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          compyld_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          STSSAIDtemp := temp; {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          SEQNUMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          compyld_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          compyld_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          compyld_dbTable.FieldValues['CROPNAME'] := temp;
            {Second item}
          compyld_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          compyld_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
            {First item}

          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          compyld_dbTable.FieldValues['NIRRYLD'] := ShapeAttributeN3;
            {Second item}
{IChar :=IChar2;}{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          Val(temp, ShapeAttributeN3, ErrorCodex);
          compyld_dbTable.FieldValues['IRRYLD'] := ShapeAttributeN3;
          compyld_dbTable.Post;
        end;
        compyld_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        compyld_dbTable.AddIndex('', 'MUID;SEQNUMS;CROPNAME',
          [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'forest') then begin
{Make a database table       forest}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('forest');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making forest Table (3 of 15)';
        forest_dbTable := TTable.Create(Transformer);
        with forest_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'PLANTSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=31;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'PLANTCOV';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=7;   3}
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID;SEQNUMS';
        Options := [ixPrimary];
      end;
{      with AddIndexDef do begin
        Name := 'PSymIndx';
        Fields := 'PLANTSYM';
        Options := [];
      end;}
    end;*)
          CreateTable;
        end;

        forest_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          forest_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          STSSAIDtemp := temp; {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          SEQNUMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          forest_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          forest_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          forest_dbTable.FieldValues['PLANTSYM'] := temp;
            {Second item}
          forest_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          forest_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
{IChar :=IChar2;}{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          Val(temp, ShapeI, ErrorCodex);
          forest_dbTable.FieldValues['PLANTCOV'] := ShapeI;
          forest_dbTable.Post;
        end;
        forest_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        forest_dbTable.AddIndex('', 'MUID;SEQNUMS;PLANTSYM',
          [ixPrimary]);

      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'interp') then begin
{Make a database table       interp}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('interp');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making interp Table (4 of 15)';
        interp_dbTable := TTable.Create(Transformer);
        with interp_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'GRPCODE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=31;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'RATING';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'RESTCT1';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'RESTCT2';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'RESTCT3';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID;SEQNUMS';
        Options := [ixPrimary];
      end;
{      with AddIndexDef do begin
        Name := 'PSymIndx';
        Fields := 'PLANTSYM';
        Options := [];
      end;}
    end;*)
          CreateTable;
        end;

        interp_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          interp_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          STSSAIDtemp := temp; {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          SEQNUMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          interp_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          interp_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          interp_dbTable.FieldValues['GRPCODE'] := temp; {Second item}
          interp_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          interp_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          interp_dbTable.FieldValues['RESTCT1'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          interp_dbTable.FieldValues['RESTCT2'] := temp; {Second item}
{IChar :=IChar2;}{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          interp_dbTable.FieldValues['RESTCT3'] := temp;
          interp_dbTable.Post;
        end;
        interp_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        interp_dbTable.AddIndex('', 'MUID;SEQNUMS;GRPCODE',
          [ixPrimary]);

      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'layer') then begin
{Make a database table       layer}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('layer');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption := 'Making layer Table (5 of 15)';
        layer_dbTable := TTable.Create(Transformer);
        with layer_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'LAYERNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=31;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'S5ID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 6;
            end;
            with AddFieldDef do begin
              Name := 'LAYERNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  1}
            end;
            with AddFieldDef do begin
              Name := 'LAYERID';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  1}
            end;
            with AddFieldDef do begin
              Name := 'LAYDEPL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  1}
            end;
            with AddFieldDef do begin
              Name := 'LAYDEPH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  1}
            end;
            with AddFieldDef do begin
              Name := 'TEXTURE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
{            with AddFieldDef do begin
              Name := 'TEXTURE2';
              DataType := ftString;
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'TEXTURE3';
              DataType := ftString;
              Size := 8;
            end;}
            with AddFieldDef do begin
              Name := 'KFACT';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=8;  4.2}
            end;
            with AddFieldDef do begin
              Name := 'KFFACT';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=8;  4.2}
            end;
            with AddFieldDef do begin
              Name := 'TFACT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'WEG';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'INCH10L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'INCH10H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'INCH3L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'INCH3H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'NO4L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO4H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO10L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO10H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO40L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO40H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO200L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO200H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'CLAYL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'CLAYH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'LLL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'LLH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'PIL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'PIH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'UNIFIED';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
{            with AddFieldDef do begin
              Name := 'UNIFIED2';
              DataType := ftString;
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'UNIFIED3';
              DataType := ftString;
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'UNIFIED4';
              DataType := ftString;
              Size := 5;
            end;}
            with AddFieldDef do begin
              Name := 'AASHTO';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
{            with AddFieldDef do begin
              Name := 'AASHTO2';
              DataType := ftString;
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'AASHTO3';
              DataType := ftString;
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'AASHTO4';
              DataType := ftString;
              Size := 5;
            end;}
            with AddFieldDef do begin
              Name := 'AASHIND';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.1}
            end;
            with AddFieldDef do begin
              Name := 'AWCL';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.2}
            end;
            with AddFieldDef do begin
              Name := 'AWCH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.2}
            end;
            with AddFieldDef do begin
              Name := 'BDL';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.2}
            end;
            with AddFieldDef do begin
              Name := 'BDH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.2}
            end;
            with AddFieldDef do begin
              Name := 'OML';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.1}
            end;
            with AddFieldDef do begin
              Name := 'OMH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.1}
            end;
            with AddFieldDef do begin
              Name := 'PHL';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.1}
            end;
            with AddFieldDef do begin
              Name := 'PHH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.1}
            end;
            with AddFieldDef do begin
              Name := 'SALINL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'SALINH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'SARL';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.1}
            end;
            with AddFieldDef do begin
              Name := 'SARH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.1}
            end;
            with AddFieldDef do begin
              Name := 'CECL';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.1}
            end;
            with AddFieldDef do begin
              Name := 'CECH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.1}
            end;
            with AddFieldDef do begin
              Name := 'CACO3L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'CACO3H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'GYPSUML';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'GYPSUMH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'PERML';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.2}
            end;
            with AddFieldDef do begin
              Name := 'PERMH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.2}
            end;
            with AddFieldDef do begin
              Name := 'SHRINKSW';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 10;
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID;SEQNUMS';
        Options := [ixPrimary];
      end;
{      with AddIndexDef do begin
        Name := 'PSymIndx';
        Fields := 'PLANTSYM';
        Options := [];
      end;}
    end;*)
          CreateTable;
        end;

        layer_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          layer_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          STSSAIDtemp := temp; {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          SEQNUMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          S5IDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';

          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          layer_dbTable.FieldValues['MUID'] := MUIDtemp; {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          layer_dbTable.FieldValues['LAYERNUMS'] := temp;
          layer_dbTable.FieldValues['SEQNUM'] := ShapeI; {Second item}
          layer_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          layer_dbTable.FieldValues['S5ID'] := S5IDtemp;
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LAYERNUM'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LAYERID'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LAYDEPL'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LAYDEPH'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['TEXTURE'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
(*
          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['TEXTURE2'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['TEXTURE3'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
*)
          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['KFACT'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['KFFACT'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['TFACT'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['WEG'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['INCH10L'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['INCH10H'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['INCH3L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['INCH3H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO4L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO4H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO10L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO10H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO40L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO40H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO200L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO200H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['CLAYL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['CLAYH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LLL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LLH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['PIL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['PIH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['UNIFIED'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
(*
          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['UNIFIED2'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['UNIFIED3'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['UNIFIED4'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
*)
          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['AASHTO'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
(*
          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['AASHTO2'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['AASHTO3'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          layer_dbTable.FieldValues['AASHTO4'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
*)
          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['AASHIND'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['AWCL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['AWCH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['BDL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['BDH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['OML'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['OMH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['PHL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['PHH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['SALINL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['SALINH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['SARL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['SARH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['CECL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['CECH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['CACO3L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['CACO3H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['GYPSUML'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['GYPSUMH'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['PERML'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0.0';
          Val(temp, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['PERMH'] := ShapeAttributeN3;
            {Second item}
{IChar :=IChar2;}{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          layer_dbTable.FieldValues['SHRINKSW'] := temp;
          layer_dbTable.Post;
        end;
        layer_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        layer_dbTable.AddIndex('', 'MUID;SEQNUMS;LAYERNUMS',
          [ixPrimary]);
      end; {LAYERNUM}

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'mapunit') then begin
{Make a database table       mapunit}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('mapunit');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making mapunit Table (6 of 15)';
        mapunit_dbTable := TTable.Create(Transformer);
        with mapunit_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'SSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'MUSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'MUNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 109;
            end;
            with AddFieldDef do begin
              Name := 'MUKIND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'MLRA';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 4;
            end;
            with AddFieldDef do begin
              Name := 'PRIMFML';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'MUACRES';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=31;  6}
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID';
        Options := [ixPrimary];
      end;
    end;*)
          CreateTable;
        end;

        mapunit_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          mapunit_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          STSSAIDtemp := temp; {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          COMPNAMEtemp := temp; {SSAID Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUSYMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
          mapunit_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          mapunit_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
            {First item}
          mapunit_dbTable.FieldValues['SSAID'] := COMPNAMEtemp;
          mapunit_dbTable.FieldValues['MUSYM'] := MUSYMtemp;
            {Second item}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          mapunit_dbTable.FieldValues['MUNAME'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          mapunit_dbTable.FieldValues['MUKIND'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          mapunit_dbTable.FieldValues['MLRA'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          mapunit_dbTable.FieldValues['PRIMFML'] := temp;
            {Second item}
{IChar :=IChar2;}{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          Val(temp, ShapeI, ErrorCodex);
          mapunit_dbTable.FieldValues['MUACRES'] := ShapeI;
          mapunit_dbTable.Post;
        end;
        mapunit_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        mapunit_dbTable.AddIndex('', 'MUID', [ixPrimary]);

      end; {}

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'plantcom') then begin
{Make a database table       plantcom}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('plantcom');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making plantcom Table (7 of 15)';
        plantcom_dbTable := TTable.Create(Transformer);
        with plantcom_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'PLANTSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'PLANTPCT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID;SEQNUMS';
        Options := [ixPrimary];
      end;
{      with AddIndexDef do begin
        Name := 'PSymIndx';
        Fields := 'PLANTSYM';
        Options := [];
      end;            }
    end;*)
          CreateTable;
        end;

        plantcom_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          plantcom_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          STSSAIDtemp := temp; {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          SEQNUMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          plantcom_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          if (ShapeI > 26) then ShapeI := 26 else
            if (ShapeI < 1) then ShapeI := 1;
          plantcom_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          plantcom_dbTable.FieldValues['PLANTSYM'] := temp;
            {Second item}
          plantcom_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          plantcom_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
{IChar :=IChar2;}{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          plantcom_dbTable.FieldValues['PLANTPCT'] := temp;
          plantcom_dbTable.Post;
        end;
        plantcom_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        plantcom_dbTable.AddIndex('', 'MUID;SEQNUMS;PLANTSYM',
          [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'plantnm') then begin
{Make a database table       plantnm}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('plantnm');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making plantnm Table (8 of 15)';
        plantnm_dbTable := TTable.Create(Transformer);
        with plantnm_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'PLANTSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SCINAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 60;
            end;
            with AddFieldDef do begin
              Name := 'COMNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 31;
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
{    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'PLANTSYM,;SCINAME;COMNAME';
        Options := [ixPrimary];
      end;
    end;}
          CreateTable;
        end;

        plantnm_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          plantnm_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          plantnm_dbTable.FieldValues['PLANTSYM'] := temp;
            {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          plantnm_dbTable.FieldValues['SCINAME'] := temp;
            {Second item}
{IChar :=IChar2; for more than ... then dupe second}
          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          plantnm_dbTable.FieldValues['COMNAME'] := temp;
          plantnm_dbTable.Post;
        end;
        plantnm_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        plantnm_dbTable.AddIndex('', 'PLANTSYM;SCINAME;COMNAME',
          [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'rsprod') then begin
{Make a database table       rsprod}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('rsprod');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making rsprod Table (9 of 15)';
        rsprod_dbTable := TTable.Create(Transformer);
        with rsprod_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'RSID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'RSNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 51;
            end;
            with AddFieldDef do begin
              Name := 'PRODFAV';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  5}
            end;
            with AddFieldDef do begin
              Name := 'PRODNORM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  5}
            end;
            with AddFieldDef do begin
              Name := 'PRODUNFV';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  5}
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID;SEQNUMS';
        Options := [ixPrimary];
      end;
{IF bSsurgo then
      with AddIndexDef do begin
        Name := 'RsidIndx';
        Fields := 'RSID';
        Options := [];
      end;}
    end;*)
          CreateTable;
        end;

        rsprod_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          rsprod_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          STSSAIDtemp := temp; {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          SEQNUMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          rsprod_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          rsprod_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          rsprod_dbTable.FieldValues['RSID'] := temp; {Second item}
          rsprod_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          rsprod_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          rsprod_dbTable.FieldValues['RSNAME'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          Val(temp, ShapeI, ErrorCodex);
          rsprod_dbTable.FieldValues['PRODFAV'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          Val(temp, ShapeI, ErrorCodex);
          rsprod_dbTable.FieldValues['PRODNORM'] := ShapeI;
            {Second item}
{IChar :=IChar2; }{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          Val(temp, ShapeI, ErrorCodex);
          rsprod_dbTable.FieldValues['PRODUNFV'] := ShapeI;
          rsprod_dbTable.Post;
        end;
        rsprod_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        rsprod_dbTable.AddIndex('', 'MUID;SEQNUMS;RSID',
          [ixPrimary]);

      end; {}

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'taxclass') then begin
{Make a database table       taxclass}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('taxclass');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making taxclass Table (10 of 15)';
        taxclass_dbTable := TTable.Create(Transformer);
        with taxclass_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'CLASCODE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 20;
            end;
            with AddFieldDef do begin
              Name := 'CLASS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 120;
            end;
            with AddFieldDef do begin
              Name := 'ORDER';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'SUBORDER';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'GRTGROUP';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'SUBGROUP';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 4;
            end;
            with AddFieldDef do begin
              Name := 'PARTSIZE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'MINALOGY';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'REACTION';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SOILTEMP';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'OTHERFAM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
{    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := 'taxIndx';
        Fields := 'CLASCODE;CLASS';
        Options := [ixPrimary];
      end;
    end;  }
          CreateTable;
        end;

        taxclass_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          taxclass_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          taxclass_dbTable.FieldValues['CLASCODE'] := temp;
            {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          taxclass_dbTable.FieldValues['CLASS'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          taxclass_dbTable.FieldValues['ORDER'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          taxclass_dbTable.FieldValues['SUBORDER'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          taxclass_dbTable.FieldValues['GRTGROUP'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          taxclass_dbTable.FieldValues['SUBGROUP'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          taxclass_dbTable.FieldValues['PARTSIZE'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          taxclass_dbTable.FieldValues['MINALOGY'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          taxclass_dbTable.FieldValues['REACTION'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          taxclass_dbTable.FieldValues['SOILTEMP'] := temp;
            {Second item}
{IChar :=IChar2;}{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          taxclass_dbTable.FieldValues['OTHERFAM'] := temp;
          taxclass_dbTable.Post;
        end;
        taxclass_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        taxclass_dbTable.AddIndex('', 'CLASCODE;CLASS', [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'windbrk') then begin
{Make a database table       windbrk}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('windbrk');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making windbrk Table (11 of 15)';
        windbrk_dbTable := TTable.Create(Transformer);
        with windbrk_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'PLANTSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'WNDBRKHT';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  3}
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID;SEQNUMS';
        Options := [ixPrimary];
      end;
{      with AddIndexDef do begin
        Name := 'PSymIndx';
        Fields := 'PLANTSYM';
        Options := [];
      end;}
    end;          *)
          CreateTable;
        end;

        windbrk_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          windbrk_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          STSSAIDtemp := temp; {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          SEQNUMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          windbrk_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          windbrk_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          windbrk_dbTable.FieldValues['PLANTSYM'] := temp;
            {Second item}
          windbrk_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          windbrk_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
{IChar :=IChar2;}{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          Val(temp, ShapeI, ErrorCodex);
          windbrk_dbTable.FieldValues['WNDBRKHT'] := ShapeI;
          windbrk_dbTable.Post;
        end;
        windbrk_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        windbrk_dbTable.AddIndex('', 'MUID;SEQNUMS;PLANTSYM',
          [ixPrimary]);

      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'wlhabit') then begin
{Make a database table       wlhabit}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('wlhabit');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making wlhabit Table (12 of 15)';
        wlhabit_dbTable := TTable.Create(Transformer);
        with wlhabit_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'WLGRAIN';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLGRASS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLHERB';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLHARD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLCONIF';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLSHRUB';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLWETPLT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLSHLWAT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLOPEN';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLWOOD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLWET';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'RLRANGE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID;SEQNUMS';
        Options := [ixPrimary];
      end;
{      with AddIndexDef do begin
        Name := 'PSymIndx';
        Fields := 'PLANTSYM';
        Options := [];
      end;}
    end;          *)
          CreateTable;
        end;

        wlhabit_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          wlhabit_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          STSSAIDtemp := temp; {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          SEQNUMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          wlhabit_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          wlhabit_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          wlhabit_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          wlhabit_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          wlhabit_dbTable.FieldValues['WLGRAIN'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          wlhabit_dbTable.FieldValues['WLGRASS'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          wlhabit_dbTable.FieldValues['WLHERB'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          wlhabit_dbTable.FieldValues['WLHARD'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          wlhabit_dbTable.FieldValues['WLCONIF'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          wlhabit_dbTable.FieldValues['WLSHRUB'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          wlhabit_dbTable.FieldValues['WLWETPLT'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          wlhabit_dbTable.FieldValues['WLSHLWAT'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          wlhabit_dbTable.FieldValues['WLOPEN'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          wlhabit_dbTable.FieldValues['WLWOOD'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          wlhabit_dbTable.FieldValues['WLWET'] := temp; {Second item}
{IChar :=IChar2; }{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          wlhabit_dbTable.FieldValues['RLRANGE'] := temp;
          wlhabit_dbTable.Post;
        end;
        wlhabit_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        wlhabit_dbTable.AddIndex('', 'MUID;SEQNUMS', [ixPrimary]);
      end; {}

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'woodland') then begin
{Make a database table       woodland}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('woodland');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making woodland Table (13 of 15)';
        woodland_dbTable := TTable.Create(Transformer);
        with woodland_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'PLANTSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'SUITCODE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;

            with AddFieldDef do begin
              Name := 'SITIND';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  3}
            end;
            with AddFieldDef do begin
              Name := 'WOODPROD';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID;SEQNUMS';
        Options := [ixPrimary];
      end;
{      with AddIndexDef do begin
        Name := 'PSymIndx';
        Fields := 'PLANTSYM';
        Options := [];
      end;}
    end;          *)
          CreateTable;
        end;

        woodland_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          woodland_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          STSSAIDtemp := temp; {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          SEQNUMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          S5IDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          woodland_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          woodland_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          woodland_dbTable.FieldValues['PLANTSYM'] := temp;
            {Second item}
          woodland_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          woodland_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          woodland_dbTable.FieldValues['SUITCODE'] := S5IDtemp;
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          Val(temp, ShapeI, ErrorCodex);
          woodland_dbTable.FieldValues['SITIND'] := ShapeI;
            {Second item}
{IChar :=IChar2;}{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          Val(temp, ShapeI, ErrorCodex);
          woodland_dbTable.FieldValues['WOODPROD'] := ShapeI;
          woodland_dbTable.Post;
        end;
        woodland_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        woodland_dbTable.AddIndex('', 'MUID;SEQNUMS;PLANTSYM',
          [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'woodmgt') then begin
{Make a database table       woodmgt}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('woodmgt');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making woodmgt Table (14 of 15)';
        woodmgt_dbTable := TTable.Create(Transformer);
        with woodmgt_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'ORDSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'WDEROSN';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'WDEQUIP';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'WDSEED';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'WDWIND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'WDPLANT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
(*    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := '';
        Fields := 'MUID;SEQNUMS';
        Options := [ixPrimary];
      end;
{      with AddIndexDef do begin
        Name := 'PSymIndx';
        Fields := 'PLANTSYM';
        Options := [];
      end;}
    end;          *)
          CreateTable;
        end;

        woodmgt_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          woodmgt_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          STSSAIDtemp := temp; {First item}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          MUIDtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '0';
          SEQNUMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          woodmgt_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          woodmgt_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          woodmgt_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          woodmgt_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          woodmgt_dbTable.FieldValues['ORDSYM'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          woodmgt_dbTable.FieldValues['WDEROSN'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          woodmgt_dbTable.FieldValues['WDEQUIP'] := temp;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          woodmgt_dbTable.FieldValues['WDSEED'] := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then
          begin
            InString[IChar2] := ' ';
            temp2[IChar2] := ' ';
            IChar2 := Pos(#9, temp2);
          end;
          temp2 := Copy(InString, 1, IChar2);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          if (length(temp) = 0) then temp := '.';
          woodmgt_dbTable.FieldValues['WDWIND'] := temp; {Second item}
{IChar :=IChar2;}{for more than ... then dupe second}

          temp2 := Copy(InString, (IChar2), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          woodmgt_dbTable.FieldValues['WDPLANT'] := temp;
          woodmgt_dbTable.Post;
        end;
        woodmgt_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        woodmgt_dbTable.AddIndex('', 'MUID;SEQNUMS', [ixPrimary]);
      end; {}

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'yldunits') then begin
{Make a database table       yldunits}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('yldunits');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making yldunits Table (15 of 15)';
        yldunits_dbTable := TTable.Create(Transformer);
        with yldunits_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'CROPNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 31;
            end;
            with AddFieldDef do begin
              Name := 'YLDUNITS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
{    with IndexDefs do begin
      Clear;
      with AddIndexDef do begin
        Name := 'YldUIndx';
        Fields := 'CROPNAME';
        Options := [];
      end;
    end;}
          CreateTable;
        end;

        yldunits_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          yldunits_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          yldunits_dbTable.FieldValues['CROPNAME'] := temp;
            {First item}

          temp2 := Copy(InString, (IChar), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          yldunits_dbTable.FieldValues['YLDUNITS'] := temp;
          yldunits_dbTable.Post;
        end;
        yldunits_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
        yldunits_dbTable.AddIndex('', 'CROPNAME;YLDUNITS',
          [ixPrimary]);
      end;

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'state') then begin
{Make a database table       state}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('state');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making state Table (16 of 15)';
        state_dbTable := TTable.Create(Transformer);
        with state_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'STATE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SCREDATE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 4;
            end;
          end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
          CreateTable;
        end;

        state_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        Readln(F1, InString); Readln(F1, InString); {get past header}
        while (not eof(F1)) do begin
          Application.ProcessMessages;
          Readln(F1, InString);
          state_dbTable.Append;
          IChar := Pos(#9, InString);
          temp2 := Copy(InString, 1, IChar);
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          state_dbTable.FieldValues['STATE'] := temp; {First item}

          temp2 := Copy(InString, (IChar), length(InString));
            {Last item}
          for Ido := 1 to length(temp2) do if temp2[Ido] = #9 then
            temp2[Ido] := ' ';
          temp := trim(temp2);
          state_dbTable.FieldValues['SCREDATE'] := temp;
          state_dbTable.Post;
        end;
        state_dbTable.Active := False;
        CloseFile(F1);
{        Val(temp,ShapeAttributeN3,ErrorCodex); ShapeAttributeN3}
{        Val(temp,ShapeI,ErrorCodex); ShapeI}
{--------------------------------------------------------}
      end; {}
{--------------------------------------------------------}
    end; {MAKING STATSGO TABLES}
{--------------------------------------------------------}
{--------------------------------------------------------}
{--------------------------------------------------------}
{--------------------------------------------------------}
Transformer.THints.Caption := 'Making additional SSURGO Tables';
{--------------------------------------------------------}
    if (bSSurgo = true) then begin
{--------------------------------------------------------}
{Make a database table      comp}
      if FileExists(StateDataSPath + 'comp') then begin
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('comp');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption := 'Making comp Table (1 of 15)';
        comp_dbTable := TTable.Create(Transformer);
        with comp_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox; {ttDBase;}
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=31;  2#s}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'MUSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'COMPNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 30;
            end;
            with AddFieldDef do begin
              Name := 'S5ID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 6;
            end;
            with AddFieldDef do begin
              Name := 'COMPPCT';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=7;   3 }
            end;
            with AddFieldDef do begin
              Name := 'SLOPEL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=7;   2 }
            end;
            with AddFieldDef do begin
              Name := 'SLOPEH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=7;   2 }
            end;
            with AddFieldDef do begin
              Name := 'SURFTEX';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'OTHERPH';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 40;
            end;
            with AddFieldDef do begin
              Name := 'COMPKIND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'COMPACRE';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=6;   6}
            end;
            with AddFieldDef do begin
              Name := 'CLASCODE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 20;
            end;
            with AddFieldDef do begin
              Name := 'ANFLOOD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'ANFLODUR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 12;
            end;
            with AddFieldDef do begin
              Name := 'ANFLOBEG';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'ANFLOEND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'GSFLOOD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'GSFLODUR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 12;
            end;
            with AddFieldDef do begin
              Name := 'GSFLOBEG';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'GSFLOEND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'WTDEPL';
              DataType := ftFloat;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  4.1}
            end;
            with AddFieldDef do begin
              Name := 'WTDEPH';
              DataType := ftFloat;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  4.1}
            end;
            with AddFieldDef do begin
              Name := 'WTKIND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'WTBEG';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'WTEND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'PNDDEPL';
              DataType := ftFloat;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  4.1}
            end;
            with AddFieldDef do begin
              Name := 'PNDDEPH';
              DataType := ftFloat;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  4.1}
            end;
            with AddFieldDef do begin
              Name := 'PNDDUR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 10;
            end;
            with AddFieldDef do begin
              Name := 'PNDBEG';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'PNDEND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'ROCKDEPL';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2.1}
            end;
            with AddFieldDef do begin
              Name := 'ROCKDEPH';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2.1}
            end;
            with AddFieldDef do begin
              Name := 'ROCKHARD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 4;
            end;
            with AddFieldDef do begin
              Name := 'PANDEPL';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'PANDEPH';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'PANHARD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'SUBINITL';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'SUBINITH';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'SUBTOTL';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'SUBTOTH';
              DataType := ftInteger;
                {ftFloat ftInteger ftString Required := True;}
        {Size:=1;  2}
            end;
            with AddFieldDef do begin
              Name := 'HYDGRP';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'FROSTACT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'DRAINAGE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'HYDRIC';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'CORCON';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'CORSTEEL';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'CLNIRR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'CLIRR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'SCLNIRR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SCLIRR';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
          end; {Fielddefs}
          CreateTable;
        end;
        Count := 0;
        comp_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
        DoRezError( 30002);
          comp_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else begin
        DoRezError( 30004);
          comp_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          comp_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2;

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2;
          IChar := IChar2; {for more than ... then dupe second}
{   Transformer.THints.Caption:='Making comp Table '+temp;
      Application.ProcessMessages;}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUSYMtemp := temp2;
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          COMPNAMEtemp := temp2;
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2;
          IChar := IChar2; {for more than ... then dupe second}
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          comp_dbTable.FieldValues['MUID'] := MUIDtemp; {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          comp_dbTable.FieldValues['SEQNUM'] := ShapeI; {Second item}
          comp_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
            {First item}
          comp_dbTable.FieldValues['MUSYM'] := MUSYMtemp;
            {Second item}
          comp_dbTable.FieldValues['COMPNAME'] := COMPNAMEtemp;
            {Second item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['S5ID'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['COMPPCT'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SLOPEL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SLOPEH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['SURFTEX'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['OTHERPH'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['COMPKIND'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['COMPACRE'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['CLASCODE'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['ANFLOOD'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['ANFLODUR'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['ANFLOBEG'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['ANFLOEND'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['GSFLOOD'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['GSFLODUR'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['GSFLOBEG'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['GSFLOEND'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          comp_dbTable.FieldValues['WTDEPL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          comp_dbTable.FieldValues['WTDEPH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['WTKIND'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['WTBEG'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['WTEND'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          comp_dbTable.FieldValues['PNDDEPL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          comp_dbTable.FieldValues['PNDDEPH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['PNDDUR'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['PNDBEG'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['PNDEND'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['ROCKDEPL'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['ROCKDEPH'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['ROCKHARD'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['PANDEPL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['PANDEPH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['PANHARD'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SUBINITL'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SUBINITH'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SUBTOTL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          comp_dbTable.FieldValues['SUBTOTH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['HYDGRP'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['FROSTACT'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['DRAINAGE'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['HYDRIC'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['CORCON'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['CORSTEEL'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['CLNIRR'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['CLIRR'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['SCLNIRR'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          comp_dbTable.FieldValues['SCLIRR'] := temp2;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          comp_dbTable.Post;
        end;
        comp_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        comp_dbTable.AddIndex('', 'MUID;SEQNUMS', [ixPrimary]);

      end; {COMP}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'compyld') then begin
{Make a database table       compyld}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('compyld');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making compyld Table  (2 of 15)';
        compyld_dbTable := TTable.Create(Transformer);
        with compyld_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'CROPNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 30;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=31;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'NIRRYLD';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=7;   8.1}
            end;
            with AddFieldDef do begin
              Name := 'IRRYLD';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=7;   8.1}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        compyld_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          compyld_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30002);
          compyld_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          compyld_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          compyld_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          compyld_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          compyld_dbTable.FieldValues['CROPNAME'] := temp2;
            {Second item}
          compyld_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          compyld_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
            {First item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          compyld_dbTable.FieldValues['NIRRYLD'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          compyld_dbTable.FieldValues['IRRYLD'] := ShapeAttributeN3;

{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          compyld_dbTable.Post;
        end;
        compyld_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        compyld_dbTable.AddIndex('', 'MUID;SEQNUMS;CROPNAME',
          [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'forest') then begin
{Make a database table       forest}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('forest');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making forest Table (3 of 15)';
        forest_dbTable := TTable.Create(Transformer);
        with forest_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'PLANTSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=31;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'PLANTCOV';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=7;   3}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        forest_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          forest_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          forest_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          forest_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          forest_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          forest_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          forest_dbTable.FieldValues['PLANTSYM'] := temp2;
            {Second item}
          forest_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          forest_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          forest_dbTable.FieldValues['PLANTCOV'] := ShapeI;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          forest_dbTable.Post;
        end;
        forest_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        forest_dbTable.AddIndex('', 'MUID;SEQNUMS;PLANTSYM',
          [ixPrimary]);

      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'interp') then begin
{Make a database table       interp}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('interp');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making interp Table (4 of 15)';
        interp_dbTable := TTable.Create(Transformer);
        with interp_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'GRPCODE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=31;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'RATING';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'RESTCT1';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'RESTCT2';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'RESTCT3';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        interp_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          interp_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          interp_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          interp_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          interp_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          interp_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          interp_dbTable.FieldValues['GRPCODE'] := temp2;
            {Second item}
          interp_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          interp_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          interp_dbTable.FieldValues['RATING'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          interp_dbTable.FieldValues['RESTCT1'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          interp_dbTable.FieldValues['RESTCT2'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          interp_dbTable.FieldValues['RESTCT3'] := temp2;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          interp_dbTable.Post;
        end;
        interp_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        interp_dbTable.AddIndex('', 'MUID;SEQNUMS;GRPCODE',
          [ixPrimary]);

      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'layer') then begin
{Make a database table       layer}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('layer');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption := 'Making layer Table (5 of 15)';
        layer_dbTable := TTable.Create(Transformer);
        with layer_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'LAYERNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=31;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'S5ID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 6;
            end;
            with AddFieldDef do begin
              Name := 'LAYERNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  1}
            end;
            with AddFieldDef do begin
              Name := 'LAYERID';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  1}
            end;
            with AddFieldDef do begin
              Name := 'LAYDEPL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  1}
            end;
            with AddFieldDef do begin
              Name := 'LAYDEPH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  1}
            end;
            with AddFieldDef do begin
              Name := 'TEXTURE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'KFACT';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=8;  4.2}
            end;
            with AddFieldDef do begin
              Name := 'KFFACT';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=8;  4.2}
            end;
            with AddFieldDef do begin
              Name := 'TFACT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'WEG';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'INCH10L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'INCH10H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'INCH3L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'INCH3H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'NO4L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO4H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO10L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO10H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO40L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO40H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO200L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'NO200H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'CLAYL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'CLAYH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  2}
            end;
            with AddFieldDef do begin
              Name := 'LLL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'LLH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'PIL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'PIH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=2;  3}
            end;
            with AddFieldDef do begin
              Name := 'UNIFIED';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'AASHTO';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'AASHIND';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.1}
            end;
            with AddFieldDef do begin
              Name := 'AWCL';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.2}
            end;
            with AddFieldDef do begin
              Name := 'AWCH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.2}
            end;
            with AddFieldDef do begin
              Name := 'BDL';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.2}
            end;
            with AddFieldDef do begin
              Name := 'BDH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.2}
            end;
            with AddFieldDef do begin
              Name := 'OML';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.1}
            end;
            with AddFieldDef do begin
              Name := 'OMH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.1}
            end;
            with AddFieldDef do begin
              Name := 'PHL';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.1}
            end;
            with AddFieldDef do begin
              Name := 'PHH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 4.1}
            end;
            with AddFieldDef do begin
              Name := 'SALINL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'SALINH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'SARL';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.1}
            end;
            with AddFieldDef do begin
              Name := 'SARH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.1}
            end;
            with AddFieldDef do begin
              Name := 'CECL';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.1}
            end;
            with AddFieldDef do begin
              Name := 'CECH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.1}
            end;
            with AddFieldDef do begin
              Name := 'CACO3L';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'CACO3H';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'GYPSUML';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'GYPSUMH';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
            with AddFieldDef do begin
              Name := 'PERML';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.2}
            end;
            with AddFieldDef do begin
              Name := 'PERMH';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=5; 5.2}
            end;
            with AddFieldDef do begin
              Name := 'SHRINKSW';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 10;
            end;
            with AddFieldDef do begin
              Name := 'WEI';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=5; 2}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        layer_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          layer_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          layer_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          layer_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          S5IDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);

          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          layer_dbTable.FieldValues['MUID'] := MUIDtemp; {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          layer_dbTable.FieldValues['LAYERNUMS'] := temp2;
          layer_dbTable.FieldValues['SEQNUM'] := ShapeI; {Second item}
          layer_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          layer_dbTable.FieldValues['S5ID'] := S5IDtemp;
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LAYERNUM'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LAYERID'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LAYDEPL'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LAYDEPH'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          layer_dbTable.FieldValues['TEXTURE'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['KFACT'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['KFFACT'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          layer_dbTable.FieldValues['TFACT'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          layer_dbTable.FieldValues['WEG'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['INCH10L'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['INCH10H'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['INCH3L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['INCH3H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO4L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO4H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO10L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO10H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO40L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO40H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO200L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['NO200H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['CLAYL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['CLAYH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LLL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['LLH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['PIL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['PIH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          layer_dbTable.FieldValues['UNIFIED'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          layer_dbTable.FieldValues['AASHTO'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['AASHIND'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['AWCL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['AWCH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['BDL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['BDH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['OML'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['OMH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['PHL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['PHH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['SALINL'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['SALINH'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['SARL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['SARH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['CECL'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['CECH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['CACO3L'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['CACO3H'] := ShapeI; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['GYPSUML'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['GYPSUMH'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['PERML'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          layer_dbTable.FieldValues['PERMH'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          layer_dbTable.FieldValues['SHRINKSW'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          layer_dbTable.FieldValues['WEI'] := ShapeI;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          layer_dbTable.Post;
        end;
        layer_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        layer_dbTable.AddIndex('', 'MUID;SEQNUMS;LAYERNUMS',
          [ixPrimary]);
      end; {LAYERNUM}

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'mapunit') then begin
{Make a database table       mapunit}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('mapunit');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making mapunit Table (6 of 15)';
        mapunit_dbTable := TTable.Create(Transformer);
        with mapunit_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'SSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'MUSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'MUNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 109;
            end;
            with AddFieldDef do begin
              Name := 'MUKIND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'MLRA';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 4;
            end;
            with AddFieldDef do begin
              Name := 'PRIMFML';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'MUACRES';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=31;  6}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        mapunit_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
         DoRezError( 30002);
          mapunit_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          mapunit_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          mapunit_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          COMPNAMEtemp := temp2; {SSAID Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUSYMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
          mapunit_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          mapunit_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
            {First item}
          mapunit_dbTable.FieldValues['SSAID'] := COMPNAMEtemp;
          mapunit_dbTable.FieldValues['MUSYM'] := MUSYMtemp;
            {Second item}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          mapunit_dbTable.FieldValues['MUNAME'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          mapunit_dbTable.FieldValues['MUKIND'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          mapunit_dbTable.FieldValues['MLRA'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          mapunit_dbTable.FieldValues['PRIMFML'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          mapunit_dbTable.FieldValues['MUACRES'] := ShapeI;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          mapunit_dbTable.Post;
        end;
        mapunit_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        mapunit_dbTable.AddIndex('', 'MUID', [ixPrimary]);
      end; {}

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'plantcom') then begin
{Make a database table       plantcom}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('plantcom');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making plantcom Table (7 of 15)';
        plantcom_dbTable := TTable.Create(Transformer);
        with plantcom_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'PLANTSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'PLANTPCT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        plantcom_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          plantcom_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          plantcom_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          plantcom_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          plantcom_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          if (ShapeI > 26) then ShapeI := 26 else
            if (ShapeI < 1) then ShapeI := 1;
          plantcom_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          plantcom_dbTable.FieldValues['PLANTSYM'] := temp2;
            {Second item}
          plantcom_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          plantcom_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          plantcom_dbTable.FieldValues['PLANTPCT'] := temp;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          plantcom_dbTable.Post;
        end;
        plantcom_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        plantcom_dbTable.AddIndex('', 'MUID;SEQNUMS;PLANTSYM',
          [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'plantnm') then begin
{Make a database table       plantnm}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('plantnm');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making plantnm Table (8 of 15)';
        plantnm_dbTable := TTable.Create(Transformer);
        with plantnm_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'PLANTSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SCINAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 60;
            end;
            with AddFieldDef do begin
              Name := 'COMNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 31;
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        plantnm_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          plantnm_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else begin
          DoRezError( 30004);
          plantnm_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 20)) do begin
          Application.ProcessMessages;
          plantnm_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          plantnm_dbTable.FieldValues['PLANTSYM'] := temp2;
            {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          plantnm_dbTable.FieldValues['SCINAME'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          plantnm_dbTable.FieldValues['COMNAME'] := temp2;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          plantnm_dbTable.Post;
        end;
        plantnm_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        plantnm_dbTable.AddIndex('', 'PLANTSYM;SCINAME;COMNAME',
          [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'rsprod') then begin
{Make a database table       rsprod}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('rsprod');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making rsprod Table (9 of 15)';
        rsprod_dbTable := TTable.Create(Transformer);
        with rsprod_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'RSID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'RSNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 51;
            end;
            with AddFieldDef do begin
              Name := 'PRODFAV';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  5}
            end;
            with AddFieldDef do begin
              Name := 'PRODNORM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  5}
            end;
            with AddFieldDef do begin
              Name := 'PRODUNFV';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  5}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        rsprod_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then begin
          DoRezError( 30002);
          rsprod_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else begin
          DoRezError( 30004);
          rsprod_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          rsprod_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          rsprod_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          rsprod_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          rsprod_dbTable.FieldValues['RSID'] := temp2; {Second item}
          rsprod_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          rsprod_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          rsprod_dbTable.FieldValues['RSNAME'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          rsprod_dbTable.FieldValues['PRODFAV'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          rsprod_dbTable.FieldValues['PRODNORM'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp, ShapeI, ErrorCodex);
          rsprod_dbTable.FieldValues['PRODUNFV'] := ShapeI;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          rsprod_dbTable.Post;
        end;
        rsprod_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        rsprod_dbTable.AddIndex('', 'MUID;SEQNUMS;RSID',
          [ixPrimary]);
      end; {}

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'taxclass') then begin
{Make a database table       taxclass}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('taxclass');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making taxclass Table (10 of 15)';
        taxclass_dbTable := TTable.Create(Transformer);
        with taxclass_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'CLASCODE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 30;
            end;
            with AddFieldDef do begin
              Name := 'CLASS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 120;
            end;
            with AddFieldDef do begin
              Name := 'ORDER';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'SUBORDER';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'GRTGROUP';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'SUBGROUP';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 4;
            end;
            with AddFieldDef do begin
              Name := 'PARTSIZE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'PARTSIZEMOD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'MINALOGY';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'MINALOGY2';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'CEC';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'REACTION';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SOILTEMP';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'OTHERFAM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        taxclass_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then begin
          DoRezError( 30002);
          taxclass_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else begin
          DoRezError( 30004);
          taxclass_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          taxclass_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
{        If (IChar > 20) then begin
          IChar :=7;
          If (InString[1]=' ') then begin
            temp2:=Copy(InString,1,IChar+1); end
            else temp2:=Copy(InString,1,IChar);
        end else}
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          taxclass_dbTable.FieldValues['CLASCODE'] := temp2;
            {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['CLASS'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['ORDER'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['SUBORDER'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['GRTGROUP'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['SUBGROUP'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['PARTSIZE'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['PARTSIZEMOD'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['MINALOGY'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['MINALOGY2'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['CEC'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['REACTION'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['SOILTEMP'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          taxclass_dbTable.FieldValues['OTHERFAM'] := temp2;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if (temp2[1] = LineEnder) then temp2[1] := ' ';
          InString := temp2;
          taxclass_dbTable.Post;
        end;
        taxclass_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        taxclass_dbTable.AddIndex('', 'CLASCODE;CLASS', [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'windbrk') then begin
{Make a database table       windbrk}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('windbrk');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making windbrk Table (11 of 15)';
        windbrk_dbTable := TTable.Create(Transformer);
        with windbrk_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'PLANTSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'WNDBRKHT';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  3}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        windbrk_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          windbrk_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else begin
          DoRezError( 30004);
          windbrk_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          windbrk_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          windbrk_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          windbrk_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          windbrk_dbTable.FieldValues['PLANTSYM'] := temp2;
            {Second item}
          windbrk_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          windbrk_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          windbrk_dbTable.FieldValues['WNDBRKHT'] := ShapeI;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          windbrk_dbTable.Post;
        end;
        windbrk_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        windbrk_dbTable.AddIndex('', 'MUID;SEQNUMS;PLANTSYM',
          [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'wlhabit') then begin
{Make a database table       wlhabit}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('wlhabit');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making wlhabit Table (12 of 15)';
        wlhabit_dbTable := TTable.Create(Transformer);
        with wlhabit_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'WLGRAIN';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLGRASS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLHERB';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLHARD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLCONIF';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLSHRUB';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLWETPLT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLSHLWAT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLOPEN';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLWOOD';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'WLWET';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'RLRANGE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        wlhabit_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          wlhabit_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          wlhabit_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          wlhabit_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          wlhabit_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          wlhabit_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          wlhabit_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          wlhabit_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['WLGRAIN'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['WLGRASS'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['WLHERB'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['WLHARD'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['WLCONIF'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['WLSHRUB'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['WLWETPLT'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['WLSHLWAT'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['WLOPEN'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['WLWOOD'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['WLWET'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          wlhabit_dbTable.FieldValues['RLRANGE'] := temp;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          wlhabit_dbTable.Post;
        end;
        wlhabit_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        wlhabit_dbTable.AddIndex('', 'MUID;SEQNUMS', [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'woodland') then begin
{Make a database table       woodland}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('woodland');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making woodland Table (13 of 15)';
        woodland_dbTable := TTable.Create(Transformer);
        with woodland_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'PLANTSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 7;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;

            with AddFieldDef do begin
              Name := 'SUITCODE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;

            with AddFieldDef do begin
              Name := 'SITIND';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  3}
            end;
            with AddFieldDef do begin
              Name := 'WOODPROD';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        woodland_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          woodland_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          woodland_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          woodland_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          S5IDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          woodland_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          woodland_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          woodland_dbTable.FieldValues['PLANTSYM'] := temp2;
            {Second item}
          woodland_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          woodland_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          woodland_dbTable.FieldValues['SUITCODE'] := S5IDtemp;
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          woodland_dbTable.FieldValues['SITIND'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp, ShapeI, ErrorCodex);
          woodland_dbTable.FieldValues['WOODPROD'] := ShapeI;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          woodland_dbTable.Post;
        end;
        woodland_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        woodland_dbTable.AddIndex('', 'MUID;SEQNUMS;PLANTSYM',
          [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'woodmgt') then begin
{Make a database table       woodmgt}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('woodmgt');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making woodmgt Table (14 of 15)';
        woodmgt_dbTable := TTable.Create(Transformer);
        with woodmgt_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'ORDSYM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'WDEROSN';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'WDEQUIP';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'WDSEED';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'WDWIND';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'WDPLANT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        woodmgt_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          woodmgt_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          woodmgt_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          woodmgt_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          woodmgt_dbTable.FieldValues['MUID'] := MUIDtemp;
            {Second item}
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          woodmgt_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
            {First item}
          woodmgt_dbTable.FieldValues['SEQNUM'] := ShapeI;
            {Second item}
          woodmgt_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          woodmgt_dbTable.FieldValues['ORDSYM'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          woodmgt_dbTable.FieldValues['WDEROSN'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          woodmgt_dbTable.FieldValues['WDEQUIP'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          woodmgt_dbTable.FieldValues['WDSEED'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          woodmgt_dbTable.FieldValues['WDWIND'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          woodmgt_dbTable.FieldValues['WDPLANT'] := temp2;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          woodmgt_dbTable.Post;
        end;
        woodmgt_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        woodmgt_dbTable.AddIndex('', 'MUID;SEQNUMS', [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'yldunits') then begin
{Make a database table       yldunits}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('yldunits');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making yldunits Table (15 of 15)';
        yldunits_dbTable := TTable.Create(Transformer);
        with yldunits_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'CROPNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 31;
            end;
            with AddFieldDef do begin
              Name := 'YLDUNITS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        yldunits_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          yldunits_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          yldunits_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          yldunits_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          yldunits_dbTable.FieldValues['CROPNAME'] := temp2;
            {First item}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          yldunits_dbTable.FieldValues['YLDUNITS'] := temp2;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          yldunits_dbTable.Post;
        end;
        yldunits_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        yldunits_dbTable.AddIndex('', 'CROPNAME;YLDUNITS',
          [ixPrimary]);
      end;



{REALLY JUST SSURGO NOW}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'helclass') then begin
{Make a database table       helclass}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('helclass');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making helclass Table (SSURGO 1 of 9)';
        helclass_dbTable := TTable.Create(Transformer);
        with helclass_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'HELCFACT';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  3}
            end;
            with AddFieldDef do begin
              Name := 'HELRFACT';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
       { Size:=7;  3}
            end;
            with AddFieldDef do begin
              Name := 'MUWNDHEL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
       { Size:=7;  1}
            end;
            with AddFieldDef do begin
              Name := 'MUWATHEL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
       { Size:=7;  1}
            end;
            with AddFieldDef do begin
              Name := 'MUHELCL';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
       { Size:=7;  1}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        helclass_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          helclass_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          helclass_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          helclass_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          helclass_dbTable.FieldValues['MUID'] := MUIDtemp;
{                Val(SEQNUMtemp,ShapeI,ErrorCodex);
       helclass_dbTable.FieldValues['SEQNUMS'] :=SEQNUMtemp;
        helclass_dbTable.FieldValues['SEQNUM'] :=ShapeI;}
          helclass_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          helclass_dbTable.FieldValues['HELCFACT'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          helclass_dbTable.FieldValues['HELRFACT'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          helclass_dbTable.FieldValues['MUWNDHEL'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          helclass_dbTable.FieldValues['MUWATHEL'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          helclass_dbTable.FieldValues['MUHELCL'] := ShapeI;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          helclass_dbTable.Post;
        end;
        helclass_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        helclass_dbTable.AddIndex('', 'MUID', [ixPrimary]);
{helclass_dbTable.AddIndex('','MUID;SEQNUMS',[ixPrimary]);}
      end; {woodland_dbTable.AddIndex('','MUID;SEQNUMS;PLANTSYM',[ixPrimary]);
}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'inclusn') then begin
{Make a database table       inclusn}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('inclusn');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making inclusn Table (SSURGO 2 of 9)';
        inclusn_dbTable := TTable.Create(Transformer);
        with inclusn_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'INCLSOIL';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 35;
            end;
            with AddFieldDef do begin
              Name := 'INCLPCT';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'HYDRIC';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'LANDFMLO';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'CONDITION';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'HYDCRIT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 20;
            end;
            with AddFieldDef do begin
              Name := 'ONSITE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        inclusn_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          inclusn_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          inclusn_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          inclusn_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          inclusn_dbTable.FieldValues['MUID'] := MUIDtemp;
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          inclusn_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
          inclusn_dbTable.FieldValues['SEQNUM'] := ShapeI;
          inclusn_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          inclusn_dbTable.FieldValues['INCLSOIL'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          inclusn_dbTable.FieldValues['INCLPCT'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          inclusn_dbTable.FieldValues['HYDRIC'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          inclusn_dbTable.FieldValues['LANDFMLO'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          inclusn_dbTable.FieldValues['CONDITION'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          inclusn_dbTable.FieldValues['HYDCRIT'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          inclusn_dbTable.FieldValues['ONSITE'] := temp;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          inclusn_dbTable.Post;
        end;
        inclusn_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        inclusn_dbTable.AddIndex('', 'MUID;SEQNUMS', [ixPrimary]);
      end; {}

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'mucoacre') then begin
{Make a database table       mucoacre}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('mucoacre');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making mucoacre Table (SSURGO 3 of 9)';
        mucoacre_dbTable := TTable.Create(Transformer);
        with mucoacre_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'CNTYCODE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'MUCOACRE';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=3;  6}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        mucoacre_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          mucoacre_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          mucoacre_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          mucoacre_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          mucoacre_dbTable.FieldValues['MUID'] := MUIDtemp;
          mucoacre_dbTable.FieldValues['CNTYCODE'] := temp2;
            {Second item}
{IChar :=IChar2;}{for more than ... then dupe second}
          mucoacre_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          mucoacre_dbTable.FieldValues['MUCOACRE'] := ShapeI;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          mucoacre_dbTable.Post;
        end;
        mucoacre_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        mucoacre_dbTable.AddIndex('', 'MUID;CNTYCODE', [ixPrimary]);
      end; {inclusn_dbTable.AddIndex('','MUID;SEQNUMS',[ixPrimary]);}

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'muyld') then begin
{Make a database table       muyld}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('muyld');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making muyld Table (SSURGO 4 of 9)';
        muyld_dbTable := TTable.Create(Transformer);
        with muyld_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'CROPNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 30;
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'NIRRYLD';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=109;  4.2}
            end;
            with AddFieldDef do begin
              Name := 'IRRYLD';
              DataType := ftfloat;
                {ftInteger ftString Required := True;}
        {Size:=3; 4.2}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        muyld_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          muyld_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          muyld_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          muyld_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          muyld_dbTable.FieldValues['MUID'] := MUIDtemp;
          muyld_dbTable.FieldValues['CROPNAME'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}
          muyld_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeAttributeN3, ErrorCodex);
          muyld_dbTable.FieldValues['NIRRYLD'] := ShapeAttributeN3;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '0.0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp, ShapeAttributeN3, ErrorCodex);
          muyld_dbTable.FieldValues['IRRYLD'] := ShapeAttributeN3;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          muyld_dbTable.Post;
        end;
        muyld_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        muyld_dbTable.AddIndex('', 'MUID;CROPNAME', [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'rangenm') then begin
{Make a database table       rangenm}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('rangenm');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making rangenm Table (SSURGO 5 of 9)';
        rangenm_dbTable := TTable.Create(Transformer);
        with rangenm_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'RSID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 10;
            end;
            with AddFieldDef do begin
              Name := 'RSNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 100;
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        rangenm_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          rangenm_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          rangenm_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          rangenm_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          rangenm_dbTable.FieldValues['RSID'] := temp2; {First item}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          rangenm_dbTable.FieldValues['RSNAME'] := temp;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          rangenm_dbTable.Post;
        end;
        rangenm_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        rangenm_dbTable.AddIndex('', 'RSID', [ixPrimary]);
      end; {muyld_dbTable.AddIndex('','MUID;CNTYCODE',[ixPrimary]);}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'ssacoac') then begin
{Make a database table       ssacoac}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('ssacoac');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making ssacoac Table (SSURGO 6 of 9)';
        ssacoac_dbTable := TTable.Create(Transformer);
        with ssacoac_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'CNTYCODE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'CNTYNAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 30;
            end;
            with AddFieldDef do begin
              Name := 'SSACOAC';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  8}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        ssacoac_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          ssacoac_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          ssacoac_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          ssacoac_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          ssacoac_dbTable.FieldValues['STSSAID'] := temp2;
            {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          ssacoac_dbTable.FieldValues['CNTYCODE'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          ssacoac_dbTable.FieldValues['CNTYNAME'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp, ShapeI, ErrorCodex);
          ssacoac_dbTable.FieldValues['SSACOAC'] := ShapeI;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          ssacoac_dbTable.Post;
        end;
        ssacoac_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        ssacoac_dbTable.AddIndex('', 'STSSAID;CNTYCODE',
          [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'ssarea') then begin
{Make a database table       ssarea}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('ssarea');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making ssarea Table (SSURGO 7 of 9)';
        ssarea_dbTable := TTable.Create(Transformer);
        with ssarea_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'STATE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'SSANUM';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'SSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 3;
            end;
            with AddFieldDef do begin
              Name := 'SSANAME';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 135;
            end;
            with AddFieldDef do begin
              Name := 'SSAACRES';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  8}
            end;
            with AddFieldDef do begin
              Name := 'CORDATE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'STATUS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'EDSTAT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'EDDATE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 8;
            end;
            with AddFieldDef do begin
              Name := 'COMMENT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 100;
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        ssarea_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          ssarea_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          ssarea_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 30)) do begin
          Application.ProcessMessages;
          ssarea_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          MUIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          ssarea_dbTable.FieldValues['STSSAID'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}
{        If (STSSAIDtemp='0') then STSSAIDtemp:=(MUIDtemp+SEQNUMtemp);}
          ssarea_dbTable.FieldValues['STATE'] := MUIDtemp;
{                Val(SEQNUMtemp,ShapeI,ErrorCodex);
        ssarea_dbTable.FieldValues['SEQNUM'] :=ShapeI;
        ssarea_dbTable.FieldValues['STSSAID'] :=STSSAIDtemp;
        }
          ssarea_dbTable.FieldValues['SSANUM'] := SEQNUMtemp;



          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          ssarea_dbTable.FieldValues['SSAID'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          ssarea_dbTable.FieldValues['SSANAME'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          ssarea_dbTable.FieldValues['SSAACRES'] := ShapeI;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          ssarea_dbTable.FieldValues['CORDATE'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          ssarea_dbTable.FieldValues['STATUS'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          ssarea_dbTable.FieldValues['EDSTAT'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}


          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          ssarea_dbTable.FieldValues['EDDATE'] := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          ssarea_dbTable.FieldValues['COMMENT'] := temp;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          ssarea_dbTable.Post;
        end;
        ssarea_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        ssarea_dbTable.AddIndex('', 'STSSAID', [ixPrimary]);
      end; {}
{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'hydcomp') then begin
{Make a database table       hydcomp}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('hydcomp');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making hydcomp Table (SSURGO 8 of 9)';
        hydcomp_dbTable := TTable.Create(Transformer);
        with hydcomp_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUMS';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'SEQNUM';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'CONDITION';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
            with AddFieldDef do begin
              Name := 'LANDFMLO';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 2;
            end;
            with AddFieldDef do begin
              Name := 'HYDCRIT';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 20;
            end;
            with AddFieldDef do begin
              Name := 'ONSITE';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 1;
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        hydcomp_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          hydcomp_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          hydcomp_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          hydcomp_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          STSSAIDtemp := temp2; {First item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          MUIDtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          SEQNUMtemp := temp2; {Second item}
          IChar := IChar2; {for more than ... then dupe second}
          if (STSSAIDtemp = '0') then
            STSSAIDtemp := (MUIDtemp + SEQNUMtemp);
          hydcomp_dbTable.FieldValues['MUID'] := MUIDtemp;
          hydcomp_dbTable.FieldValues['SEQNUMS'] := SEQNUMtemp;
          Val(SEQNUMtemp, ShapeI, ErrorCodex);
          hydcomp_dbTable.FieldValues['SEQNUM'] := ShapeI;
          hydcomp_dbTable.FieldValues['STSSAID'] := STSSAIDtemp;



          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          hydcomp_dbTable.FieldValues['CONDITION'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          hydcomp_dbTable.FieldValues['LANDFMLO'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          hydcomp_dbTable.FieldValues['HYDCRIT'] := temp2;
            {Second item}
          IChar := IChar2; {for more than ... then dupe second}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          hydcomp_dbTable.FieldValues['ONSITE'] := temp2;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if temp2[1] = LineEnder then temp2[1] := ' ';
          InString := temp2;
          hydcomp_dbTable.Post;
        end;
        hydcomp_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        hydcomp_dbTable.AddIndex('', 'MUID;SEQNUMS', [ixPrimary]);
      end; {}

{--------------------------------------------------------}
      if FileExists(StateDataSPath + 'muident') then
      begin
{Make a database table       muident}
{   temp:=StateShapeSName+'_1';}{rename for each db created}
        temp := ('muident');
        StateDataSName := StateDataSPath + temp;
          {rename for each data source}
        StateShapeSName := StateShapeSPath + temp;
        Transformer.THints.Caption :=
          'Making muident Table (SSURGO 9 of 9)';
        muident_dbTable := TTable.Create(Transformer);
        with muident_dbTable do begin
          Active := False;
          DatabaseName := 'statsgo' + IntToStr(MyPDbCount);
          TableType := ttParadox;
          TableName := StateShapeSName + '.db';
          with FieldDefs do begin
            Clear;
            with AddFieldDef do begin
              Name := 'STSSAID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 5;
            end;
            with AddFieldDef do begin
              Name := 'MUID';
              DataType := ftString;
                {ftInteger ftString Required := True;}
              Size := 9;
            end;
            with AddFieldDef do begin
              Name := 'MUIID';
              DataType := ftInteger;
                {ftInteger ftString Required := True;}
        {Size:=109;  2}
            end;
          end; {Fielddefs}
          CreateTable;
        end;

        muident_dbTable.Active := True;
        AssignFile(F1, StateDataSName);
        Reset(F1);
        LineEnder10 := False;
        LineEnder13 := False;
        for iLineEnder := 1 to 1234 do begin Read(F1, Ch);
          if (ord(Ch) = 10) then LineEnder10 := True;
          if (ord(Ch) = 13) then LineEnder13 := True; end;
        if (LineEnder10 and LineEnder13) then
        begin
          DoRezError( 30002);
          muident_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end else if (LineEnder10) then begin
          Reset(F1);
          Readln(F1, InString);
          LineEnder := #10;
        end else if (LineEnder13) then begin
          Reset(F1);
          Readln(F1, InString);
     {For ISur:= 1 to Length(InString) do
         If (InString[ISur]=#13) then InString[ISur]:=#10;
     LineEnder:=#10;} LineEnder := #13;
        end else
        begin
          DoRezError( 30004);
          muident_dbTable.Active := False;
          CloseFile(F1);
          Session.DropConnections;
          Session.Active := False;
          MyPDBCount := 0;
          Screen.Cursor := crDefault;
          Exit;
        end;

   {get past header}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 1}
        IChar := Pos(LineEnder, InString);
        temp2 := Copy(InString, IChar + 1, length(InString));
        InString := temp2; {Skip 2}
        while ((length(InString) > 10)) do begin
          Application.ProcessMessages;
          muident_dbTable.Append;
          IChar := Pos(#9, InString);
          if (IChar = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar - 1);
          trimleft(temp2); {cheater from the end}
          muident_dbTable.FieldValues['STSSAID'] := temp2;
            {Second item}

          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          IChar2 := Pos(#9, temp2);
          if (IChar2 = 1) then temp2 := '.' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          muident_dbTable.FieldValues['MUID'] := temp2; {Second item}

{LAST ONE is DIFFERENT}
          temp2 := Copy(InString, IChar + 1, length(InString));
          InString := temp2;
          if ((Pos(LineEnder, temp2)) < (Pos(#9, temp2))) then
          begin IChar2 := Pos(LineEnder, temp2); {EndSkipper :=true;}
            end
          else
            begin IChar2 := Pos(#9, temp2); { EndSkipper :=false;} end;
          if (IChar2 = 1) then temp2 := '0' else
            temp2 := Copy(InString, 1, IChar2 - 1);
          Val(temp2, ShapeI, ErrorCodex);
          muident_dbTable.FieldValues['MUIID'] := ShapeI;
{REPLACE InString for next round}
          IChar := IChar2;
          temp2 := Copy(InString, IChar + 1, length(InString));
          if (length(temp2) > 0) then begin
            if temp2[1] = LineEnder then temp2[1] := ' '; end;
          InString := temp2;
          muident_dbTable.Post;
        end;
        muident_dbTable.Active := False;
        CloseFile(F1);
{--------------------------------------------------------}
        muident_dbTable.AddIndex('', 'STSSAID;MUID', [ixPrimary]);
      end; {}
    end; {making SSURGO}
{--------------------------------------------------------}
{--------------------------------------------------------}
{--------------------------------------------------------}
{--------------------------------------------------------}
{--------------------------------------------------------}

    Transformer.THints.Caption := 'Finished Making Tables';
{--------------------------------------------------------}

{If (bcomp_dbTable=true) then comp_dbTable.AddIndex('','MUID;SEQNUMS',[ixPrimary]);}
{ Name := '';Fields := 'MUID;SEQNUMS';Options := [ixPrimary];}
{comp_dbTable, compyld_dbTable, forest_dbTable, interp_dbTable,
layer_dbTable, plantcom_dbTable, plantnm_dbTable,
rsprod_dbTable, taxclass_dbTable, windbrk_dbTable, wlhabit_dbTable,
woodland_dbTable, woodmgt_dbTable, yldunits_dbTable,
mapunit_dbTable, state_dbTable,
helclass_dbTable, inclusn_dbTable, mucoacre_dbTable, muyld_dbTable,
rangenm_dbTable, ssacoac_dbTable, ssarea_dbTable,
hydcomp_dbTable, muident_dbTable}
{--------------------------------------------------------}
{End of all database }
{Inc(MyPDbCount);    }
 {DELETE the database!!! REDUCE the MyDBCount or ELSE!!!}
{ Session.DropConnections;
 Session.Active:=False;
 MyPDBCount:=0;}
  end else
    DoRezError( 30003);

  Screen.Cursor := crDefault; {crDefault}
end;
(******************************************************************)
(******************************************************************)

end.
